import java.util.*;
import java.io.*;

public class EconomicOperation extends Operation implements Cloneable, Serializable
{

	public EconomicOperation(Player playe, Player targetPlaye, Planet targetPlane)
	{
		player = playe;
		targetPlayer = targetPlaye;
		targetPlanet = targetPlane;

		name = "Economic Operation";
		cost = 4;
		defensive = false;
		type = 2;
	}

	// Determine if operation succeeds or fails, make any changes to the map that are required.
	// Operations will always be performed sequentially, NOT CONCURRENTLY.
	// Adds messages as necessary to indicate the success of the operation.

	public void performOperation(Map currentMap, Vector messages, Vector defensiveOperations, Vector<PaxGenericAI> aiPlayers)
	{
		Random r = new Random();
		r.nextInt(100);

		// indicates whether to report operation to the target based on defensive op.
		boolean report = CheckReport(defensiveOperations);
		// check the success of the operation
		boolean success = CheckSuccess(defensiveOperations);

		int effect = 5; // the numerical effect of the operation.


		if (success)
		{
			StringBuffer results = new StringBuffer("");

			// Determine effect here.

			/*
			Empire empire = targetPlayer.getEmpire();

			if (effect > empire.getMoney())
			{
				effect = empire.getMoney();
			}*/

			int treasury = 0;

			for (int i = 0; i < currentMap.getPlayers().size(); i++)
			{
				Player p = (Player) currentMap.getPlayers().elementAt(i);

				if (p.getName().equals(targetPlayer.getName()))
				{
					if (p.getEmpire().getMoney() < effect)
					{
						effect = p.getEmpire().getMoney();
					}
					p.getEmpire().setMoney(p.getEmpire().getMoney() - effect);
					treasury = p.getEmpire().getMoney();
				}
			}

			for (int i = 0; i < currentMap.getPlayers().size(); i++)
			{
				Player p = (Player) currentMap.getPlayers().elementAt(i);

				if (p.getName().equals(player.getName()))
				{
					p.getEmpire().setMoney(p.getEmpire().getMoney() + effect);
				}
			}

			results.append("Your spies have infiltrated " + targetPlanet + ", a planet belonging to " + targetPlayer.getName() + ", and stolen " + effect + " money from their treasury! " + targetPlayer.getName() +"'s treasury now contains " + treasury + " money!\n\n");

			Message message = new Message(results.toString(), false);
			message.addPlayer(player.getName());

			messages.addElement(message);

			if (report)
			{
				StringBuffer results2 = new StringBuffer("");

				results2.append(player.getName() + "'s spies have infiltrated " + targetPlanet + " and stolen " + effect + " money from your treasury!\n\n");

				Message message2 = new Message(results2.toString(), false);
				message2.addPlayer(targetPlayer.getName());

				messages.addElement(message2);

				// Update the AI's aggression level.
				for (int i = 0; i < aiPlayers.size(); i++)
				{
					PaxGenericAI aiPlayer = aiPlayers.elementAt(i);

					if (aiPlayer.player.getName().equals(targetPlayer.getName()))
					{
						aiPlayer.intelligenceFile.updateAggression(player.getName(), 0.4);
						break;
					}
				}
			}
			else
			{
				StringBuffer results2 = new StringBuffer("");

				results2.append("Foreign spies have infiltrated " + targetPlanet + " and stolen " + effect + " money from your treasury!\n\n");

				Message message2 = new Message(results2.toString(), false);
				message2.addPlayer(targetPlayer.getName());

				messages.addElement(message2);
			}
		}
		else
		{
			FailureMessage(messages, report, aiPlayers);
		}
	}

}
