import java.util.*;
import java.io.*;

public class Location implements Serializable
{
	private int positionX;
	private int positionY;
	private boolean valid;
	private Vector units;
	private Vector planets;
	private int groundUnitCount;
	private int spaceUnitCount;

	// Indicates whether this space is part of the asteroid belt.  All asteroid squares are considered
	// to be part of the same location, even though their coordinates might indicate differently.
	private boolean asteroids;

	public Location(int x, int y, boolean vali) //, boolean asteroid)
	{
		positionX = x;
		positionY = y;
		valid = vali;
		asteroids = false; // asteroid;

		units = new Vector();
		planets = new Vector();
	}

	public void addUnit(Unit u)
	{
		units.addElement(u);
	}

	public void removeUnit(Unit u)
	{
		units.removeElement(u);
	}

	public void addPlanet(Planet p)
	{
		planets.addElement(p);
	}

	public Vector getUnits()
	{
		return units;
	}

	public void setGroundUnitCount(int groundUnit)
	{
		groundUnitCount = groundUnit;
	}

	public int getGroundUnitCount()
	{
		return groundUnitCount;
	}

	public void setSpaceUnitCount(int spaceUnit)
	{
		spaceUnitCount = spaceUnit;
	}

	public int getSpaceUnitCount()
	{
		return spaceUnitCount;
	}

	public boolean getValid()
	{
		return valid;
	}

	public void setValid(boolean v)
	{
	    valid = v;
	}

	public boolean getAsteroids()
	{
		return asteroids;
	}

	public void setAsteroids(boolean b)
	{
		asteroids = b;
	}

	public int getPositionX()
	{
		return positionX;
	}

	public int getPositionY()
	{
		return positionY;
	}

	public Vector getPlanets()
	{
		return planets;
	}

	public String toString()
	{
		String result = "("+positionX+", "+positionY+")";

		if (getPlanets().size() > 0)
		{
			result += " - " + getPlanets().elementAt(0);
		}

		return result;
	}

}

