import java.util.*;
import java.io.*;

public class Message implements Serializable
{
	// Represents a message sent to a certain number of players.
	// Messages are displayed at the end of each phase.
 
	// The string represents the message itself.
	private String message;

	// This boolean indicates if the message should be sent to all players.
	private boolean all;

	// This vector contains a list of player names that should receive the message.
	private Vector players;

	public Message(String messag, boolean al)
	{
		message = messag;
		all = al;

		players = new Vector();
	}

	// Returns the message as a string.
	public String toString()
	{
		return message;
	}

	// Checks if the player in question has permission to receive the message.
	public boolean hasPermission(String name)
	{
		// If message is public, all have permission.
		boolean result = all;

		for (int i = 0; i < players.size(); i++)
		{
			String player = (String) players.elementAt(i);

			if (player.equals(name))
			{
				result = true;
			}
		}

		return result;
	}

	// Adds a player to the list of people who can view this message.
	public void addPlayer(String name)
	{
		players.addElement(name);
	}


}

