import java.io.*;
import java.util.*;

//The unchecked warnings come from any method which takes any Vector
@SuppressWarnings("unchecked")


public class PaxAIThread implements Runnable
{
	Vector<PaxGenericAI> aiPlayers;
	Vector<Player> otherPlayers;
	int phase;
	PrintStream ps;

	public PaxAIThread(Vector<PaxGenericAI> ais, int currentPhase, Map map, PrintStream outStream)
	{
		aiPlayers = ais;
		phase = currentPhase;
		ps = outStream;

		otherPlayers = new Vector<Player>();

		if (phase == 2)
		{
			for (int i = 0; i < map.getPlayers().size(); i++)
			{
				Player player = (Player) map.getPlayers().elementAt(i);

				otherPlayers.addElement(player.clone());
			}
		}
	}

	public void run()
	{
		try
		{
			Thread.sleep(500);
		}
		catch (Exception f)
		{
			f.printStackTrace();
		}

		for (int i = 0; i < aiPlayers.size(); i++)
		{
			try
			{
				if (phase == 2)
				{
					aiPlayers.elementAt(i).runMovement(otherPlayers, ps);
				}
				else if (phase == 5)
				{
					aiPlayers.elementAt(i).runImprovementProduction(ps);
				}
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
	}
}