import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.plaf.ColorUIResource;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import javax.swing.JPanel.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;

// Name: Jeremy Long
// Student Number: 587 702
// NSID: jsl847
// CMPT436, Project

public class PaxClient
{

	private Socket connection; // the Socket connection created with the server.
	private ObjectOutputStream sendstream; // the stream used for sending objects to the server.
	private ObjectInputStream receivestream; // the stream which receives objects sent by the server.

	private JFrame main;
	private JLabel empire;
	private JLabel income;
	private JLabel tech;
	private JLabel resTurn;
	private JLabel espionage;
	private JLabel counterEspionage;
	private JLabel maintenance;
	private JLabel money;
	private JLabel food;
	private JLabel minerals;
	private JLabel gas;

	private JLabel planet1;
	private JLabel planetEco1;
	private JLabel planetInd1;
	private JLabel planetRes1;
	private JLabel planet2;
	private JLabel planetEco2;
	private JLabel planetInd2;
	private JLabel planetRes2;
	private JLabel planet3;
	private JLabel planetEco3;
	private JLabel planetInd3;
	private JLabel planetRes3;
	private JLabel planet4;
	private JLabel planetEco4;
	private JLabel planetInd4;
	private JLabel planetRes4;
	private JLabel planet5;
	private JLabel planetEco5;
    	private JLabel planetInd5;
	private JLabel planetRes5;
	private JLabel planet6;
	private JLabel planetEco6;
    	private JLabel planetInd6;
	private JLabel planetRes6;
	private JLabel planet7;
	private JLabel planetEco7;
    	private JLabel planetInd7;
	private JLabel planetRes7;
	private JLabel planet8;
	private JLabel planetEco8;
    	private JLabel planetInd8;
	private JLabel planetRes8;
	private JLabel planet9;
	private JLabel planetEco9;
    	private JLabel planetInd9;
	private JLabel planetRes9;

	private Vector spaceLabels;
	private Vector spaceNames;
	private Vector spaceButtons;
	private Vector spaceLocations;
	private Vector spaceLists;
	private JButton newSpaceUnit;

	private JList currentUnitList;
	private JList currentGroundList;

	private Vector groundLabels;
	private Vector groundNames;
	private Vector groundButtons;
	private Vector groundLocations;
	private Vector groundLists;
	private JButton newGroundUnit;

	private JLabel turnLabel;

	private JButton mapOn;
	private JButton done;
	private JButton drop;
	private JButton frameOn;
	private JButton transferSpace;
	private JButton transferGround;
	private JButton disbandSpace;
	private JButton disbandGround;

	// Improvement execute button.
	private JButton execute;
	// The Production execute button.
	private JButton executeProduction;
	private boolean doneTurn = false;

	private boolean loop;
	private boolean addUnit;
	private boolean undo; // we undo the movement phase.
	private boolean dropped;
	private Vector messages;

	private static Player player;
	private static Map map;
	private MapCanvas mc;

	private JFrame paxMap;
	private JComboBox unitsBox;
	private JFrame frame;

	private JFrame transferFrame;
	private JFrame disbandFrame;
	private JFrame showFrame;

	private int max2;
	private int curFood;
	private int curMinerals;
	private int curGas;
	private int totalIncome;

	private Vector operations;

	private static Vector totalSpaceForces;
	private static Vector totalGroundForces;

	private static PaxServerInterface psi;

	// Market Phase stuff.
	private int oFood;
	private int oGas;
	private int oMinerals;
	private int oMoney;

	// The main method, where execution of the program begins.  It serves only to call the class constructor.

	public static void main(String[] args) throws Exception
	{
		PaxClient pc = new PaxClient();
	}

	public PaxClient()
	{
		production();
	}

	public PaxClient(Vector one, Vector two, PaxServerInterface pax)
	{
		totalSpaceForces = one;
		totalGroundForces = two;

		psi = pax;
	}


	public PaxClient(Player play, Map ma, boolean loo)
	{
	    	player = play;
		map = ma;
		loop = loo;

		map.clean();

		player.getEmpire().calculateVictoryPoints(map);

		addUnit = false;
		undo = false;
		dropped = false;

		messages = new Vector();

		final Color c = new Color(121);

		main = new JFrame(player + " - Pax Client");
		main.setSize(700, 700);
		main.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);//JFrame.EXIT_ON_CLOSE);
    		main.getContentPane().setLayout(new GridBagLayout());
		main.setResizable(false);

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 8;
    		gbc.insets.left = 8;
		gbc.insets.bottom = 8;
		gbc.insets.top = 8;

		gbc.gridy = 0;
		gbc.gridx = 0;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;

		gbc.fill = GridBagConstraints.HORIZONTAL;

		JLabel empireLabel = new JLabel("Empire Name: ");
		main.getContentPane().add(empireLabel, gbc);

		gbc.gridx = 1;

		empire = new JLabel(player.getEmpire().getName());
		main.getContentPane().add(empire, gbc);

		gbc.gridx = 2;

		JLabel incomeLabel = new JLabel("Total Income: ");
		main.getContentPane().add(incomeLabel, gbc);

		gbc.gridx = 3;

		income = new JLabel(""+player.getEmpire().getIncome());
		main.getContentPane().add(income, gbc);

		gbc.gridx = 0;
		gbc.gridy = 1;

		JLabel techLabel = new JLabel("Tech Level (5): ");
		main.getContentPane().add(techLabel, gbc);

		gbc.gridx = 1;

		tech = new JLabel(""+player.getEmpire().getTech());
		main.getContentPane().add(tech, gbc);

		gbc.gridx = 2;

		JLabel resTurnLabel = new JLabel("Resources/Turn: ");
		main.getContentPane().add(resTurnLabel, gbc);

		gbc.gridx = 3;

		resTurn = new JLabel(player.getEmpire().getFoodTurn()+" F/"+player.getEmpire().getMineralsTurn()+" M/"+player.getEmpire().getGasTurn()+" G");
		main.getContentPane().add(resTurn, gbc);

		gbc.gridy = 3;
		gbc.gridx = 2;

		JLabel espionageLabel = new JLabel("Espionage (5): ");
		main.getContentPane().add(espionageLabel, gbc);

		gbc.gridx = 3;

		espionage = new JLabel(""+player.getEmpire().getEspionage());
		main.getContentPane().add(espionage, gbc);

		gbc.gridy = 4;
		gbc.gridx = 2;

		JLabel counterEspionageLabel = new JLabel("Counter Espionage: ");
		main.getContentPane().add(counterEspionageLabel, gbc);

		gbc.gridx = 3;

		counterEspionage = new JLabel(""+player.getEmpire().getCounterEspionage());
		main.getContentPane().add(counterEspionage, gbc);

		gbc.gridy = 3;
		gbc.gridx = 0;

		gbc.gridwidth = 2;
		gbc.gridheight = 2;

		JPanel maintenancePanel = new JPanel();
		maintenancePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Maintenance: "));
		maintenance = new JLabel(""+player.getEmpire().getMaintenance());
		maintenance.setFont(new Font("Serif", 1, 24));
		maintenancePanel.add(maintenance);
		main.getContentPane().add(maintenancePanel, gbc);

		gbc.fill = GridBagConstraints.HORIZONTAL;

		gbc.gridheight = 2;
		gbc.gridy = 0;
		gbc.gridx = 4;
		gbc.gridwidth = 3;

		JPanel moneyPanel = new JPanel();
		moneyPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Money: "));
		money = new JLabel(""+player.getEmpire().getMoney());
		money.setFont(new Font("Dialog", 2, 24));
		money.setForeground(c.GREEN.darker());
		moneyPanel.add(money);
		main.getContentPane().add(moneyPanel, gbc);

		gbc.fill = GridBagConstraints.BOTH;

		gbc.gridx = 4;
		gbc.gridy = 3;
		gbc.gridwidth = 3;
		gbc.gridheight = 2;

		JPanel resourcePanel = new JPanel();
		resourcePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Resources: "));

		food = new JLabel(" Food: 0"+player.getEmpire().getFood());
		food.setFont(new Font("Dialog", 1, 14));
		food.setForeground(c.BLUE);
		resourcePanel.add(food);

		minerals = new JLabel(" Min: 0"+player.getEmpire().getMinerals());
		minerals.setFont(new Font("Dialog", 1, 14));
		minerals.setForeground(c.WHITE.darker().darker());
		resourcePanel.add(minerals);

		gas = new JLabel(" Gas: 0"+player.getEmpire().getGas()+ " ");
		gas.setFont(new Font("Dialog", 1, 14));
		gas.setForeground(c.RED);
		resourcePanel.add(gas);

		main.getContentPane().add(resourcePanel, gbc);

		gbc.fill = GridBagConstraints.NONE;

		gbc.gridy = 5;
		gbc.gridx = 0;
		gbc.gridwidth = 2;
		gbc.gridheight = 1;

		JLabel planetsLabel = new JLabel("Planets: ");
		main.getContentPane().add(planetsLabel, gbc);

		gbc.gridx = 2;
		gbc.gridwidth = 1;//2;

		JLabel spaceLabel = new JLabel("Space Units: ");
		main.getContentPane().add(spaceLabel, gbc);

		gbc.gridx = 3;

		disbandSpace = new JButton("Disband Force");
		disbandSpace.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				disband(player.getEmpire().getSpaceUnits(), true);
			}});
		main.getContentPane().add(disbandSpace, gbc);

		gbc.gridx = 4;
		gbc.gridwidth = 2;//3;

		JLabel groundLabel = new JLabel("Ground Units: ");
		main.getContentPane().add(groundLabel, gbc);

		gbc.gridx = 6;
		gbc.gridwidth = 1;

		disbandGround = new JButton("Disband Force");
		disbandGround.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				disband(player.getEmpire().getGroundUnits(), false);
			}});
		main.getContentPane().add(disbandGround, gbc);

		int gridy = 6;

		gbc.fill = GridBagConstraints.BOTH;

		Vector titles = new Vector();
		planet1 = new JLabel(" ");
		planet2 = new JLabel(" ");
		planet3 = new JLabel(" ");
		planet4 = new JLabel(" ");
		planet5 = new JLabel(" ");
		planet6 = new JLabel(" ");
		planet7 = new JLabel(" ");
		planet8 = new JLabel(" ");
		planet9 = new JLabel(" ");
		titles.addElement(planet1);
		titles.addElement(planet2);
		titles.addElement(planet3);
		titles.addElement(planet4);
		titles.addElement(planet5);
		titles.addElement(planet6);
		titles.addElement(planet7);
		titles.addElement(planet8);
		titles.addElement(planet9);
		Vector ecos = new Vector();
		planetEco1 = new JLabel(" ");
		planetEco2 = new JLabel(" ");
		planetEco3 = new JLabel(" ");
		planetEco4 = new JLabel(" ");
		planetEco5 = new JLabel(" ");
		planetEco6 = new JLabel(" ");
		planetEco7 = new JLabel(" ");
		planetEco8 = new JLabel(" ");
		planetEco9 = new JLabel(" ");
		ecos.addElement(planetEco1);
		ecos.addElement(planetEco2);
		ecos.addElement(planetEco3);
		ecos.addElement(planetEco4);
		ecos.addElement(planetEco5);
		ecos.addElement(planetEco6);
		ecos.addElement(planetEco7);
		ecos.addElement(planetEco8);
		ecos.addElement(planetEco9);
		Vector inds = new Vector();
		planetInd1 = new JLabel(" ");
		planetInd2 = new JLabel(" ");
		planetInd3 = new JLabel(" ");
		planetInd4 = new JLabel(" ");
		planetInd5 = new JLabel(" ");
		planetInd6 = new JLabel(" ");
		planetInd7 = new JLabel(" ");
		planetInd8 = new JLabel(" ");
		planetInd9 = new JLabel(" ");
		inds.addElement(planetInd1);
		inds.addElement(planetInd2);
		inds.addElement(planetInd3);
		inds.addElement(planetInd4);
		inds.addElement(planetInd5);
		inds.addElement(planetInd6);
		inds.addElement(planetInd7);
		inds.addElement(planetInd8);
		inds.addElement(planetInd9);
		Vector res = new Vector();
		planetRes1 = new JLabel(" ");
		planetRes2 = new JLabel(" ");
		planetRes3 = new JLabel(" ");
		planetRes4 = new JLabel(" ");
		planetRes5 = new JLabel(" ");
		planetRes6 = new JLabel(" ");
		planetRes7 = new JLabel(" ");
		planetRes8 = new JLabel(" ");
		planetRes9 = new JLabel(" ");
		res.addElement(planetRes1);
		res.addElement(planetRes2);
		res.addElement(planetRes3);
		res.addElement(planetRes4);
		res.addElement(planetRes5);
		res.addElement(planetRes6);
		res.addElement(planetRes7);
		res.addElement(planetRes8);
		res.addElement(planetRes9);

		gbc.insets.bottom = 1;
		gbc.insets.top = 1;
		gbc.insets.right = 1;
		gbc.insets.left = 1;

		int gridy2 = gridy;

		JPanel planetsPanel = new JPanel();
		planetsPanel.setLayout(new GridBagLayout());

		for (int i = 0; i < 9; i++)
		{
		    	gbc.gridx = 0;
			gbc.gridy = i;//gridy;
			gbc.gridwidth = 2;

			JPanel planetPanel = new JPanel();
			planetPanel.setBorder(BorderFactory.createEtchedBorder(1));
			planetPanel.setLayout(new GridBagLayout());

			GridBagConstraints gbc2 = new GridBagConstraints();

			gbc2.insets.right = 2;
    			gbc2.insets.left = 2;
			gbc2.insets.bottom = 2;
			gbc2.insets.top = 2;

			gbc2.gridy = 0;
			gbc2.gridx = 0;
			gbc2.gridwidth = 2;
			gbc2.gridheight = 1;

			gbc2.fill = GridBagConstraints.NONE;

			JLabel planetName = (JLabel) titles.elementAt(i);
			planetName.setForeground(c.YELLOW.darker());
			planetPanel.add(planetName, gbc2);

			gbc2.fill = GridBagConstraints.HORIZONTAL;

			gbc2.gridy = 1;
			gbc2.gridwidth = 1;

			JLabel planetEcoLabel = new JLabel("Eco (3): ");
			planetPanel.add(planetEcoLabel, gbc2);

			gbc2.gridx = 1;

			JLabel planetEco = (JLabel) ecos.elementAt(i);
			planetPanel.add(planetEco, gbc2);

			gbc2.gridy = 2;
			gbc2.gridx = 0;

			JLabel planetIndLabel = new JLabel("Ind (5): ");
			planetPanel.add(planetIndLabel, gbc2);

			gbc2.gridx = 1;

			JLabel planetInd = (JLabel) inds.elementAt(i);
			planetPanel.add(planetInd, gbc2);

			gbc2.gridy = 3;
			gbc2.gridx = 0;

			JLabel planetResLabel = new JLabel("Res/Tur: ");
			planetPanel.add(planetResLabel, gbc2);

			gbc2.gridx = 1;

			JLabel planetRes = (JLabel) res.elementAt(i);
			planetPanel.add(planetRes, gbc2);

			planetsPanel.add(planetPanel, gbc);
			//JScrollPane scrollPlanets = new JScrollPane(planetPanel);

			//main.getContentPane().add(scrollPlanets, gbc);//planetPanel, gbc);

			gridy++;
		}

		gbc.gridy = gridy2;
		gbc.gridheight = 5;

		JScrollPane scrollPlanets = new JScrollPane(planetsPanel);
		scrollPlanets.setPreferredSize(new Dimension(85, 400));
		main.getContentPane().add(scrollPlanets, gbc);

		gbc.insets.right = 8;
    		gbc.insets.left = 8;
		gbc.gridheight = 1;

		Vector planets = player.getEmpire().getPlanets();
		for (int i = 0; i < planets.size(); i++)
		{
			Planet p = (Planet) planets.elementAt(i);
			JLabel title = (JLabel) titles.elementAt(i);
			title.setText(p.getName());
			JLabel eco = (JLabel) ecos.elementAt(i);
			eco.setText(""+p.getEconomy());
			JLabel ind = (JLabel) inds.elementAt(i);
			ind.setText(""+p.getIndustry());
			JLabel reso = (JLabel) res.elementAt(i);
			//reso.setText(p.getFood()+"F/"+p.getMinerals()+"M/"+p.getGas()+"G");

			// Show the bonuses for supertech!
			String text = new String();

			double multiplier = 0;

			// Hydroponics
			if (player.getEmpire().getTech() > 29)
			{
				if (p.getFood() > 0)
				{
					multiplier = 1;
				}
			}

			text += (int)(p.getFood() + multiplier) + "F/";

			multiplier = 0;

			// Ore Refining
			if (player.getEmpire().getTech() > 39)
			{
				if (p.getMinerals() > 0)
				{
					multiplier = 1;
				}
			}

			text += (int)(p.getMinerals() + multiplier) + "M/";

			multiplier = 0;

			// Gas Refining
			if (player.getEmpire().getTech() > 34)
			{
				if (p.getGas() > 0)
				{
					multiplier = 1;
				}
			}

			text += (int)(p.getGas() + multiplier) + "G";

			reso.setText(text);
		}

		gbc.gridx = 2;
		gbc.gridwidth = 2;
		gbc.gridheight = 5;
		gbc.gridy = 6;

		gridy = 1;

		spaceLabels = new Vector();
		spaceNames = new Vector();
		spaceButtons = new Vector();
		spaceLocations = new Vector();
		spaceLists = new Vector();

		groundLabels = new Vector();
		groundNames = new Vector();
		groundButtons = new Vector();
		groundLocations = new Vector();
		groundLists = new Vector();

		JPanel spaces = new JPanel();
		spaces.setLayout(new GridBagLayout());

		GridBagConstraints gbc3 = new GridBagConstraints();

		gbc3.insets.right = 2;
		gbc3.insets.left = 2;
		gbc3.insets.bottom = 2;
		gbc3.insets.top = 2;

		gbc3.gridx = 0;
		gbc3.gridy = 0;
		gbc3.gridwidth = 1;

		gbc3.fill = GridBagConstraints.HORIZONTAL;

		newSpaceUnit = new JButton("New Unit");
		newSpaceUnit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				Unit u = new Unit("New Unit " + player.getNewUnitCounter(), player.toString());
				player.getEmpire().addSpaceUnit(u);
				addUnit = true;
				loop = false;
			}});
		spaces.add(newSpaceUnit, gbc3);

		gbc3.gridx = 1;

		transferSpace = new JButton("Transfer");
		transferSpace.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){

			    transfer(player.getEmpire().getSpaceUnits());

			}});
		spaces.add(transferSpace, gbc3);

		for (int i = 0; i < player.getEmpire().getSpaceUnits().size(); i++)
		{
		   	final Unit su = (Unit) player.getEmpire().getSpaceUnits().elementAt(i);

	//		GridBagConstraints gbc3 = new GridBagConstraints();

			gbc3.insets.right = 0;
    			gbc3.insets.left = 0;
			gbc3.insets.bottom = 2;
			gbc3.insets.top = 2;

			gbc3.gridy = gridy;
			gbc3.gridx = 0;
			gbc3.gridwidth = 2;
			gbc3.gridheight = 1;

			gbc3.fill = GridBagConstraints.HORIZONTAL;

		    	JPanel spacePanel = new JPanel();
			spacePanel.setBorder(BorderFactory.createEtchedBorder(1));
			spacePanel.setLayout(new GridBagLayout());

			GridBagConstraints gbc4 = new GridBagConstraints();

			gbc4.insets.right = 1;
    			gbc4.insets.left = 1;
			gbc4.insets.bottom = 2;
			gbc4.insets.top = 2;

			gbc4.gridy = 0;
			gbc4.gridx = 0;
			gbc4.gridwidth = 1;
			gbc4.gridheight = 1;

			gbc4.fill = GridBagConstraints.HORIZONTAL;

			//JLabel unitName = new JLabel("Unit 1     ");

			final JLabel unitName = new JLabel(su.toString());
			spacePanel.add(unitName, gbc4);
			spaceLabels.addElement(unitName);


			gbc4.gridx = 1;

			final JTextField newName = new JTextField(" ", 7);
			spacePanel.add(newName, gbc4);
			spaceNames.addElement(newName);

			gbc4.gridx =2;

			JButton changeName = new JButton("Change");
			changeName.setFont(new Font("Serif", 1, 9));
			changeName.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){
					su.setName(newName.getText());
					newName.setText(" ");
					unitName.setText(su.toString());
			}});
			spacePanel.add(changeName, gbc4);
			spaceButtons.addElement(changeName);

			gbc4.gridx = 0;
			gbc4.gridy = gbc4.gridy + 1;
			gbc4.gridheight = 1;
			gbc4.gridwidth = 3;

			// Put in location label here.

			String locationText = "Location (x/y): ";
			if (!su.isEmpty())
			{
				Location loc = su.getLocation();
				locationText += loc.getPositionX() + "/" + loc.getPositionY();
				if (loc.getPlanets().size() > 0)
				{
					Planet plan = (Planet) loc.getPlanets().elementAt(0);
					locationText += " ("+plan.getName()+")";
				}
			}

			final JLabel spaceLocation = new JLabel(locationText, 0);
			spaceLocations.addElement(spaceLocation);
			spacePanel.add(spaceLocation, gbc4);


			gbc4.gridx = 0;
			gbc4.gridy = gbc4.gridy + 1;
			gbc4.gridheight = 3;
			gbc4.gridwidth = 3;

			final JList forces = new JList(su.getForces());
			ListSelectionModel lsm = forces.getSelectionModel();
			lsm.setSelectionMode(0);

			ListCellRenderer unitRenderer = new UnitRenderer();
			forces.setCellRenderer(unitRenderer);

 			JPanel listPanel = getListPanel(forces, su.getName(), lsm);

			// MouseListener for your list of forces.  Double click to show the force.
			MouseListener mouseListener = new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
		       		if (e.getClickCount() > 1)
				{
             				Force force = (Force) forces.getSelectedValue();
					showUnit(force, true);
				}
     			}};
 			forces.addMouseListener(mouseListener);


			spacePanel.add(forces, gbc4);//listPanel, gbc4);//forces, gbc4);

			// We are trying to achieve drag & drop!
			//DragSource ds = new DragSource();
			/*
			forces.setDragEnabled(true);


			DropTarget dt = new DropTarget();
			forces.setDropTarget(dt);

			try
			{
			dt.addDropTargetListener(new DropTargetListener()
				    {
					public void drop(DropTargetDropEvent e)
					{
					    try
						{
						System.out.println(e.toString());
						SpaceForce sf = (SpaceForce) ((Unit)player.getEmpire().getSpaceUnits().elementAt(0)).getForces().elementAt(0);
						Class classic = sf.getClass();

						System.out.println("Class: " + classic.getName());

						DataFlavor sfFlavor = new DataFlavor(sf.getClass(), "SpaceForce");

						System.out.println("Getting flavor!");

						Transferable t = e.getTransferable();


						System.out.println("Transferable: " + t.toString());

						SpaceForce st = (SpaceForce) t.getTransferData(DataFlavor.stringFlavor);

						System.out.println("Getting: " + st.toString());

						e.acceptDrop(DnDConstants.ACTION_MOVE);

						System.out.println("MADE IT!");
						System.out.println(st.getClass().getName());

						e.dropComplete(true);


						}
						catch (Exception f)
						{
							System.out.println("Hah! " + f.toString() );
						}
					}
   					public void dragEnter(DropTargetDragEvent e) { }
    					public void dragExit(DropTargetEvent e) { }
  					public void dragOver(DropTargetDragEvent e) { }
    					public void dropActionChanged(DropTargetDragEvent e) { }
				    }); // DropTargetListener
			}
			catch (Exception e)
			{
				System.out.println(e.toString());
			}*/


			spaceLists.addElement(forces);

			spaces.add(spacePanel, gbc3);

		   	gridy = gridy + 1;

		}

		JScrollPane scroll = new JScrollPane(spaces);
		scroll.setPreferredSize(new Dimension(90, 300));
		main.getContentPane().add(scroll, gbc);


		gbc.gridx = 4;
		gbc.gridwidth = 3;

		gridy = 1;

		JPanel grounds = new JPanel();
		grounds.setLayout(new GridBagLayout());

		gbc3.insets.right = 2;
		gbc3.insets.left = 2;
		gbc3.insets.bottom = 2;
		gbc3.insets.top = 2;

		gbc3.gridx = 0;
		gbc3.gridy = 0;
		gbc3.gridwidth = 1;

		newGroundUnit = new JButton("New Unit");
		newGroundUnit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				Unit u = new Unit("New Unit " + player.getNewUnitCounter(), player.toString());
				player.getEmpire().addGroundUnit(u);
				addUnit = true;
				loop = false;
			}});
		grounds.add(newGroundUnit, gbc3);

			gbc3.gridx = 1;

		transferGround = new JButton("Transfer");
		transferGround.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				transfer(player.getEmpire().getGroundUnits());
			}});
		grounds.add(transferGround, gbc3);

		for (int i = 0; i < player.getEmpire().getGroundUnits().size(); i++)
		{
		    	final Unit gu = (Unit) player.getEmpire().getGroundUnits().elementAt(i);

	//		GridBagConstraints gbc3 = new GridBagConstraints();

			gbc3.insets.right = 0;
    			gbc3.insets.left = 0;
			gbc3.insets.bottom = 2;
			gbc3.insets.top = 2;

			gbc3.gridy = gridy;
			gbc3.gridx = 0;
			gbc3.gridwidth = 2;
			gbc3.gridheight = 1;

			gbc3.fill = GridBagConstraints.HORIZONTAL;

		    	JPanel groundPanel = new JPanel();
			groundPanel.setBorder(BorderFactory.createEtchedBorder(1));
			groundPanel.setLayout(new GridBagLayout());

			GridBagConstraints gbc4 = new GridBagConstraints();

			gbc4.insets.right = 1;
    			gbc4.insets.left = 1;
			gbc4.insets.bottom = 2;
			gbc4.insets.top = 2;

			gbc4.gridy = 0;
			gbc4.gridx = 0;
			gbc4.gridwidth = 1;
			gbc4.gridheight = 1;

			gbc4.fill = GridBagConstraints.HORIZONTAL;

			//JLabel unitName = new JLabel("Unit 1     ");
			final JLabel unitName = new JLabel(gu.toString());
			groundPanel.add(unitName, gbc4);
			groundLabels.addElement(unitName);

			gbc4.gridx = 1;

			final JTextField newName = new JTextField(" ", 7);
			groundPanel.add(newName, gbc4);
			groundNames.addElement(newName);

			gbc4.gridx = 2;

			JButton changeName = new JButton("Change");
			changeName.setFont(new Font("Serif", 1, 9));
			changeName.addActionListener(new ActionListener(){
			    public void actionPerformed(ActionEvent e){
				gu.setName(newName.getText());
				newName.setText(" ");
				unitName.setText(gu.toString());
			}});
			groundPanel.add(changeName, gbc4);
			groundButtons.addElement(changeName);

			gbc4.gridx = 0;
			gbc4.gridy = gbc4.gridy + 1;
			gbc4.gridheight = 1;
			gbc4.gridwidth = 3;

			// Put in location label here.

			String locationText = "Location (x/y): ";
			if (!gu.isEmpty())
			{
				Location loc = gu.getLocation();
				locationText += loc.getPositionX() + "/" + loc.getPositionY();
				if (loc.getPlanets().size() > 0)
				{
					Planet plan = (Planet) loc.getPlanets().elementAt(0);
					locationText += " ("+plan.getName()+")";
				}
			}

			if (gu.getLoaded())
			{
				locationText += " - SPACE";
			}

			final JLabel spaceLocation = new JLabel(locationText, 0);
			groundLocations.addElement(spaceLocation);
			groundPanel.add(spaceLocation, gbc4);

			gbc4.gridx = 0;
			gbc4.gridy = gbc4.gridy+1;
			gbc4.gridheight = 3;
			gbc4.gridwidth = 3;

			final JList forces = new JList(gu.getForces());
			ListSelectionModel lsm = forces.getSelectionModel();
			lsm.setSelectionMode(0);
			groundPanel.add(forces, gbc4);
			groundLists.addElement(forces);

			ListCellRenderer unitRenderer = new UnitRenderer();
			forces.setCellRenderer(unitRenderer);

			// MouseListener for your list of forces.  Double click to show the force.
			MouseListener mouseListener = new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
		       		if (e.getClickCount() > 1)
				{
             				Force force = (Force) forces.getSelectedValue();
					showUnit(force, false);
				}
     			}};
 			forces.addMouseListener(mouseListener);

			grounds.add(groundPanel, gbc3);

		   	gridy = gridy + 1;

		}

		JScrollPane scroll2 = new JScrollPane(grounds);
		scroll2.setPreferredSize(new Dimension(90, 300));
		main.getContentPane().add(scroll2, gbc);

		gbc.gridy = 1;
		gbc.gridx = 7;
		gbc.gridheight = 6;
		gbc.gridwidth = 3;

		JPanel turnPanel = new JPanel();
		turnPanel.setBorder(BorderFactory.createEtchedBorder(1));
		turnPanel.setLayout(new GridBagLayout());

		GridBagConstraints gbc2 = new GridBagConstraints();

		gbc2.fill = GridBagConstraints.NONE;

		gbc2.insets.top = 0;
		gbc2.insets.bottom = 15;
		gbc2.insets.right = 5;
		gbc2.insets.left = 5;

		gbc2.gridwidth = 4;
		gbc2.gridheight = 1;
		gbc2.gridy = 0;
		gbc2.gridx = 0;

		turnLabel = new JLabel(" Turn "+map.getTurn()+" - Order of Phases ");
		turnLabel.setBorder(BorderFactory.createBevelBorder(1));
		turnLabel.setFont(new Font("Serif", 1, 20));
		turnLabel.setBackground(c.BLUE);
		turnPanel.add(turnLabel, gbc2);

		gbc2.fill = GridBagConstraints.HORIZONTAL;

		gbc2.insets.top = 3;
		gbc2.insets.bottom = 3;

		gbc2.gridx = 2;
		gbc2.gridy = 1;
		gbc2.gridwidth = 2;

		JLabel phase1Label = new JLabel("1 - Collect Money & Resources");
		turnPanel.add(phase1Label, gbc2);

		gbc2.gridy = 2;

		JLabel phase2Label = new JLabel("2 - Espionage");
		turnPanel.add(phase2Label, gbc2);

		gbc2.gridy = 3;

		JLabel phase3Label = new JLabel("3 - Movement");
		turnPanel.add(phase3Label, gbc2);

		gbc2.gridy = 4;

		JLabel phase4Label = new JLabel("4 - Combat");
		turnPanel.add(phase4Label, gbc2);

		gbc2.gridy = 5;

		JLabel phase5Label = new JLabel("5 - Market");//Production");
		turnPanel.add(phase5Label, gbc2);

		gbc2.gridy = 6;

		JLabel phase6Label = new JLabel("6 - Improvement");//Market");
		turnPanel.add(phase6Label, gbc2);

		gbc2.gridy = 7;

		JLabel phase7Label = new JLabel("7 - Production");//Improvement");
		turnPanel.add(phase7Label, gbc2);

		if (map.getPhase() == 1)
		{
			phase1Label.setForeground(c.RED);
		}
		else if (map.getPhase() == 2)
		{
			phase2Label.setForeground(c.RED);
		}
		else if (map.getPhase() == 3)
		{
			phase3Label.setForeground(c.RED);
		}
		else if (map.getPhase() == 4)
		{
			phase4Label.setForeground(c.RED);
		}
		else if (map.getPhase() == 5)
		{
			phase5Label.setForeground(c.RED);
		}
		else if (map.getPhase() == 6)
		{
			phase6Label.setForeground(c.RED);
		}
		else if (map.getPhase() == 7)
		{
			phase7Label.setForeground(c.RED);
		}

		main.getContentPane().add(turnPanel, gbc);

		gbc.gridy = 7;
		gbc.gridheight = 2;

		JPanel victoryPanel = new JPanel();
		victoryPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Victory Conditions:"));
		victoryPanel.setLayout(new GridBagLayout());

		gbc3 = new GridBagConstraints();

		gbc3.fill = GridBagConstraints.HORIZONTAL;

		gbc3.insets.top = 6;
		gbc3.insets.bottom = 6;
		gbc3.insets.right = 6;
		gbc3.insets.left = 6;

		gbc3.gridx = 0;
		gbc3.gridy = 1;

		JLabel condition1 = new JLabel(" Victory Points (current/needed): ");
		condition1.setFont(new Font("Serif", 1, 14));
		condition1.setBorder(BorderFactory.createBevelBorder(1));
		condition1.setBackground(c.RED);
		//victoryPanel.add(condition1, gbc3);

		gbc3.gridy = 2;

		JLabel condition3 = new JLabel(player.getEmpire().getVictoryPoints()+" / " + player.getEmpire().getMaxVictoryPoints(), 0);
		condition3.setFont(new Font("Serif", 1, 28));
		condition3.setBorder(BorderFactory.createTitledBorder(BorderFactory.createBevelBorder(1), "Victory Points (VP):"));
		condition3.setBackground(c.RED);
		condition3.setForeground(c.GREEN.darker());
		victoryPanel.add(condition3, gbc3);

		gbc3.gridy = 3;

		JLabel condition2 = new JLabel("1VP/10 tech, 1VP/10 Industry, 3VP/Planet", 0);
		condition2.setFont(new Font("Serif", 1, 10));
		victoryPanel.add(condition2, gbc3);

		//condition2.setBorder(BorderFactory.createBevelBorder(1));
		//condition2.setBackground(c.RED);

		gbc3.gridy = 4;

		JLabel condition4 = new JLabel(player.getEmpire().getSpecialVictoryCondition()+"", 0);
		condition4.setFont(new Font("Serif", 1, 9));
		victoryPanel.add(condition4, gbc3);

		main.getContentPane().add(victoryPanel, gbc);

		gbc.gridy = 9;
		gbc.gridheight = 2;

		gbc.fill = GridBagConstraints.NONE;

		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new GridBagLayout());
		main.getContentPane().add(buttonPanel, gbc);

		gbc2 = new GridBagConstraints();

		gbc2.insets.top = 5;
		gbc2.insets.bottom = 5;
		gbc2.insets.left = 5;
		gbc2.insets.right = 5;

		gbc2.gridx = 0;
		gbc2.gridy = 0;

		mapOn = new JButton(" Show Map! ");

		mapOn.setFont(new Font("Serif", 1, 14));
		mapOn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			paxMap.dispose();
			showMap();
		}});
		buttonPanel.add(mapOn, gbc2);

		gbc2.gridy = 1;

		frameOn = new JButton(" Show Menu ");
		frameOn.setFont(new Font("Serif", 1, 14));
		frameOn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			frame.setVisible(true);
		}});

		frameOn.setEnabled(false);
		buttonPanel.add(frameOn, gbc2);

		if ((map.getPhase() == 2) || (map.getPhase() == 6) || (map.getPhase() == 7)) // 5
		{
			frameOn.setEnabled(true);
		}

		gbc2.gridy = 2;

		done = new JButton("Done Phase!");
		done.setFont(new Font("Serif", 1, 14));
		done.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){

			if (map.getPhase() == 3)
			{
				boolean	finish = invadePlanets();

				if (finish)
				{
					done.disable();
					doneButton();
				}
			}
			else
			{
				int finished = JOptionPane.showConfirmDialog(main, "Are you ready to end this phase?", "Done Phase?", JOptionPane.YES_NO_OPTION);
				if (finished == 0)
				{
					if (map.getPhase() == 2)
					{
						try
						{
							psi.acceptOperations(operations);
						}
						catch (Exception ee)
						{
							System.out.println("Can't reach server! " + ee.toString());
						}
					}

					else if (map.getPhase() == 6)
					{
						if (execute != null)
						{
							execute.doClick();
						}
					}
					else if (map.getPhase() == 7)
					{
						if (executeProduction != null)
						{
							doneTurn = true;
							executeProduction.doClick();
						}
					}

					done.disable();
					doneButton();
				}
			}
		}});
		buttonPanel.add(done, gbc2);

		gbc2.gridy = 3;

		JLabel filler = new JLabel("      ");
		filler.setFont(new Font("Serif", 1, 14));
		buttonPanel.add(filler, gbc2);

		gbc2.gridy = 4;

		drop = new JButton(" Drop Out! ");
		drop.setFont(new Font("Serif", 1, 14));
		drop.setBackground(c.RED);
		drop.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){

			ColorUIResource r = new ColorUIResource(c.RED);
			ColorUIResource n = (ColorUIResource) UIManager.get("OptionPane.background");
			UIManager.put("OptionPane.background", r);
			UIManager.put("Panel.background", r);


			int finished = JOptionPane.showConfirmDialog(main, "Dropping out will turn your empire into an AI.\nYou will not be able to rejoin this game.\n\nDo you really want to drop out of this game?", "Drop Game?", JOptionPane.YES_NO_OPTION);
			if (finished == 0)
			{
				dropped = true;

				drop.disable();
				doneButton();

			}

			UIManager.put("OptionPane.background", n);
			UIManager.put("Panel.background", n);


		}});
		buttonPanel.add(drop, gbc2);


		showMap();

		main.pack();
		main.show();


		if (loo)
		{
			if (map.getPhase() == 2)
			{
				espionage();
			}
			if (map.getPhase() == 7)
			{
				// Restore captured planets to an uncaptured state.
				for (int i = 0; i < player.getEmpire().getPlanets().size(); i++)
				{
					Planet p = (Planet) player.getEmpire().getPlanets().elementAt(i);
					p.setCaptured(false);
				}

				if (player.getEmpire().getPlanets().size() > 0)
				{
			    		production();
				}
				else
				{
					JOptionPane.showMessageDialog(main, "You have no planets to use for production!","No Production", JOptionPane.INFORMATION_MESSAGE);
				}


			}

			if (map.getPhase() == 5)
			{
				market();
			}

			if (map.getPhase() == 6)
			{
				if (player.getEmpire().getPlanets().size() > 0)
				{
					improvement();
				}
				else
				{
					JOptionPane.showMessageDialog(main, "You cannot improve without owning any planets!","No Improvement", JOptionPane.INFORMATION_MESSAGE);
				}

				for (int i = 0; i < player.getEmpire().getSpaceUnits().size(); i++)
				{
					Unit u = (Unit) player.getEmpire().getSpaceUnits().elementAt(i);
					u.restoreMovement();
				}
				for (int i = 0; i < player.getEmpire().getPlanets().size(); i++)
				{
					Planet p = (Planet) player.getEmpire().getPlanets().elementAt(i);
					p.restoreIndustry();
				}

			}
		}

		KeyboardFocusManager kfm = KeyboardFocusManager.getCurrentKeyboardFocusManager();

		Color f = done.getBackground();
		Color m = main.getBackground();

		int timer = 0;


		while (loop)
		{


			if (kfm.getFocusedWindow() != null)
			{
				try
				{
					if (timer > 500)
					{

						//done.setBackground(c.GRAY.darker());
						//done.setForeground(c.WHITE);

						//Thread.sleep(50);

						if ((timer-500)%20 < 10)
						{
							done.setBackground(f);
							done.setForeground(c.BLACK);

							main.getContentPane().setBackground(m);

							empireLabel.setForeground(c.BLACK);
							techLabel.setForeground(c.BLACK);
							resTurnLabel.setForeground(c.BLACK);
							espionageLabel.setForeground(c.BLACK);
							counterEspionageLabel.setForeground(c.BLACK);
							incomeLabel.setForeground(c.BLACK);

							empire.setForeground(c.BLACK);
							tech.setForeground(c.BLACK);
							resTurn.setForeground(c.BLACK);
							espionage.setForeground(c.BLACK);
							counterEspionage.setForeground(c.BLACK);
							income.setForeground(c.BLACK);

							planetsLabel.setForeground(c.BLACK);
							spaceLabel.setForeground(c.BLACK);
							groundLabel.setForeground(c.BLACK);

						}
						else
						{
							done.setBackground(c.GRAY.darker());
							done.setForeground(c.WHITE);

							main.getContentPane().setBackground(c.GRAY.darker());

							empireLabel.setForeground(c.WHITE);
							techLabel.setForeground(c.WHITE);
							resTurnLabel.setForeground(c.WHITE);
							espionageLabel.setForeground(c.WHITE);
							counterEspionageLabel.setForeground(c.WHITE);
							incomeLabel.setForeground(c.WHITE);

							empire.setForeground(c.WHITE);
							tech.setForeground(c.WHITE);
							resTurn.setForeground(c.WHITE);
							espionage.setForeground(c.WHITE);
							counterEspionage.setForeground(c.WHITE);
							income.setForeground(c.WHITE);

							planetsLabel.setForeground(c.WHITE);
							spaceLabel.setForeground(c.WHITE);
							groundLabel.setForeground(c.WHITE);
						}

						Thread.sleep(100);
						timer++;
					}
					else
					{
						timer++;
						Thread.sleep(100);
					}

					mc.setTimer((float)(Math.abs(Math.sin(timer*0.25))));
					mc.repaint();
				}
				catch (Exception e)
				{
					System.out.println("Can't flash button!");
				}
			}
			else
			{
				//if (!main.isShowing())
				//{
				if (main.getExtendedState() == 1)//ICONIFIED)
				{
					main.toFront();
				}
					//main.toFront();
					//main.requestFocusInWindow();
				//}
			}

		}

		if (addUnit || undo)
		{
		    	dispose();
			PaxClient pc = new PaxClient(player, map, true);
		}


	}

  	private JPanel getListPanel(JList list, String labelName, ListSelectionModel listModel )
	{
        JPanel listPanel = new JPanel();
        JScrollPane scrollPane = new JScrollPane(list);

        list.setSelectionModel(listModel);
        JLabel nameListName = new JLabel(labelName );

        listPanel.setLayout( new BorderLayout());
        //listPanel.add(nameListName, BorderLayout.NORTH);
        listPanel.add( scrollPane, BorderLayout.CENTER);

        return listPanel;
  	}


	public void doneButton()
	{

			loop = false;  // put in disable method???!

			main.dispose();
			paxMap.dispose();

			if ((map.getPhase() == 2) || (map.getPhase() == 6) || (map.getPhase() == 7)) //5
			{
				if (frame != null)
				{
					frame.dispose();
				}
			}

			if (transferFrame != null)
			{
				transferFrame.dispose();
			}
			if (disbandFrame != null)
			{
				disbandFrame.dispose();
			}
			if (showFrame != null)
			{
				showFrame.dispose();
			}
	}

	public void showMap()
	{
		Color c = new Color(121);

		Vector colors = new Vector();
		colors.addElement(c.BLUE);
		colors.addElement(c.RED);
		colors.addElement(c.GREEN.darker());
		colors.addElement(c.GRAY);
		colors.addElement(c.MAGENTA);
		colors.addElement(c.ORANGE);
		colors.addElement(c.PINK);
		colors.addElement(c.CYAN.darker());
		colors.addElement(c.RED.darker());
		colors.addElement(c.WHITE.darker());
		colors.addElement(c.GREEN.brighter());
		colors.addElement(c.MAGENTA.darker());

		paxMap = new JFrame();
		paxMap.setResizable(false);
		paxMap.setTitle("Pax Galaktika Map");
		paxMap.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 6;
		gbc.gridheight = 10;


		currentUnitList = new JList();
		currentGroundList = new JList();

		//final MapCanvas mc = new MapCanvas(player, map, spaceLocations, groundLocations, spaceLists, groundLists);
		mc = new MapCanvas(player, map, spaceLocations, groundLocations, spaceLists, groundLists, unitsBox, currentUnitList);
		mc.setGroundLocations(groundLocations);
		mc.setSpaceLocations(spaceLocations);
		paxMap.getContentPane().add(mc, gbc);

		gbc.insets.top = 5;
		gbc.insets.bottom = 5;
		gbc.insets.right = 5;
		gbc.insets.left = 5;

		gbc.gridx = 6;
		gbc.gridwidth = 3;
		gbc.gridheight = 6;

		gbc.fill = GridBagConstraints.HORIZONTAL;

		JPanel legendPanel = new JPanel();
		legendPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Legend:"));
		legendPanel.setLayout(new GridBagLayout());

		GridBagConstraints gbc2 = new GridBagConstraints();

		gbc2.insets.top = 5;
		gbc2.insets.bottom = 5;
		gbc2.insets.right = 5;
		gbc2.insets.left = 5;

		gbc2.fill = GridBagConstraints.HORIZONTAL;

		gbc2.gridx = 0;
		gbc2.gridwidth = 1;
		gbc2.gridheight = 1;

		for (int i = 0; i < map.getPlayers().size(); i++)
		{
			Player p = (Player) (map.getPlayers()).elementAt(i);

		    	gbc2.gridy = i;
			JLabel temp = new JLabel((i+1)+" - " + p.toString());
			temp.setFont(new Font("Serif", 1, 16));
			temp.setForeground((Color) colors.elementAt(i));
			legendPanel.add(temp, gbc2);
		}

		paxMap.getContentPane().add(legendPanel, gbc);

		gbc.gridy = 9;
		gbc.gridheight = 1;
		gbc.gridwidth = 3;

		JPanel movePanel = new JPanel();
		paxMap.getContentPane().add(movePanel, gbc);
		movePanel.setLayout(new GridBagLayout());

		gbc2 = new GridBagConstraints();

		gbc2.fill = GridBagConstraints.HORIZONTAL;

		gbc2.insets.top = 5;
		gbc2.insets.bottom = 5;
		gbc2.insets.right = 5;
		gbc2.insets.left = 5;

		gbc2.gridx = 0;
		gbc2.gridy = 0;
		gbc2.gridwidth = 1;
		gbc2.gridheight = 1;

		final JLabel minMoveLabel = new JLabel(" Fleet Movement:  - ");

		unitsBox = new JComboBox(player.getEmpire().getSpaceUnits());
		mc.setCurrentUnit((Unit)unitsBox.getSelectedItem(), unitsBox.getSelectedIndex());
		unitsBox.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
			mc.setCurrentUnit((Unit)unitsBox.getSelectedItem(), unitsBox.getSelectedIndex());
			mc.setMove(0);
			currentUnitList.setListData(((Unit)unitsBox.getSelectedItem()).getForces());

			if (map.getPhase() == 3)
			{
				mc.setMove(((Unit)unitsBox.getSelectedItem()).getMinMove());
				minMoveLabel.setText(" Fleet Movement: " + ((Unit)unitsBox.getSelectedItem()).getMinMove()+" ");
			}

			mc.repaint();
		}});
		movePanel.add(unitsBox, gbc2);

		mc.setUnitsBox(unitsBox);


		// Add a panel showing current unit contents.

		currentUnitList.setListData(((Unit)unitsBox.getSelectedItem()).getForces());
		ListSelectionModel lsm = currentUnitList.getSelectionModel();
		lsm.setSelectionMode(0);

		ListCellRenderer unitRenderer = new UnitRenderer();
		currentUnitList.setCellRenderer(unitRenderer);

		currentUnitList.setPreferredSize(new Dimension(200, 300));
		JScrollPane scrollCurrentUnitList = new JScrollPane(currentUnitList);
		scrollCurrentUnitList.setPreferredSize(new Dimension(120, 90));

		gbc2.gridy = gbc2.gridy + 1;
		movePanel.add(scrollCurrentUnitList, gbc2);

		gbc2.gridy = gbc2.gridy+1;

		if (map.getPhase() == 3) // Movement phase
		{
			minMoveLabel.setText(" Fleet Movement:  - ");
			minMoveLabel.setFont(new Font("Serif", 1, 14));
			movePanel.add(minMoveLabel, gbc2);

			if (unitsBox.getItemCount() > 0 && !(((Unit)unitsBox.getSelectedItem()).isEmpty()))
			{
				mc.setMove(((Unit)unitsBox.getSelectedItem()).getMinMove());
				minMoveLabel.setText(" Fleet Movement: " + ((Unit)unitsBox.getSelectedItem()).getMinMove()+" ");
			}

			gbc2.gridy = gbc2.gridy+1;

			JButton moving = new JButton("Move Unit");
			moving.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){

				Unit u = (Unit)unitsBox.getSelectedItem();

				if (!u.isEmpty())
				{
					//mc.setCurrentUnit((Unit)units.getSelectedItem());
					mc.setMove(((Unit)unitsBox.getSelectedItem()).getMinMove());
					minMoveLabel.setText(" Fleet Movement: " + ((Unit)unitsBox.getSelectedItem()).getMinMove()+" ");
					mc.repaint();
				}
				else
				{
					minMoveLabel.setText(" Fleet Movement:  - ");
				}
			}});
			movePanel.add(moving, gbc2);

			mc.setMoveLabel(minMoveLabel);

			gbc2.gridy = gbc2.gridy + 1;

			final JComboBox groundUnitsBox = new JComboBox(player.getEmpire().getGroundUnits());
			groundUnitsBox.addItemListener(new ItemListener(){
				public void itemStateChanged(ItemEvent e){
					currentGroundList.setListData(((Unit)groundUnitsBox.getSelectedItem()).getForces());
					mc.setCurrentGround((Unit)groundUnitsBox.getSelectedItem());
				}});
			movePanel.add(groundUnitsBox, gbc2);

			mc.setCurrentGround((Unit)groundUnitsBox.getSelectedItem());

			// Add a panel showing current unit contents.

			currentGroundList.setListData(((Unit)groundUnitsBox.getSelectedItem()).getForces());
			ListSelectionModel lsm2 = currentGroundList.getSelectionModel();
			lsm2.setSelectionMode(0);

			ListCellRenderer unitRenderer2 = new UnitRenderer();
			currentGroundList.setCellRenderer(unitRenderer2);

			currentGroundList.setPreferredSize(new Dimension(200, 300));
			JScrollPane scrollCurrentGroundList = new JScrollPane(currentGroundList);
			scrollCurrentGroundList.setPreferredSize(new Dimension(120, 90));

			gbc2.gridy = gbc2.gridy + 1;
			movePanel.add(scrollCurrentGroundList, gbc2);

			gbc2.gridy = gbc2.gridy + 1;

			final JButton loadGround = new JButton("Load Unit");
			loadGround.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){
				Unit u = (Unit) groundUnitsBox.getSelectedItem();
				if (!u.getLoaded())
				{
					if (!u.isEmpty())
					{
						int size = u.getForces().size();

						Unit u2 = (Unit) unitsBox.getSelectedItem();
						boolean loaded = false;

						if (u2.isEmpty())
						{
							JOptionPane.showMessageDialog(paxMap, "You cannot load into an empty fleet!","Loading Error", JOptionPane.ERROR_MESSAGE);
						}
						else
						{

						// Either the transports must be on the same square, or
						// the empire must have matter transporters.
						if ( (u.getLocation().getPositionX() == u2.getLocation().getPositionX() && u.getLocation().getPositionY() == u2.getLocation().getPositionY()) || player.getEmpire().getTech() > 49)
						{

							for (int i = 0; i < u2.getForces().size(); i++)
							{
						    		SpaceForce sf = (SpaceForce) u2.getForces().elementAt(i);
								if (sf.getStorageCapability() >= size)
			    					{
									loaded = true;

									// indicates if there is an immobile unit that can't be loaded.
									boolean immobile = false;

									for (int count = 0; count < u.getForces().size(); count++)
									{
										GroundForce gf = (GroundForce) u.getForces().elementAt(count);
										if (!gf.getMobile())
										{
											immobile = true;
										}

									}

									if (!immobile)
									{

										Vector store = sf.getStorage();
										Vector temp = new Vector();
										for (int k = 0; k < store.size(); k++)
										{
											Unit utemp = (Unit) store.elementAt(k);
											temp.addElement(utemp);
										}
										temp.addElement(u);
										sf.setStorage(temp);
										//store.addElement(u);
										u.setLoaded(true);
										i = u2.getForces().size();
										System.out.println("Loaded " + u + " into " + sf.getName() + " of " + u2 + "!");
										JOptionPane.showMessageDialog(paxMap, "You have successfully loaded " + u + " into " + u2 + "!","Loading Success", JOptionPane.INFORMATION_MESSAGE);

										JLabel location = (JLabel) groundLocations.elementAt(groundUnitsBox.getSelectedIndex());
										location.setText(location.getText() + " - SPACE");
										JList list = (JList) spaceLists.elementAt(unitsBox.getSelectedIndex());
										list.repaint();

										mc.repaint();
									}
									else
									{
										JOptionPane.showMessageDialog(paxMap, "One or more of the ground forces is immobile!","Loading Error", JOptionPane.ERROR_MESSAGE);
									}
								}
							}
							if (!loaded)
							{
								JOptionPane.showMessageDialog(paxMap, "No single storage ship big enough to hold this unit!","Loading Error", JOptionPane.ERROR_MESSAGE);
							}
						}
						else
						{
							JOptionPane.showMessageDialog(paxMap, "The chosen fleet is not at the same location\nas the unit to be loaded!","Loading Error", JOptionPane.ERROR_MESSAGE);
						}
						}
					}
					else
					{
						JOptionPane.showMessageDialog(paxMap, "There's no point in loading an empty unit!","Loading Error", JOptionPane.ERROR_MESSAGE);
					}
				}
				else
				{
					JOptionPane.showMessageDialog(paxMap, "That ground unit is already loaded!","Loading Error", JOptionPane.ERROR_MESSAGE);
				}
			}});
			movePanel.add(loadGround, gbc2);

			// The Unload button unloads the selected ground unit, as long as they are over a planet.
			gbc2.gridy = gbc2.gridy + 1;

			final JButton unloadButton= new JButton("Unload Unit");
			unloadButton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){
				Unit u = (Unit) groundUnitsBox.getSelectedItem();

				// Can't unload a unit that isn't loaded.
				if (!u.getLoaded())
				{
					JOptionPane.showMessageDialog(paxMap, "Ground unit " + u.getName() + " is not currently loaded in a transport!","Unloading Error", JOptionPane.ERROR_MESSAGE);
				}
				else if (u.getLoaded())
				{
					Location loc = u.getLocation();

					// Must unload onto a planet.
					if (loc.getPlanets().size() < 1)
					{
						JOptionPane.showMessageDialog(paxMap, "Ground unit " + u.getName() + " is not currently over a planet!\n\nGround units cannot be unloaded in deep space.","Unloading Error", JOptionPane.ERROR_MESSAGE);
					}
					else if (loc.getPlanets().size() > 0)
					{
						Planet p = (Planet) loc.getPlanets().elementAt(0);

						boolean owned = false;

						for (int t = 0; t < player.getEmpire().getPlanets().size(); t++)
						{
							Planet plan = (Planet) player.getEmpire().getPlanets().elementAt(t);

							if (plan.getName().equals(p.getName()))
							{
								owned = true;
								t = player.getEmpire().getPlanets().size();
							}
						}

						if (!owned)
						{
							JOptionPane.showMessageDialog(paxMap, "Ground units over enemy planets will be automatically unloaded after combat phase!","Unloading Failure", JOptionPane.INFORMATION_MESSAGE);
						}
						else
						{

							// Unloading the unit.
							unLoad(u);

							JOptionPane.showMessageDialog(paxMap, "You have successfully unloaded " + u.getName() + "!","Unloading Success", JOptionPane.INFORMATION_MESSAGE);
							mc.repaint();

							JLabel location = (JLabel) groundLocations.elementAt(groundUnitsBox.getSelectedIndex());
							String locationText = "Location (x/y): ";

							Location loc2 = u.getLocation();
							locationText += loc2.getPositionX() + "/" + loc2.getPositionY();

							if (loc2.getPlanets().size() > 0)
							{
								Planet plan = (Planet) loc2.getPlanets().elementAt(0);
								locationText += " ("+plan.getName()+")";
							}
							location.setText(locationText);

							JList list = (JList) spaceLists.elementAt(unitsBox.getSelectedIndex());
							list.repaint();
							mc.repaint();

						}
					}
				}
			}});

			movePanel.add(unloadButton, gbc2);

			// The Undo button undoes all movement for the phase, and sets all units back to their
			// initial locations and configurations.
			gbc2.gridy = gbc2.gridy + 1;
			//gbc2.fill = GridBagConstraints.VERTICAL;

			JLabel blankLabel = new JLabel(" ");
			movePanel.add(blankLabel, gbc2);

			gbc2.gridy = gbc2.gridy + 1;

			/*
			JLabel blankLabel2 = new JLabel(" ");
			movePanel.add(blankLabel2, gbc2);

			gbc2.gridy = gbc2.gridy + 1;

			JLabel blankLabel3 = new JLabel(" ");
			movePanel.add(blankLabel3, gbc2);

			gbc2.gridy = gbc2.gridy + 1;
			*/

			final JButton undoButton = new JButton("Undo All Movement");
			undoButton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){
				int finished = JOptionPane.showConfirmDialog(paxMap, "This will set your units back to their configurations at the beginning of this phase. \n\nDo you still wish to proceed?", "Undo All Movement?", JOptionPane.YES_NO_OPTION);
				if (finished == 0)
				{
					try
					{
						// Grabbing initial conditions from the server.

						Map serverMap = psi.getMap();

						Vector temp = serverMap.getPlayers();

						for (int i = 0; i < temp.size(); i++)
						{
							Player p = (Player) temp.elementAt(i);

							if (p.getName().equals(player.getName()))
							{
								player = p;
								map.getPlayers().setElementAt(player, i);
							}
						}


						// Building up a new client window.
						undo = true;
						loop = false;
					}
					catch (Exception f)
					{
						System.out.println("Couldn't get player - undo! " + f.toString());
					}
				}
			}});
			movePanel.add(undoButton, gbc2);


		}

		paxMap.pack();
		paxMap.show();
	}


	public void dispose()
	{
		main.dispose();
		paxMap.dispose(); // possibly causing an error?!

		if (addUnit)
		{
			if ((map.getPhase() == 2) || (map.getPhase() == 6) || (map.getPhase() == 7)) // 5;
			{
				frame.dispose();
			}
		}

		if (transferFrame != null)
		{
			transferFrame.dispose();
		}
		if (disbandFrame != null)
		{
			disbandFrame.dispose();
		}
		if (showFrame != null)
		{
			showFrame.dispose();
		}
	}

	public void disable()
	{
		done.setEnabled(false);
		drop.setEnabled(false);
		frameOn.setEnabled(false);
		newSpaceUnit.setEnabled(false);
		newGroundUnit.setEnabled(false);
		transferSpace.setEnabled(false);
		transferGround.setEnabled(false);
		disbandSpace.setEnabled(false);
		disbandGround.setEnabled(false);

		for (int i = 0; i < spaceNames.size(); i++)
		{
			JTextField temp = (JTextField) spaceNames.elementAt(i);
			temp.setEnabled(false);
			JButton temp2 = (JButton) spaceButtons.elementAt(i);
			temp2.setEnabled(false);
			JList temp3 = (JList) spaceLists.elementAt(i);
			temp3.setEnabled(false);
		}

		for (int i = 0; i < groundNames.size(); i++)
		{
		    	JTextField temp = (JTextField) groundNames.elementAt(i);
			temp.setEnabled(false);
			JButton temp2 = (JButton) groundButtons.elementAt(i);
			temp2.setEnabled(false);
			JList temp3 = (JList) groundLists.elementAt(i);
			temp3.setEnabled(false);
		}
	}

	public Vector getMessages()
	{
		return messages;
	}

	public void transfer(Vector uni)
	{

	    	Color c = new Color(121);
		final Vector units = uni;


		final Vector tempUnits = new Vector();
		for (int i = 0; i < units.size(); i++)
		{
			Unit u = (Unit) units.elementAt(i);
			if (!u.isEmpty() && !u.getLoaded())
			{
				tempUnits.addElement(u);
			}
		}


 		transferFrame = new JFrame(player.toString() + " - Transfer Forces");
		transferFrame.setSize(350, 550);
		transferFrame.setResizable(false);
		transferFrame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 4;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		transferFrame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 4;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Transfer Forces");
		transferFrame.getContentPane().add(waitingLabel, gbc);

		gbc.fill = GridBagConstraints.HORIZONTAL;

		gbc.gridy = 2;
		gbc.gridwidth = 1;

		JLabel transfer1Label = new JLabel("Transfer From: ");
		transferFrame.getContentPane().add(transfer1Label, gbc);

		gbc.gridx = 0;
		gbc.gridwidth = 2;
		gbc.gridy = 3;

		final JComboBox fromBox = new JComboBox(tempUnits);//units);
		transferFrame.getContentPane().add(fromBox, gbc);

		gbc.gridx = 2;
		gbc.gridwidth = 1;
		gbc.gridy = 2;

		JLabel transfer2Label = new JLabel("Transfer To: ");
		transferFrame.getContentPane().add(transfer2Label, gbc);

		gbc.gridx = 2;
		gbc.gridwidth = 2;
		gbc.gridy = 3;

		final JComboBox toBox = new JComboBox();//toUnits);
		transferFrame.getContentPane().add(toBox, gbc);

		gbc.gridy = 4;
		gbc.gridx = 0;
		gbc.gridheight = 3;
		gbc.gridwidth = 2;

		final JList fromForces = new JList(((Unit)fromBox.getSelectedItem()).getForces());
		ListSelectionModel lsm = fromForces.getSelectionModel();
		lsm.setSelectionMode(0);
		JScrollPane scroll1 = new JScrollPane(fromForces);
		scroll1.setPreferredSize(new Dimension(200, 150));//MinimumSize(new Dimension(6, 6));
		transferFrame.getContentPane().add(scroll1, gbc);

		ListCellRenderer unitRenderer = new UnitRenderer();
		fromForces.setCellRenderer(unitRenderer);

		gbc.gridx = 2;

		final JList toForces = new JList();
		lsm = toForces.getSelectionModel();
		lsm.setSelectionMode(0);
		JScrollPane scroll2 = new JScrollPane(toForces);
		scroll2.setPreferredSize(new Dimension(200, 150));//MinimumSize(new Dimension(6, 6));
		transferFrame.getContentPane().add(scroll2, gbc);

		toForces.setCellRenderer(unitRenderer);

		if (units.size() > 0)
		{
			Unit u = (Unit) fromBox.getSelectedItem();
		    	fromForces.setListData(u.getForces());
			Location l = u.getLocation();

			for (int i = 0; i < units.size(); i++)
			{
				Unit un = (Unit) units.elementAt(i);

				if (un.getForces().size() == 0)
				{
					toBox.addItem(un);
					un.setLoaded(false);
				}
				else if ((un.getLocation().getPositionX() == l.getPositionX() && un.getLocation().getPositionY() == l.getPositionY()) && !(u == un) && !un.getLoaded())
				{
					toBox.addItem(un);
				}
				// Units in the asteroid belt are considered to be on the same square.
				else if (l.getAsteroids() && un.getLocation().getAsteroids() && !(u == un) && !un.getLoaded())
				{
					toBox.addItem(un);
				}

			}
		}


		gbc.gridy = 7;
		gbc.gridx = 0;
		gbc.gridwidth = 4;
		gbc.gridheight = 1;

		JButton transfer = new JButton("Transfer Force");
		transfer.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			try
			{
				Unit u = (Unit) fromBox.getSelectedItem();
				Unit u2 = (Unit) toBox.getSelectedItem();
				Vector forc = u.getForces();
				Vector forc2 = u2.getForces();
				int i = fromForces.getSelectedIndex();
				if (i > -1)
				{
				    	Force f = (Force) forc.elementAt(i);
					forc.removeElementAt(i);
					fromForces.setListData(forc);

					if (u2.isEmpty())
					{
						u2.setLocation(u.getLocation());
					}
					u2.setLoaded(u.getLoaded());

					forc2.addElement(f);
					toForces.setListData(forc2);



					for (int t = 0; t < spaceLists.size(); t++)
					{
					    	JList temp = (JList) spaceLists.elementAt(t);
						temp.setListData(((Unit)player.getEmpire().getSpaceUnits().elementAt(t)).getForces());
					}
					for (int t = 0; t < groundLists.size(); t++)
					{
					    	JList temp = (JList) groundLists.elementAt(t);
						temp.setListData(((Unit)player.getEmpire().getGroundUnits().elementAt(t)).getForces());
					}


					if (u.isEmpty())
					{
						//unitsBox.removeItem(u);
						fromBox.removeItem(u);
					}


					u.calculateMinMove();
					u2.calculateMinMove();

					currentUnitList.repaint();
					currentGroundList.repaint();
					mc.repaint();

					refreshLabels();
				}

				// Possibly fixing a nebulous bug.
				//if (u.getForces().size() == 0)
				//{
					//fromBox.removeItem(u);
					//toBox.addItem(u);
					//tempUnits.remove(u);

					//Unit u3 = (Unit) fromBox.getSelectedItem();
					//fromForces.setListData(u3.getForces());


				//}
			}
			catch (Exception f)
			{
				System.out.println("Couldn't perform the force transfer.");
			}
		}});
		transferFrame.getContentPane().add(transfer, gbc);

		gbc.gridy = 8;
		gbc.gridwidth = 1;
		gbc.gridx = 3;

		JButton finished = new JButton("Done");
		finished.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			transferFrame.dispose();
		}});
		transferFrame.getContentPane().add(finished, gbc);

		fromBox.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
			try
	    		{

				//Unit u2 = (Unit) fromBox.getSelectedItem();
				//fromForces.setListData(u2.getForces());

			    	Unit u = (Unit) fromBox.getSelectedItem();

				if (!u.isEmpty())
				{

					toBox.removeAllItems();
					//toUnits.clear();

					fromForces.setListData(u.getForces());
					Location l = u.getLocation();

					for (int i = 0; i < units.size(); i++)
		    			{
						Unit u2 = (Unit) units.elementAt(i);
						Location l2 = u2.getLocation();

						// We can transfer force to an empty unit.
						if (u2.isEmpty())
						{
							toBox.addItem(u2);
							//toUnits.addElement(u2);
						}
						// Can transfer if at the same location and not the same unit.
						else if (l.getPositionX() == l2.getPositionX() && l.getPositionY() == l2.getPositionY() && !(u.getName().equals(u2.getName())))
						{
							toBox.addItem(u2);
							//toUnits.addElement(u2);
						}
						// Can transfer if in the belt.
						else if (l.getAsteroids() && l2.getAsteroids() && !(u.getName().equals(u2.getName())))
						{
							toBox.addItem(u2);
						}

					}
				}
			}
			catch (Exception f)
			{
				System.out.println("Problem with fromBox! " + f.toString());
			}
		}});
		if (toBox.getItemCount() > 0)
		{
			toForces.setListData(((Unit)toBox.getSelectedItem()).getForces());
		}
		toBox.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
			try
	    		{
			    	if (toBox.getItemCount() > 0)
				{
					Unit u = (Unit) toBox.getSelectedItem();
					if (!u.isEmpty())
					{
						toForces.setListData(u.getForces());
						System.out.println("Setting a new toBox value");
					}
					else
		    			{
					    	Vector v = new Vector();
						v.addElement(" ");
						toForces.setListData(v);
					}


				}
				else
				{
					Vector v = new Vector();
					v.addElement(" ");
					toForces.setListData(v);
					//System.out.println("zapping all in toBox b");
				}
			}
			catch (Exception f)
			{
				System.out.println("Problem with toBox! " + f.toString());
			}
		}});

		transferFrame.pack();
		transferFrame.show();
	}

	// Disband forces from the selected vector of units.
	// Two JLists - one shows units, and the other shows the forces within them.
	// A button at the bottom for disband, and one for done.  The boolean indicates
	// whether we are disbanding space units.

	public void disband(Vector uni, boolean spac)
	{
		final boolean space = spac;

	    	Color c = new Color(121);

		// Add all the non-empty units to a vector so that they can
		// be displayed as a JList.

		final Vector units = new Vector();
		for (int i = 0; i < uni.size(); i++)
		{
			Unit u = (Unit) uni.elementAt(i);
			if (!u.isEmpty())
			{
				units.addElement(u);
			}
		}

 		disbandFrame = new JFrame(player.toString() + " - Disband Forces");
		disbandFrame.setSize(350, 550);
		disbandFrame.setResizable(false);
		disbandFrame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 4;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		disbandFrame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 4;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Disband Forces");
		disbandFrame.getContentPane().add(waitingLabel, gbc);

		gbc.fill = GridBagConstraints.HORIZONTAL;

		gbc.gridy = 2;
		gbc.gridwidth = 1;

		JLabel transfer1Label = new JLabel("Available Units: ");
		disbandFrame.getContentPane().add(transfer1Label, gbc);

		gbc.gridx = 0;
		gbc.gridwidth = 2;
		gbc.gridy = 3;

		final JList unitList = new JList(units);
		ListSelectionModel lsm = unitList.getSelectionModel();
		lsm.setSelectionMode(0);
		JScrollPane scroll1 = new JScrollPane(unitList);
		scroll1.setPreferredSize(new Dimension(200, 150));
		disbandFrame.getContentPane().add(scroll1, gbc);

		gbc.gridx = 2;
		gbc.gridwidth = 1;
		gbc.gridy = 2;

		JLabel transfer2Label = new JLabel("Available Forces: ");
		disbandFrame.getContentPane().add(transfer2Label, gbc);

		gbc.gridx = 2;
		gbc.gridwidth = 2;
		gbc.gridy = 3;

		final JList forceList = new JList();
		lsm = forceList.getSelectionModel();
		lsm.setSelectionMode(0);
		JScrollPane scroll2 = new JScrollPane(forceList);
		scroll2.setPreferredSize(new Dimension(200, 150));
		disbandFrame.getContentPane().add(scroll2, gbc);

		// MouseListener for the list of units.  Put the contents of the unit into the forceList.
		MouseListener mouseListener = new MouseAdapter() {
     		public void mouseClicked(MouseEvent e) {
  		       	if (e.getClickCount() > 0)
			{
             			int index = unitList.locationToIndex(e.getPoint());
             			System.out.println("Clicked on Item " + index);

				Unit unit = (Unit) unitList.getSelectedValue();

				forceList.setListData(unit.getForces());
          		}
     		}};
 		unitList.addMouseListener(mouseListener);

		gbc.gridy = 4;
		gbc.gridx = 0;
		gbc.gridwidth = 4;
		gbc.gridheight = 1;

		final JButton disbandButton = new JButton("Disband Force");
		disbandButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){

			    // Get the Force to be disbanded and its unit.
			    Force f = (Force) forceList.getSelectedValue();
			    Unit u = (Unit) unitList.getSelectedValue();

			    int finished = JOptionPane.showConfirmDialog(disbandFrame, "Do you really wish to disband " + f.getName() + "?", "Disband Force?", JOptionPane.YES_NO_OPTION);
			    if (finished == 0)
			    {
			    	// Remove the index.
			    	int index = forceList.getSelectedIndex();

			    	u.getForces().removeElementAt(index);

				forceList.setListData(u.getForces());

				// Refresh the space or ground unit list.
				if (space)
				{
					JList temp = (JList) spaceLists.elementAt(unitList.getSelectedIndex());
					temp.setListData(u.getForces());
					temp.repaint();
				}
				else
				{
					JList temp = (JList) groundLists.elementAt(unitList.getSelectedIndex());
					temp.setListData(u.getForces());
					temp.repaint();
				}

				player.getEmpire().calculateMaintenance();
				maintenance.setText(""+player.getEmpire().getMaintenance());

			    disbandButton.setEnabled(false);

				currentUnitList.repaint();
				currentGroundList.repaint();

				mc.repaint();
			    }

		}});
		disbandFrame.getContentPane().add(disbandButton, gbc);

		disbandButton.setEnabled(false);

		// MouseListener for the list of forces.  Enables the 'Disband' button when one is selected.
		MouseListener mouseListener2 = new MouseAdapter() {
     		public void mouseClicked(MouseEvent e) {
  		       	if (e.getClickCount() > 0)
			{
             			int index = forceList.locationToIndex(e.getPoint());
             			//System.out.println("Clicked on Item " + index);

				disbandButton.setEnabled(true);
          		}
     		}};
 		forceList.addMouseListener(mouseListener2);

		gbc.gridy = 5;
		gbc.gridwidth = 1;
		gbc.gridx = 3;

		JButton finished = new JButton("Done");
		finished.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			disbandFrame.dispose();
		}});
		disbandFrame.getContentPane().add(finished, gbc);

		disbandFrame.pack();
		disbandFrame.show();
	}


	public void showUnit(Force force, boolean space)
	{

		showFrame = new JFrame(player.toString() + " - Show Force - " + force.getName());
		showFrame.setSize(350, 550);
		showFrame.setResizable(false);
		showFrame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 4;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		showFrame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 4;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Show Force - " + force.getName(), 0);
		waitingLabel.setFont(new Font("Dialog", 1, 16));
		showFrame.getContentPane().add(waitingLabel, gbc);

		gbc.fill = GridBagConstraints.HORIZONTAL;

		gbc.gridy = 2;
		gbc.gridwidth = 4;

		Vector forceVector = new Vector();
		forceVector.addElement(force.getDescription());

		if (!space)
		{

			// Ground panel!

			JPanel groundUnitListPanel = new JPanel();
			groundUnitListPanel.setLayout(new GridBagLayout());

			GridBagConstraints gbc2 = new GridBagConstraints();

			gbc2.fill = GridBagConstraints.BOTH;

			gbc2.insets.right = 0;
			gbc2.insets.left = 0;
			gbc2.insets.bottom = 5;
			gbc2.insets.top = 5;

			gbc2.gridwidth = 1;
			gbc2.gridheight = 1;
			gbc2.gridx = 0;
			gbc2.gridy = 0;

			JLabel groundName = new JLabel("Force:                 ");
			groundUnitListPanel.add(groundName, gbc2);

			gbc2.gridx = 1;

			JLabel groundInd = new JLabel("Ind:    ");
			groundUnitListPanel.add(groundInd, gbc2);

			gbc2.gridx = 2;

			JLabel groundRes = new JLabel("Res Cost:  ");
			groundUnitListPanel.add(groundRes, gbc2);

			gbc2.gridx = 3;

			JLabel groundTech = new JLabel("Tech:  ");
			groundUnitListPanel.add(groundTech, gbc2);

			gbc2.gridx = 4;

			JLabel groundMaint = new JLabel("Maint:  ");
			groundUnitListPanel.add(groundMaint, gbc2);

			gbc2.gridx = 5;

			JLabel groundDamage = new JLabel("Dam:  ");
			groundUnitListPanel.add(groundDamage, gbc2);

			gbc2.gridx = 6;

			JLabel groundArmor = new JLabel("Armor:  ");
			groundUnitListPanel.add(groundArmor, gbc2);

			gbc2.gridx = 7;

			JLabel groundSpeed = new JLabel("Speed:  ");
			groundUnitListPanel.add(groundSpeed, gbc2);

			gbc2.gridx = 8;

			JLabel groundStorage = new JLabel("Mobile:  ");
			groundUnitListPanel.add(groundStorage, gbc2);

			gbc2.gridheight = 2;
			gbc2.gridwidth = 9;
			gbc2.gridx = 0;
			gbc2.gridy = 1;

			final JList groundUnitsList = new JList(forceVector);
			ListSelectionModel lsm = groundUnitsList.getSelectionModel();
			groundUnitsList.setFont(new Font("Courier", 0, 12));
			lsm.setSelectionMode(0);
			JScrollPane scroll2 = new JScrollPane(groundUnitsList);
			groundUnitListPanel.add(scroll2, gbc2);

			groundUnitsList.setEnabled(false);

			// End Ground panel.

			showFrame.getContentPane().add(groundUnitListPanel, gbc);
		}
		else
		{
			// Space Panel.

			// Add any cargo of this ship.
			SpaceForce sf = (SpaceForce) force;

			for (int i = 0; i < sf.getStorage().size(); i++)
			{
				Unit u = (Unit) sf.getStorage().elementAt(i);

				for (int t = 0; t < u.getForces().size(); t++)
				{
					Force f = (Force) u.getForces().elementAt(t);
					forceVector.addElement(f.getDescription());
				}
			}

			JPanel spaceUnitListPanel = new JPanel();
			spaceUnitListPanel.setLayout(new GridBagLayout());

			GridBagConstraints gbc2 = new GridBagConstraints();

			gbc2.fill = GridBagConstraints.BOTH;

			gbc2.insets.right = 0;
			gbc2.insets.left = 0;
			gbc2.insets.bottom = 5;
			gbc2.insets.top = 5;

			gbc2.gridwidth = 1;
			gbc2.gridheight = 1;
			gbc2.gridx = 0;
			gbc2.gridy = 0;

			JLabel spaceName = new JLabel("Force:                 ");
			spaceUnitListPanel.add(spaceName, gbc2);

			gbc2.gridx = 1;

			JLabel spaceInd = new JLabel("Ind:    ");
			spaceUnitListPanel.add(spaceInd, gbc2);

			gbc2.gridx = 2;

			JLabel spaceRes = new JLabel("Res Cost:  ");
			spaceUnitListPanel.add(spaceRes, gbc2);

			gbc2.gridx = 3;

			JLabel spaceTech = new JLabel("Tech:  ");
			spaceUnitListPanel.add(spaceTech, gbc2);

			gbc2.gridx = 4;

			JLabel spaceMaint = new JLabel("Maint:  ");
			spaceUnitListPanel.add(spaceMaint, gbc2);

			gbc2.gridx = 5;

			JLabel spaceDamage = new JLabel("Dam:  ");
			spaceUnitListPanel.add(spaceDamage, gbc2);

			gbc2.gridx = 6;

			JLabel spaceArmor = new JLabel("Armor:  ");
			spaceUnitListPanel.add(spaceArmor, gbc2);

			gbc2.gridx = 7;

			JLabel spaceSpeed = new JLabel("Speed:  ");
			spaceUnitListPanel.add(spaceSpeed, gbc2);

			gbc2.gridx = 8;

			JLabel spaceStorage = new JLabel("Carry:  ");
			spaceUnitListPanel.add(spaceStorage, gbc2);

			gbc2.gridheight = 2;
			gbc2.gridwidth = 9;
			gbc2.gridx = 0;
			gbc2.gridy = 1;

			final JList spaceUnitsList = new JList(forceVector);
			ListSelectionModel lsm = spaceUnitsList.getSelectionModel();
			lsm.setSelectionMode(0);
			spaceUnitsList.setFont(new Font("Courier", 0, 12));
			JScrollPane scroll = new JScrollPane(spaceUnitsList);
			spaceUnitListPanel.add(scroll, gbc2);

			spaceUnitsList.setEnabled(false);

			// End Space Panel.

			showFrame.getContentPane().add(spaceUnitListPanel, gbc);
		}

		gbc.gridy = gbc.gridy + 1;
		gbc.gridx = 0;

		JButton finished = new JButton("Done");
		finished.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			showFrame.dispose();
		}});
		showFrame.getContentPane().add(finished, gbc);


		showFrame.pack();
		showFrame.show();
	}


	public void espionage()
	{
		final int max = player.getEmpire().getEspionage();
		operations = new Vector();
		final JList operationsList = new JList(operations);

 		frame = new JFrame(player.toString() + " - Espionage");
		frame.setSize(300, 650);
		frame.setResizable(false);
		frame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 4;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		frame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 4;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Espionage Phase");
		frame.getContentPane().add(waitingLabel, gbc);

		gbc.gridy = 2;
		gbc.gridwidth = 2;

		gbc.fill = GridBagConstraints.BOTH;

		final JLabel availableEspionage = new JLabel("Available Espionage: " );
		frame.getContentPane().add(availableEspionage, gbc);

		gbc.gridx = 2;

		final JLabel espionageLabel = new JLabel(""+max + " / " + player.getEmpire().getMaxEspionage());
		espionageLabel.setFont(new Font("Serif", 0, 24));
		frame.getContentPane().add(espionageLabel, gbc);

		gbc.gridx = 0;
		gbc.gridy = gbc.gridy+1;

		JLabel operationLabel = new JLabel("Espionage Operation: ");
		frame.getContentPane().add(operationLabel, gbc);

		gbc.gridx = 2;

		SecurityOperation secOp = new SecurityOperation(player, null, null);
		CounterIntelligenceOperation counterOp = new CounterIntelligenceOperation(player, null, null);
		InformationGatheringOperation info = new InformationGatheringOperation(player, null, null);
		EconomicOperation ecoOp = new EconomicOperation(player, null, null);
		IndustryOperation indOp = new IndustryOperation(player, null, null);
		TechnologyOperation techOp = new TechnologyOperation(player, null, null);

		Vector methods = new Vector();
		methods.addElement(secOp);
		methods.addElement(counterOp);
		methods.addElement(info);
		methods.addElement(ecoOp);
		methods.addElement(indOp);
		methods.addElement(techOp);

		final JComboBox operation = new JComboBox(methods);
		frame.getContentPane().add(operation, gbc);

		gbc.gridy = gbc.gridy+1;
		gbc.gridx = 0;
		gbc.gridwidth = 2;

		JLabel targetPlayerLabel = new JLabel("Choose Target Player: ");
		frame.getContentPane().add(targetPlayerLabel, gbc);

		gbc.gridx = 2;

		Vector pla = new Vector();

		for (int zz = 0; zz < map.getPlayers().size(); zz++)
		{
			Player p = (Player) map.getPlayers().elementAt(zz);

			if (!p.getName().equals(player.getName()))
			{
				pla.addElement(p);
			}
		}

		final JComboBox targetPlayers = new JComboBox(pla);
		frame.getContentPane().add(targetPlayers, gbc);

		gbc.gridy = gbc.gridy + 1;
		gbc.gridx = 0;

		JLabel targetLabel = new JLabel("Choose Target Planet: ");
		frame.getContentPane().add(targetLabel, gbc);

		gbc.gridx = 2;

		Player play = (Player) map.getPlayers().elementAt(0);

		final JComboBox targets = new JComboBox(new Vector());
		frame.getContentPane().add(targets, gbc);

		targetPlayers.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
			Player play = (Player) targetPlayers.getSelectedItem();

			targets.removeAllItems();

			if (play != null && !(((Operation)operation.getSelectedItem()).getDefensive()))
			{
				for (int z = 0; z < play.getEmpire().getPlanets().size(); z++)
				{
					Planet pl = (Planet) play.getEmpire().getPlanets().elementAt(z);

					targets.addItem(pl);
				}
			}

		}});

		operation.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
			Operation op = (Operation) operation.getSelectedItem();

			Player target = (Player) targetPlayers.getSelectedItem();

		 	targetPlayers.removeAllItems();

			/*
			if (op.getDefensive())
			{
				targetPlayers.addItem(player);
			}
			else
			{*/
				for (int z = 0; z < map.getPlayers().size(); z++)
				{
					Player p = (Player) map.getPlayers().elementAt(z);

					if (!p.getName().equals(player.getName()))
					{
						targetPlayers.addItem(p);
					}
				}

				if (target != null)
				{
					targetPlayers.setSelectedItem(target);//targetPlayers.getSelectedItem());
				}
			//}

		}});


		gbc.gridx = 0;
		gbc.gridy = gbc.gridy+1;
		gbc.gridwidth = 4;
		gbc.gridheight = 2;

		JButton execute = new JButton("Create Operation!");
		execute.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){

				Operation op = (Operation) operation.getSelectedItem();

				// Can't perform operation without enough espionage.
				if (player.getEmpire().getEspionage() < op.getCost())
				{
					JOptionPane.showMessageDialog(frame, "You do not have enough remaining espionage for this operation!","Espionage Error", JOptionPane.ERROR_MESSAGE);
				}
				else
				{

					if (targetPlayers.getSelectedItem() != null && (targets.getSelectedItem() != null || op.getDefensive()))
					{

						Operation op2 = (Operation) op.clone();

						player.getEmpire().setEspionage(player.getEmpire().getEspionage() - op.getCost());
						espionageLabel.setText(""+player.getEmpire().getEspionage() + " / " + player.getEmpire().getMaxEspionage());

						op2.setTargetPlayer((Player) targetPlayers.getSelectedItem());
						op2.setTargetPlanet((Planet) targets.getSelectedItem());

						operations.addElement(op2);

						operationsList.setListData(operations);
						operationsList.repaint();
					}
				}
		}});
		frame.getContentPane().add(execute, gbc);


		gbc.fill = GridBagConstraints.NONE;

		gbc.gridy = 9;
		gbc.gridwidth = 4;
		gbc.gridx = 0;

		JPanel espionagePanel = new JPanel();
		espionagePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Operations: "));
		espionagePanel.setLayout(new GridBagLayout());

		GridBagConstraints gbc2 = new GridBagConstraints();

		gbc2.insets.right = 5;
		gbc2.insets.left = 5;
		gbc2.insets.bottom = 5;
		gbc2.insets.top = 5;

		gbc2.gridheight = 3;
		gbc2.gridwidth = 3;
		gbc2.gridx = 0;
		gbc2.gridy = 0;

		final ListSelectionModel lsm = operationsList.getSelectionModel();
		lsm.setSelectionMode(0);
		operationsList.setFont(new Font("Sans-Serif", 0, 12));
		operationsList.setPreferredSize(new Dimension(400, 130));
		JScrollPane scrollOperations = new JScrollPane(operationsList);
		scrollOperations.setPreferredSize(new Dimension(340, 110));

		espionagePanel.add(scrollOperations, gbc2);

		gbc2.gridy = gbc2.gridy + 4;
		gbc2.gridheight = 1;

		final JLabel notes = new JLabel("<html><center>Double click on an operation to cancel it. <P>\n\nListed operations will be performed when you hit 'Done Phase'.</center></html>", 0);
		notes.setFont(new Font("Dialog", 0, 10));
		espionagePanel.add(notes, gbc2);


		ListCellRenderer operationsRenderer = new OperationRenderer();
		operationsList.setCellRenderer(operationsRenderer);


		// MouseListener for the operation list.
		MouseListener mouseListener = new MouseAdapter() {
     		public void mouseClicked(MouseEvent e) {
  		       	if (e.getClickCount() > 1)
			{
             			int index = operationsList.locationToIndex(e.getPoint());
             			//System.out.println("Clicked on Item " + index);

				Operation  op = (Operation) operationsList.getSelectedValue();

				player.getEmpire().setEspionage(player.getEmpire().getEspionage() + op.getCost());

				espionageLabel.setText(""+player.getEmpire().getEspionage() + " / " + player.getEmpire().getMaxEspionage());

				operations.removeElement(op);

				operationsList.setListData(operations);
				operationsList.repaint();

          		}
     		}};
 		operationsList.addMouseListener(mouseListener);

		frame.getContentPane().add(espionagePanel, gbc);

		frame.pack();
		frame.show();

	}

/*
	public void espionage()
	{
		final int max = player.getEmpire().getEspionage();

 		frame = new JFrame(player.toString() + " - Espionage");
		frame.setSize(350, 550);
		frame.setResizable(false);
		frame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 4;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		frame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 4;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Espionage Phase");
		frame.getContentPane().add(waitingLabel, gbc);

		gbc.gridy = 2;
		gbc.gridwidth = 2;

		gbc.fill = GridBagConstraints.BOTH;

		JLabel espionageLabel = new JLabel("Available Espionage: ");
		frame.getContentPane().add(espionageLabel, gbc);

		gbc.gridx = 2;
		gbc.gridwidth = 2;

		final SpinnerNumberModel model = new SpinnerNumberModel(max, 0, max, 1); // (0, 0, max, 1);
		final JSpinner esp = new JSpinner(model);
		JSpinner.DefaultEditor editor = (JSpinner.DefaultEditor) esp.getEditor();
		JFormattedTextField ftf = editor.getTextField();
		ftf.setEditable(false);
		ftf.setFont(new Font("Serif", 1, 16));
		frame.getContentPane().add(esp, gbc);

		gbc.gridy = 3;
		gbc.gridx = 0;

		JLabel targetLabel = new JLabel("Choose your Target: ");
		frame.getContentPane().add(targetLabel, gbc);

		gbc.gridx = 2;

		Vector planets = new Vector();

		for (int i = 0; i < map.getPlayers().size(); i++)
		{
			Player p = (Player) map.getPlayers().elementAt(i);

			if (!p.getName().equals(player.getName()))
			{
				Vector temp = p.getEmpire().getPlanets();
				for (int t = 0; t < temp.size(); t++)
				{
					Planet plan = (Planet) temp.elementAt(t);
					planets.addElement(plan);
				}
			}
		}

		Vector neutral = new Vector();

		try
		{
			neutral = psi.getEmpires();
		}
		catch (Exception e)
		{
			System.out.println("Can't get neutral empires! " + e.toString());
		}

		final Vector neutralEmpires = neutral;

		for (int i = 0; i < neutralEmpires.size(); i++)
		{
			Empire e = (Empire) neutralEmpires.elementAt(i);

			Vector temp = e.getPlanets();
			for (int t = 0; t < temp.size(); t++)
			{
				Planet plan = (Planet) temp.elementAt(t);
				planets.addElement(plan);
			}
		}

		final JComboBox targets = new JComboBox(planets);
		frame.getContentPane().add(targets, gbc);

		gbc.gridx = 0;
		gbc.gridy = 4;

		JLabel operationLabel = new JLabel("Espionage Operation: ");
		frame.getContentPane().add(operationLabel, gbc);

		gbc.gridx = 2;

		Vector methods = new Vector();
		methods.addElement("Information Gathering");
		//methods.addElement("Eco Bombing");
		methods.addElement("Steal Money");
		methods.addElement("Industry Bombing");
		methods.addElement("Technology Stealing");

		final JComboBox operation = new JComboBox(methods);
		frame.getContentPane().add(operation, gbc);

		gbc.gridx = 0;
		gbc.gridy = 5;
		gbc.gridwidth = 4;
		gbc.gridheight = 2;

		final JTextArea info = new JTextArea("Espionage Results", 9, 10);
		info.setLineWrap(true);
		info.setWrapStyleWord(true);
		info.setEditable(false);
		JScrollPane scroll2 = new JScrollPane(info);
		frame.getContentPane().add(scroll2, gbc);

		gbc.fill = GridBagConstraints.NONE;

		gbc.gridy = 7;
		gbc.gridwidth = 1;
		gbc.gridx = 2;

		JButton execute = new JButton("Execute");
		execute.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			int spent = model.getNumber().intValue();

			int finished = JOptionPane.showConfirmDialog(frame, "Spend " + spent + " " + operation.getSelectedItem() + " on " + targets.getSelectedItem() + "? \n\nFailed operations attempted on other players will be reported only to them.\n\nFailed operations attempted on Neutral planets are reported to all players.", "Confirm Espionage", JOptionPane.YES_NO_OPTION);
			if (finished == 0)
			{

			if (spent > 0)
			{
				info.setText("You spent " + spent + " " + operation.getSelectedItem()+" on " + targets.getSelectedItem() + "!");
				int newMax = ((Integer)model.getMaximum()).intValue()-spent;
				while (model.getNumber().intValue() > newMax)
				{
					model.setValue(model.getPreviousValue());
				}
				model.setMaximum(new Integer(newMax));

				Planet hit = (Planet) targets.getSelectedItem();

				Empire empire = null;

				// We search the neutral empires to find the planet.
				if (hit.getOwner().equals("Neutral"))
				{
					for (int i = 0; i < neutralEmpires.size(); i++)
					{
						empire = (Empire) neutralEmpires.elementAt(i);

						for (int t = 0; t < empire.getPlanets().size(); t++)
						{
							Planet plan = (Planet) empire.getPlanets().elementAt(t);

							if (plan.getName().equals(hit.getName()))
							{
								// We've found our neutral empire.
								t = empire.getPlanets().size();
								i = neutralEmpires.size();
							}
						}
					}

				}
				else
				{
					for (int i = 0; i < map.getPlayers().size(); i++)
					{
						Player p = (Player) map.getPlayers().elementAt(i);

						if (p.toString().equals(hit.getOwner()))
						{
							empire = p.getEmpire();
							i = map.getPlayers().size();
						}

					}
				}

				// empire now contains the empire that was spied on.

				// Operations combo box;
				// 0 - Information Gathering
				// 1 - Steal Money
				// 2 - Industry Bomb
				// 3 - Tech Stealing

				try
				{
					psi.useEspionage(player.getName(), spent);
				}
				catch (Exception f)
				{
					System.out.println("Can't use espionage!");
				}

				int extra = 0;

				if (operation.getSelectedIndex() > 0)
				{
					// extra contains the amount of damage that should be done with other forms of spying.
					extra = spent - empire.getCounterEspionage();
					extra /= 5;
				}

				if (spent <= empire.getCounterEspionage() || (operation.getSelectedIndex() > 0 && extra < 1))
				{
					info.setText(info.getText()+"\n\nYour espionage attempt has failed! \nIt will be reported to " + hit.getOwner() + ".");

					// Send public message for failure on a neutral planet.
					Message m = new Message(player.toString() + " attempted and failed to perform " + operation.getSelectedItem()+ " on " + hit.toString() + ", one of "+hit.getOwner()+"'s planets.", true);
					if (!hit.getOwner().equals("Neutral"))
					{
						m = new Message(player.toString() + " attempted and failed to perform " + operation.getSelectedItem()+ " on " + hit.toString() + ", one of "+hit.getOwner()+"'s planets.", false);
						m.addPlayer(hit.getOwner());
					}

					messages.addElement(m);//player.toString() + " attempted and failed to perform " + operation.getSelectedItem()+ " on " + hit.toString() + ", one of "+hit.getOwner()+"'s planets.");
				}

				// Espionage succeeded!
				else if ((operation.getSelectedIndex() == 0 && spent > empire.getCounterEspionage()) || (extra > 0))
				{
				info.setText(info.getText()+"\n\nYour espionage attempt against " + hit.getOwner() + " has succeeded!");

				StringBuffer results = new StringBuffer("");

				// Information Gathering

				if (operation.getSelectedIndex() == 0)
				{

					results.append("\n\nEmpire Name: " + empire.getName());
					results.append("\nTech Level: " + empire.getTech());
					results.append("\n\n" + hit.toString());
					results.append("\nEconomy: " + hit.getEconomy());
					results.append("\nIndustry: " + hit.getIndustry());

					Location l = hit.getLocation();

					for (int k = 0; k < empire.getSpaceUnits().size(); k++)
					{
						Unit u = (Unit) empire.getSpaceUnits().elementAt(k);

						if (u.getForces().size() > 0)
						{
							Location l2 = u.getLocation();

							if (l.getPositionX() == l2.getPositionX() && l.getPositionY() == l2.getPositionY())
							{
								results.append("\n\n" + u.toString());

								for (int z = 0; z < u.getForces().size(); z++)
								{
									Force f = (Force) u.getForces().elementAt(z);
									results.append("\n" + f.toString());
								}
							}
						}
					}
					for (int k = 0; k < empire.getGroundUnits().size(); k++)
					{
						Unit u = (Unit) empire.getGroundUnits().elementAt(k);

						if (u.getForces().size() > 0)
						{
							Location l2 = u.getLocation();

							if (l.getPositionX() == l2.getPositionX() && l.getPositionY() == l2.getPositionY())
							{
								results.append("\n\n" + u.toString());
								for (int z = 0; z < u.getForces().size(); z++)
								{
									Force f = (Force) u.getForces().elementAt(z);
									results.append("\n" + f.toString());
								}
							}
						}
					}
				}
				// Steal Money - EcoBombing
				else if (operation.getSelectedIndex() == 1)
				{
					// Determine damage - 3-5 * extra;
					Random r = new Random();
					int damage = (r.nextInt(5*extra-(extra*3-1))) + extra * 3;

					// Send this info to the server.
					// Prepare a message sent only to that player.

					try
					{
						damage = psi.stealMoney(hit, damage, player.getName());
					}
					catch (Exception h)
					{
						System.out.println("Can't send spy results to the server! " + h.toString());
					}

					player.getEmpire().setMoney(player.getEmpire().getMoney()+damage);

					results.append("\n\n You stole " + damage + " money from " + hit.getName()+"!");

					money.setText(""+player.getEmpire().getMoney());

				}
				// Industry Bombing
				else if (operation.getSelectedIndex() == 2)
				{
					// Determine damage - 1d4 * extra;
					Random r = new Random();
					int damage = (r.nextInt(4*extra-(extra-1))) + extra;

					results.append("\n\n You inflicted " + damage + " damage on " + hit.getName()+"'s industry!");
					// Send this info to the server.
					// Prepare a message sent only to that player.

					try
					{
						psi.industryBomb(hit, damage);
					}
					catch (Exception h)
					{
						System.out.println("Can't send spy results to the server! " + h.toString());
					}
				}
				// Tech Stealing
				else if (operation.getSelectedIndex() == 3)
				{
					if (empire.getTech() > player.getEmpire().getTech())
					{
						player.getEmpire().setTech(player.getEmpire().getTech()+extra);
						if (player.getEmpire().getTech() > empire.getTech())
						{
							player.getEmpire().setTech(empire.getTech());
						}

						results.append("\n\n You stole " + extra + " tech from " + hit.getName()+"!");
						try
						{
							psi.techSteal(player.getName(), player.getEmpire().getTech());
						}
						catch (Exception h)
						{
							System.out.println("Can't send spy results to the server! " + h.toString());
						}
					}
					else
					{
						results.append("\n\n You have nothing to gain from " + hit.getName()+"'s primitive technology!");
					}
				}

				info.setText(info.getText() + results.toString());

				}
			}
			else
		    	{
				frame.setVisible(false);
			}
			}
		}});
		frame.getContentPane().add(execute, gbc);

		gbc.gridx = 3;

		JButton cancel = new JButton("Cancel ");
		cancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			frame.setVisible(false);
		}});
		frame.getContentPane().add(cancel, gbc);

		frame.pack();
		frame.show();

	}
*/

	public void production()
	{
	    	Color c = new Color(121);

		totalIncome = player.getEmpire().getIncome();

		curFood = player.getEmpire().getFood();
		curMinerals = player.getEmpire().getMinerals();
		curGas = player.getEmpire().getGas();

 		frame = new JFrame(player.toString() + " - Production");
		frame.setSize(350, 550);
		frame.setResizable(false);
		frame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 4;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		frame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 4;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Production Phase");
		frame.getContentPane().add(waitingLabel, gbc);

		gbc.fill = GridBagConstraints.BOTH;

		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.gridwidth = 4;
		gbc.gridheight = 2;

		JPanel resourcePanel = new JPanel();
		resourcePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Resources: "));

		final JLabel prodFood = new JLabel(" Food: "+curFood);
		prodFood.setFont(new Font("Dialog", 1, 14));
		prodFood.setForeground(c.BLUE);
		resourcePanel.add(prodFood);

		final JLabel prodMinerals = new JLabel(" Min: "+curMinerals);
		prodMinerals.setFont(new Font("Dialog", 1, 14));
		prodMinerals.setForeground(c.WHITE.darker().darker());
		resourcePanel.add(prodMinerals);

		final JLabel prodGas = new JLabel(" Gas: "+curGas);
		prodGas.setFont(new Font("Dialog", 1, 14));
		prodGas.setForeground(c.RED);
		resourcePanel.add(prodGas);

		frame.getContentPane().add(resourcePanel, gbc);

		gbc.gridy = 4;
		gbc.gridheight = 2;

		JPanel spaceUnitListPanel = new JPanel();
		spaceUnitListPanel.setLayout(new GridBagLayout());

		GridBagConstraints gbc2 = new GridBagConstraints();

		gbc2.fill = GridBagConstraints.BOTH;

		gbc2.insets.right = 0;
		gbc2.insets.left = 0;
		gbc2.insets.bottom = 5;
		gbc2.insets.top = 5;

		gbc2.gridwidth = 1;
		gbc2.gridheight = 1;
		gbc2.gridx = 0;
		gbc2.gridy = 0;

		JLabel spaceName = new JLabel("Force:                ");
		spaceUnitListPanel.add(spaceName, gbc2);

		gbc2.gridx = 1;

		JLabel spaceInd = new JLabel("Ind:    ");
		spaceUnitListPanel.add(spaceInd, gbc2);

		gbc2.gridx = 2;

		JLabel spaceRes = new JLabel("Res Cost:  ");
		spaceUnitListPanel.add(spaceRes, gbc2);

		gbc2.gridx = 3;

		JLabel spaceTech = new JLabel("Tech:  ");
		spaceUnitListPanel.add(spaceTech, gbc2);

		gbc2.gridx = 4;

		JLabel spaceMaint = new JLabel("Maint:  ");
		spaceUnitListPanel.add(spaceMaint, gbc2);

		gbc2.gridx = 5;

		JLabel spaceDamage = new JLabel("Dam:  ");
		spaceUnitListPanel.add(spaceDamage, gbc2);

		gbc2.gridx = 6;

		JLabel spaceArmor = new JLabel("Armor:  ");
		spaceUnitListPanel.add(spaceArmor, gbc2);

		gbc2.gridx = 7;

		JLabel spaceSpeed = new JLabel("Speed:  ");
		spaceUnitListPanel.add(spaceSpeed, gbc2);

		gbc2.gridx = 8;

		JLabel spaceStorage = new JLabel("Carry:  ");
		spaceUnitListPanel.add(spaceStorage, gbc2);

		gbc2.gridheight = 2;
		gbc2.gridwidth = 9;
		gbc2.gridx = 0;
		gbc2.gridy = 1;

		Vector spaceDescriptions = new Vector();
		Vector groundDescriptions = new Vector();
		Vector potentialSpaceDescriptions = new Vector();
		Vector potentialGroundDescriptions = new Vector();

		for (int i = 0; i < totalSpaceForces.size(); i++)
		{
		    	SpaceForce sf = (SpaceForce) totalSpaceForces.elementAt(i);
			if (sf.getTech() <= player.getEmpire().getTech() && (sf.getExclusive().length() == 0 || sf.getExclusive().equals(player.getEmpire().getRace())))//player.getEmpire().getTech()
			{
				spaceDescriptions.addElement(sf.getDescription());
			}
		}
		for (int i = 0; i < totalGroundForces.size(); i++)
		{
		    	GroundForce gf = (GroundForce) totalGroundForces.elementAt(i);
			if (gf.getTech() <= player.getEmpire().getTech() && (gf.getExclusive().length() == 0 || gf.getExclusive().equals(player.getEmpire().getRace())))//player.getEmpire().getTech()
			{
				groundDescriptions.addElement(gf.getDescription());
			}
		}

		for (int i = 0; i < totalSpaceForces.size(); i++)
		{
		    	SpaceForce sf = (SpaceForce) totalSpaceForces.elementAt(i);
			if (sf.getExclusive().length() == 0 || sf.getExclusive().equals(player.getEmpire().getRace()))//player.getEmpire().getTech()
			{
				potentialSpaceDescriptions.addElement(sf.getDescription());
			}
		}
		for (int i = 0; i < totalGroundForces.size(); i++)
		{
		    	GroundForce gf = (GroundForce) totalGroundForces.elementAt(i);
			if (gf.getExclusive().length() == 0 || gf.getExclusive().equals(player.getEmpire().getRace()))//player.getEmpire().getTech()
			{
				potentialGroundDescriptions.addElement(gf.getDescription());
			}
		}

		final JList spaceUnitsList = new JList(spaceDescriptions);// modified Vector of total space units, containing descriptions!);
		ListSelectionModel lsm = spaceUnitsList.getSelectionModel();
		lsm.setSelectionMode(0);
		spaceUnitsList.setFont(new Font("Courier", 0, 12));
		JScrollPane scroll = new JScrollPane(spaceUnitsList);
		spaceUnitListPanel.add(scroll, gbc2);

		// Ground panel!

		JPanel groundUnitListPanel = new JPanel();
		groundUnitListPanel.setLayout(new GridBagLayout());

		gbc2 = new GridBagConstraints();

		gbc2.fill = GridBagConstraints.BOTH;

		gbc2.insets.right = 0;
		gbc2.insets.left = 0;
		gbc2.insets.bottom = 5;
		gbc2.insets.top = 5;

		gbc2.gridwidth = 1;
		gbc2.gridheight = 1;
		gbc2.gridx = 0;
		gbc2.gridy = 0;

		JLabel groundName = new JLabel("Force:                ");
		groundUnitListPanel.add(groundName, gbc2);

		gbc2.gridx = 1;

		JLabel groundInd = new JLabel("Ind:    ");
		groundUnitListPanel.add(groundInd, gbc2);

		gbc2.gridx = 2;

		JLabel groundRes = new JLabel("Res Cost:  ");
		groundUnitListPanel.add(groundRes, gbc2);

		gbc2.gridx = 3;

		JLabel groundTech = new JLabel("Tech:  ");
		groundUnitListPanel.add(groundTech, gbc2);

		gbc2.gridx = 4;

		JLabel groundMaint = new JLabel("Maint:  ");
		groundUnitListPanel.add(groundMaint, gbc2);

		gbc2.gridx = 5;

		JLabel groundDamage = new JLabel("Dam:  ");
		groundUnitListPanel.add(groundDamage, gbc2);

		gbc2.gridx = 6;

		JLabel groundArmor = new JLabel("Armor:  ");
		groundUnitListPanel.add(groundArmor, gbc2);

		gbc2.gridx = 7;

		JLabel groundSpeed = new JLabel("Speed:  ");
		groundUnitListPanel.add(groundSpeed, gbc2);

		gbc2.gridx = 8;

		JLabel groundStorage = new JLabel("Mobile:  ");
		groundUnitListPanel.add(groundStorage, gbc2);

		gbc2.gridheight = 2;
		gbc2.gridwidth = 9;
		gbc2.gridx = 0;
		gbc2.gridy = 1;

		final JList groundUnitsList = new JList(groundDescriptions);// modified Vector of total space units, containing descriptions!);
		lsm = groundUnitsList.getSelectionModel();
		groundUnitsList.setFont(new Font("Courier", 0, 12));
		lsm.setSelectionMode(0);
		JScrollPane scroll2 = new JScrollPane(groundUnitsList);
		groundUnitListPanel.add(scroll2, gbc2);

		// Potential Space Tab

		JPanel potentialSpaceUnitListPanel = new JPanel();
		potentialSpaceUnitListPanel.setLayout(new GridBagLayout());

		gbc2 = new GridBagConstraints();

		gbc2.fill = GridBagConstraints.BOTH;

		gbc2.insets.right = 0;
		gbc2.insets.left = 0;
		gbc2.insets.bottom = 5;
		gbc2.insets.top = 5;

		gbc2.gridwidth = 1;
		gbc2.gridheight = 1;
		gbc2.gridx = 0;
		gbc2.gridy = 0;

		JLabel potentialSpaceName = new JLabel("Force:                ");
		potentialSpaceUnitListPanel.add(potentialSpaceName, gbc2);

		gbc2.gridx = 1;

		JLabel potentialSpaceInd = new JLabel("Ind:    ");
		potentialSpaceUnitListPanel.add(potentialSpaceInd, gbc2);

		gbc2.gridx = 2;

		JLabel potentialSpaceRes = new JLabel("Res Cost:  ");
		potentialSpaceUnitListPanel.add(potentialSpaceRes, gbc2);

		gbc2.gridx = 3;

		JLabel potentialSpaceTech = new JLabel("Tech:  ");
		potentialSpaceUnitListPanel.add(potentialSpaceTech, gbc2);

		gbc2.gridx = 4;

		JLabel potentialSpaceMaint = new JLabel("Maint:  ");
		potentialSpaceUnitListPanel.add(potentialSpaceMaint, gbc2);

		gbc2.gridx = 5;

		JLabel potentialSpaceDamage = new JLabel("Dam:  ");
		potentialSpaceUnitListPanel.add(potentialSpaceDamage, gbc2);

		gbc2.gridx = 6;

		JLabel potentialSpaceArmor = new JLabel("Armor:  ");
		potentialSpaceUnitListPanel.add(potentialSpaceArmor, gbc2);

		gbc2.gridx = 7;

		JLabel potentialSpaceSpeed = new JLabel("Speed:  ");
		potentialSpaceUnitListPanel.add(potentialSpaceSpeed, gbc2);

		gbc2.gridx = 8;

		JLabel potentialSpaceStorage = new JLabel("Carry:  ");
		potentialSpaceUnitListPanel.add(potentialSpaceStorage, gbc2);

		gbc2.gridheight = 2;
		gbc2.gridwidth = 9;
		gbc2.gridx = 0;
		gbc2.gridy = 1;

		final JList potentialSpaceUnitsList = new JList(potentialSpaceDescriptions);// modified Vector of total space units, containing descriptions!);
		lsm = potentialSpaceUnitsList.getSelectionModel();
		potentialSpaceUnitsList.setFont(new Font("Courier", 0, 12));
		lsm.setSelectionMode(0);
		JScrollPane potentialScroll = new JScrollPane(potentialSpaceUnitsList);
		potentialSpaceUnitListPanel.add(potentialScroll, gbc2);

		potentialSpaceUnitsList.setEnabled(false);

		// End Potential Space Tab

		// Potential Ground Tab

		JPanel potentialGroundUnitListPanel = new JPanel();
		potentialGroundUnitListPanel.setLayout(new GridBagLayout());

		gbc2 = new GridBagConstraints();

		gbc2.fill = GridBagConstraints.BOTH;

		gbc2.insets.right = 0;
		gbc2.insets.left = 0;
		gbc2.insets.bottom = 5;
		gbc2.insets.top = 5;

		gbc2.gridwidth = 1;
		gbc2.gridheight = 1;
		gbc2.gridx = 0;
		gbc2.gridy = 0;

		JLabel potentialGroundName = new JLabel("Force:                ");
		potentialGroundUnitListPanel.add(potentialGroundName, gbc2);

		gbc2.gridx = 1;

		JLabel potentialGroundInd = new JLabel("Ind:    ");
		potentialGroundUnitListPanel.add(potentialGroundInd, gbc2);

		gbc2.gridx = 2;

		JLabel potentialGroundRes = new JLabel("Res Cost:  ");
		potentialGroundUnitListPanel.add(potentialGroundRes, gbc2);

		gbc2.gridx = 3;

		JLabel potentialGroundTech = new JLabel("Tech:  ");
		potentialGroundUnitListPanel.add(potentialGroundTech, gbc2);

		gbc2.gridx = 4;

		JLabel potentialGroundMaint = new JLabel("Maint:  ");
		potentialGroundUnitListPanel.add(potentialGroundMaint, gbc2);

		gbc2.gridx = 5;

		JLabel potentialGroundDamage = new JLabel("Dam:  ");
		potentialGroundUnitListPanel.add(potentialGroundDamage, gbc2);

		gbc2.gridx = 6;

		JLabel potentialGroundArmor = new JLabel("Armor:  ");
		potentialGroundUnitListPanel.add(potentialGroundArmor, gbc2);

		gbc2.gridx = 7;

		JLabel potentialGroundSpeed = new JLabel("Speed:  ");
		potentialGroundUnitListPanel.add(potentialGroundSpeed, gbc2);

		gbc2.gridx = 8;

		JLabel potentialGroundStorage = new JLabel("Mobile:  ");
		potentialGroundUnitListPanel.add(potentialGroundStorage, gbc2);

		gbc2.gridheight = 2;
		gbc2.gridwidth = 9;
		gbc2.gridx = 0;
		gbc2.gridy = 1;

		final JList potentialGroundUnitsList = new JList(potentialGroundDescriptions);// modified Vector of total space units, containing descriptions!);
		lsm = potentialGroundUnitsList.getSelectionModel();
		potentialGroundUnitsList.setFont(new Font("Courier", 0, 12));
		lsm.setSelectionMode(0);
		JScrollPane potentialScroll2 = new JScrollPane(potentialGroundUnitsList);
		potentialGroundUnitListPanel.add(potentialScroll2, gbc2);

		potentialGroundUnitsList.setEnabled(false);

		// End Potential Space Tab

		final JTabbedPane tabs = new JTabbedPane();
		tabs.add("Space Units", spaceUnitListPanel);
		tabs.add("Ground Units", groundUnitListPanel);
		tabs.add("Potential Space", potentialSpaceUnitListPanel);
		tabs.add("Potential Ground", potentialGroundUnitListPanel);

		frame.getContentPane().add(tabs, gbc);

		gbc.gridy = 6;
		gbc.gridheight = 1;
		gbc.gridwidth = 2;

		final JComboBox productionPlanets = new JComboBox(player.getEmpire().getPlanets());
		frame.getContentPane().add(productionPlanets, gbc);

		gbc.gridy = 7;

		JPanel productionPanel = new JPanel();
		productionPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Industry: "));
		final JLabel production = new JLabel(""+((Planet)productionPlanets.getSelectedItem()).getCurrentIndustry()+"/"+((Planet)productionPlanets.getSelectedItem()).getIndustry());
		production.setFont(new Font("Serif", 1, 24));
		productionPanel.add(production);
		frame.getContentPane().add(productionPanel, gbc);

		productionPlanets.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
			Planet p = (Planet) productionPlanets.getSelectedItem();
			production.setText(""+p.getCurrentIndustry() + "/" + p.getIndustry());
		}});

		gbc.gridy = 6;
		gbc.gridwidth = 2;
		gbc.gridx = 2;

		JLabel currentOrder = new JLabel("Current Order: ");
		frame.getContentPane().add(currentOrder, gbc);

		gbc.gridy = 7;
		gbc.gridheight = 3;

		final JList orderList = new JList();
		lsm = orderList.getSelectionModel();
		lsm.setSelectionMode(0);
		JScrollPane scroll3 = new JScrollPane(orderList);
		frame.getContentPane().add(scroll3, gbc);

		gbc.gridy = 8;
		gbc.gridx = 0;
		gbc.gridheight = 1;

		final Vector orders = new Vector();

		JButton order = new JButton(" Order! ");
		order.setFont(new Font("Sans-Serif", 1, 14));
		order.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			String s = "";
			if (tabs.getSelectedIndex() == 0)
			{
				s = (String) spaceUnitsList.getSelectedValue();
				s = s.substring(0, s.indexOf("  "));
				s = s.trim();
				int ind = ((Planet)productionPlanets.getSelectedItem()).getCurrentIndustry();

				SpaceForce sf = (SpaceForce) createForce(s, totalSpaceForces);

				if (sf.getIndustry() > ind)//<= ind
				{
					JOptionPane.showMessageDialog(frame, "You do not have enough remaining industry to build this unit on the selected planet!","Building Error", JOptionPane.ERROR_MESSAGE);
				}
				else if (sf.getFood() <= curFood && sf.getGas() <= curGas && sf.getMinerals() <= curMinerals)
				{

					// Check if the space is clear of enemies.

					boolean clear = true;

					Location loc = ((Planet)productionPlanets.getSelectedItem()).getLocation();

					for (int check = 0; check < map.getPlayers().size(); check++)
					{
						Player play = (Player) map.getPlayers().elementAt(check);

						if (!play.getName().equals(player.getName()))
						{

							for (int check2 = 0; check2 < play.getEmpire().getSpaceUnits().size(); check2++)
							{
								Unit un = (Unit) play.getEmpire().getSpaceUnits().elementAt(check2);

								if (un.getForces().size() > 0)
								{

									Location loc2 = un.getLocation();

									if (loc.getPositionX() == loc2.getPositionX() && loc.getPositionY() == loc2.getPositionY())
									{
										clear = false;
									}

								}

							}
						}
					}


					if (clear)
					{

						// Check so one cannot build units into debt.

						if ((totalIncome - sf.getMaintenance()) >= 0)
						{

				   	 		s = s + "//space--"+((Planet)productionPlanets.getSelectedItem()).getName();
							orders.addElement(s);
							orderList.setListData(orders);

							ind = ind - sf.getIndustry();
							curFood -= sf.getFood();
							curMinerals -= sf.getMinerals();
							curGas -= sf.getGas();
							totalIncome -= sf.getMaintenance();

							((Planet)productionPlanets.getSelectedItem()).setCurrentIndustry(ind);
							production.setText("" + ind + "/"+((Planet)productionPlanets.getSelectedItem()).getIndustry());
							prodFood.setText(" Food: " + curFood);
							prodMinerals.setText(" Min: " + curMinerals);
							prodGas.setText(" Gas: " + curGas);
						}
						else
						{
							JOptionPane.showMessageDialog(frame, "You cannot build space units that will put your empire into debt!","Building Error", JOptionPane.ERROR_MESSAGE);
						}
					}
					else
					{
						JOptionPane.showMessageDialog(frame, "You cannot build space units with enemy units overhead!","Building Error", JOptionPane.ERROR_MESSAGE);
					}
				}
				else
				{
					JOptionPane.showMessageDialog(frame, "You do not have enough remaining resources to build this unit!","Building Error", JOptionPane.ERROR_MESSAGE);
				}


			}
			else if (tabs.getSelectedIndex() == 1)
			{
				s = (String) groundUnitsList.getSelectedValue();
				s = s.substring(0, s.indexOf("  "));
				s = s.trim();
				int ind = ((Planet)productionPlanets.getSelectedItem()).getCurrentIndustry();

				String sPlanet = ((Planet)productionPlanets.getSelectedItem()).getName();

				GroundForce gf = (GroundForce) createForce(s, totalGroundForces);

				if (gf.getIndustry() > ind)
				{
					JOptionPane.showMessageDialog(frame, "You do not have enough remaining industry to build this unit on the selected planet!","Building Error", JOptionPane.ERROR_MESSAGE);
				}

				else if (gf.getFood() <= curFood && gf.getGas() <= curGas && gf.getMinerals() <= curMinerals)
				{
					// Check unit cost and such here.
					if ((totalIncome - gf.getMaintenance()) >= 0 || sPlanet.equals("Warchor")) //|| (player.getEmpire().getRace().equals("Warchor") && ((Planet)productionPlanets.getSelectedItem()).getName().equals("Warchor")) )
					{

					    	s = s + "//ground--"+((Planet)productionPlanets.getSelectedItem()).getName();
						orders.addElement(s);
						orderList.setListData(orders);

						ind = ind - gf.getIndustry();
						curFood -= gf.getFood();
						curMinerals -= gf.getMinerals();
						curGas -= gf.getGas();

						if (!sPlanet.equals("Warchor"))
						{
							totalIncome -= gf.getMaintenance();
						}

						((Planet)productionPlanets.getSelectedItem()).setCurrentIndustry(ind);
						production.setText("" + ind+"/"+((Planet)productionPlanets.getSelectedItem()).getIndustry());
						prodFood.setText(" Food: " + curFood);
						prodMinerals.setText(" Min: " + curMinerals);
						prodGas.setText(" Gas: " + curGas);
					}
					else
					{
						JOptionPane.showMessageDialog(frame, "You cannot build ground units that will put you into debt!","Building Error", JOptionPane.ERROR_MESSAGE);
					}
				}
				else
				{
					JOptionPane.showMessageDialog(frame, "You do not have enough remaining resources to build this unit!","Building Error", JOptionPane.ERROR_MESSAGE);
				}
			}
		}});
		frame.getContentPane().add(order, gbc);

		gbc.gridy = 9;
		JButton returnOrder = new JButton(" Return ");
		returnOrder.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			if (orderList.getSelectedIndex() != -1)
			{
				String s = (String) orderList.getSelectedValue();
				String sName = s.substring(0, s.indexOf("//"));
				String sType = s.substring(s.indexOf("//")+2, s.indexOf("--"));
				String sPlanet = s.substring(s.indexOf("--")+2, s.length());

				Vector temp = totalSpaceForces;
				if (sType.equals("ground"))
				{
					temp = totalGroundForces;
				}

				Force f = (Force) createForce(sName, temp);

				for (int pl = 0; pl < productionPlanets.getItemCount(); pl++)
				{
					Planet plane = (Planet) productionPlanets.getItemAt(pl);

					// Restore industry.
					if (plane.getName().equals(sPlanet))
					{
						plane.setCurrentIndustry(plane.getCurrentIndustry() + f.getIndustry());
						if (productionPlanets.getSelectedIndex() == pl)
						{
							production.setText("" + plane.getCurrentIndustry() + "/" +((Planet)productionPlanets.getSelectedItem()).getIndustry());
						}
					}
				}

				// Return the resource costs of this force.

				curFood += f.getFood();
				curMinerals += f.getMinerals();
				curGas += f.getGas();

				if (!sPlanet.equals("Warchor"))
				{
					totalIncome += f.getMaintenance();
				}

				prodFood.setText(" Food: " + curFood);
				prodMinerals.setText(" Min: " + curMinerals);
				prodGas.setText(" Gas: " + curGas);

				orders.removeElement(s);
				orderList.setListData(orders);
			}
			else
			{
				JOptionPane.showMessageDialog(frame, "You must select one of the forces you ordered to return!","Return Error", JOptionPane.ERROR_MESSAGE);
			}
		}});
		returnOrder.setFont(new Font("Sans-Serif", 1, 14));
		frame.getContentPane().add(returnOrder, gbc);


		gbc.fill = GridBagConstraints.NONE;

		gbc.gridx = 2;
		gbc.gridy = gbc.gridy+1;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;

		executeProduction = new JButton("Execute");
		executeProduction.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			frame.setVisible(false); // Moved to prevent double clicking.
			for (int i = 0; i < orders.size(); i++)
			{
				String s = (String) orders.elementAt(i);
				String sName = s.substring(0, s.indexOf("//"));
				String sType = s.substring(s.indexOf("//")+2, s.indexOf("--"));
				String sPlanet = s.substring(s.indexOf("--")+2, s.length());

				Vector temp = totalSpaceForces;
				if (sType.equals("ground"))
				{
					temp = totalGroundForces;
				}
				Force f = (Force) createForce(sName, temp);

				Location l = null;
				Planet p = null;

				for (int k = 0; k < player.getEmpire().getPlanets().size(); k++)
			 	{
			 		p = (Planet) player.getEmpire().getPlanets().elementAt(k);
			 		if (p.getName().equals(sPlanet))
			 		{
			 			l = p.getLocation();
			 		}
			 	}


				boolean created = false;
				if (sType.equals("space"))
				{
					// Add movement for Hyper-LSD;
					if (player.getEmpire().getTech() > 44 && f.getMobile())
					{
						f.hyperLSD();
					}

					for (int k = 0; k < player.getEmpire().getSpaceUnits().size(); k++)
					{
						Unit u = (Unit) player.getEmpire().getSpaceUnits().elementAt(k);
						if ((u.isEmpty() || (u.getLocation().getPositionX() == l.getPositionX() && u.getLocation().getPositionY() == l.getPositionY())) && !created)
						{
							created = true;
							u.addForce(f);

							u.setLocation(l);

							// an attempt
							/*
							if (!l.getUnits().contains(u))
							{
																							l.addUnit(u);
								u.setLocation(l); // New addition
							}
							*/

						}
					}
					if (!created)
					{
						Unit newU = new Unit("New Unit " + player.getNewUnitCounter(), player.toString());
						newU.addForce(f);
						newU.setLocation(l);
						l.addUnit(newU);
						player.getEmpire().addSpaceUnit(newU);
					}
				}
				if (sType.equals("ground"))
				{
					for (int k = 0; k < player.getEmpire().getGroundUnits().size(); k++)
					{
						Unit u = (Unit) player.getEmpire().getGroundUnits().elementAt(k);
						if ((u.isEmpty() || (u.getLocation().getPositionX() == l.getPositionX() && u.getLocation().getPositionY() == l.getPositionY() && !u.getLoaded())) && !created)// && !u.getLoaded())
						{
							created = true;
							u.addForce(f);
							u.setLocation(l);
							u.setLoaded(false);

							// an attempt
							/*
							if (!l.getUnits().contains(u))
							{
								l.addUnit(u);
							}
							*/
						}
					}
					if (!created)
					{
						Unit newU = new Unit("New Unit " + player.getNewUnitCounter(), player.toString());
						newU.addForce(f);
						newU.setLocation(l);
						l.addUnit(newU);
						player.getEmpire().addGroundUnit(newU);
					}
				}

			}

			player.getEmpire().setFood(curFood);
			player.getEmpire().setGas(curGas);
			player.getEmpire().setMinerals(curMinerals);
			player.getEmpire().calculateMaintenance();

			Vector blank = new Vector();
			orderList.setListData(blank);
			currentUnitList.repaint();
			currentGroundList.repaint();

			// Reversed for Donna's blazingly fast laptop.
			if (!doneTurn)
			{
				addUnit = true;
				loop = false;
			}
			doneTurn = false;

		}});
		frame.getContentPane().add(executeProduction, gbc);

		gbc.gridx = 3;

		JButton cancel = new JButton("Cancel ");
		cancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			frame.setVisible(false);
		}});
		frame.getContentPane().add(cancel, gbc);

		frame.pack();
		frame.show();

	}

	// Opens a window for market phase.
	//
	// A JList containing offers.
	// When you highlight your own, the Accept and Reject buttons light up.
	// Other people can bid on the items, and set up new offers using spinners.

	public void market()
	{
		done.setEnabled(false);
		disable();

	    Color c = new Color(121);

		oFood = player.getEmpire().getFood();
		oMinerals = player.getEmpire().getMinerals();
		oGas = player.getEmpire().getGas();
		oMoney = player.getEmpire().getMoney();

		if (oMoney < 0)
		{
			oMoney = 0;
		}

 		frame = new JFrame(player.toString() + " - Market");
		frame.setSize(650, 550);//450, 550);
		frame.setResizable(false);
		frame.getContentPane().setLayout(new GridBagLayout());
		frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 4;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		frame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 4;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Market Phase", 0);
		waitingLabel.setFont(new Font("Serif", 1, 22));
		frame.getContentPane().add(waitingLabel, gbc);

		gbc.fill = GridBagConstraints.BOTH;

		gbc.gridy = 2;

		JPanel resourcePanel = new JPanel();
		resourcePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Make an Offer: "));
		resourcePanel.setLayout(new GridBagLayout());

		GridBagConstraints gbc3 = new GridBagConstraints();

		gbc3.insets.right = 5;
		gbc3.insets.left = 5;
		gbc3.insets.bottom = 5;
		gbc3.insets.top = 5;

		gbc3.gridheight = 1;
		gbc3.gridwidth = 2;
		gbc3.gridx = 0;
		gbc3.gridy = 0;

		JLabel offerLabel = new JLabel("Offer", 0);
		offerLabel.setFont(new Font("Dialog", 1, 18));
		resourcePanel.add(offerLabel, gbc3);

		gbc3.gridwidth = 1;
		gbc3.gridy = 1;

		final JLabel prodFood = new JLabel(" Food: "+oFood);
		prodFood.setFont(new Font("Dialog", 1, 14));
		prodFood.setForeground(c.BLUE);
		resourcePanel.add(prodFood, gbc3);

		gbc3.gridy = 2;

		final JLabel prodMinerals = new JLabel(" Min: "+oMinerals);
		prodMinerals.setFont(new Font("Dialog", 1, 14));
		prodMinerals.setForeground(c.WHITE.darker().darker());
		resourcePanel.add(prodMinerals, gbc3);

		gbc3.gridy = 3;

		final JLabel prodGas = new JLabel(" Gas: "+oGas);
		prodGas.setFont(new Font("Dialog", 1, 14));
		prodGas.setForeground(c.RED);
		resourcePanel.add(prodGas, gbc3);

		gbc3.gridy = 4;

		final JLabel prodMoney = new JLabel(" Money: "+oMoney);
		prodMoney.setFont(new Font("Dialog", 1, 14));
		prodMoney.setForeground(c.GREEN.darker());
		resourcePanel.add(prodMoney, gbc3);

		gbc3.gridx = 1;
		gbc3.gridy = 1;

		final SpinnerNumberModel foodModel = new SpinnerNumberModel(0, 0, oFood, 1);
		final JSpinner foodSpinner = new JSpinner(foodModel);
		JSpinner.DefaultEditor editor = (JSpinner.DefaultEditor) foodSpinner.getEditor();
		JFormattedTextField ftf = editor.getTextField();
		ftf.setEditable(false);
		ftf.setFont(new Font("Serif", 1, 12));
		ftf.setForeground(c.BLUE);
		resourcePanel.add(foodSpinner, gbc3);

		gbc3.gridx = 1;
		gbc3.gridy = 2;

		final SpinnerNumberModel minModel = new SpinnerNumberModel(0, 0, oMinerals, 1);
		final JSpinner minSpinner = new JSpinner(minModel);
		JSpinner.DefaultEditor editor3 = (JSpinner.DefaultEditor) minSpinner.getEditor();
		JFormattedTextField ftf3 = editor3.getTextField();
		ftf3.setEditable(false);
		ftf3.setFont(new Font("Serif", 1, 12));
		ftf3.setForeground(c.WHITE.darker().darker());
		resourcePanel.add(minSpinner, gbc3);

		gbc3.gridx = 1;
		gbc3.gridy = 3;

		final SpinnerNumberModel gasModel = new SpinnerNumberModel(0, 0, oGas, 1);
		final JSpinner gasSpinner = new JSpinner(gasModel);
		JSpinner.DefaultEditor editor2 = (JSpinner.DefaultEditor) gasSpinner.getEditor();
		JFormattedTextField ftf2 = editor2.getTextField();
		ftf2.setEditable(false);
		ftf2.setFont(new Font("Serif", 1, 12));
		ftf2.setForeground(c.RED);
		resourcePanel.add(gasSpinner, gbc3);

		gbc3.gridx = 1;
		gbc3.gridy = 4;

		final SpinnerNumberModel moneyModel = new SpinnerNumberModel(0, 0, oMoney, 1);
		final JSpinner moneySpinner = new JSpinner(moneyModel);
		JSpinner.DefaultEditor editor4 = (JSpinner.DefaultEditor) moneySpinner.getEditor();
		JFormattedTextField ftf4 = editor4.getTextField();
		ftf4.setEditable(false);
		ftf4.setFont(new Font("Serif", 1, 12));
		ftf4.setForeground(c.GREEN.darker());
		resourcePanel.add(moneySpinner, gbc3);

		gbc3.gridx = 2;
		gbc3.gridy = 0;
		gbc3.gridheight = 5;

		gbc3.fill = GridBagConstraints.BOTH;

		JLabel forLabel = new JLabel("For", 0);
		forLabel.setFont(new Font("Dialog", 1, 24));
		resourcePanel.add(forLabel, gbc3);

		gbc3.gridheight = 1;
		gbc3.gridx = 3;
		gbc3.gridy = 0;

		JLabel dealLabel = new JLabel("Desired Deal");
		dealLabel.setFont(new Font("Dialog", 1, 18));
		resourcePanel.add(dealLabel, gbc3);

		gbc3.gridy = 1;

		final SpinnerNumberModel foodPriceModel = new SpinnerNumberModel(0, 0, 99999, 1);
		final JSpinner foodPriceSpinner = new JSpinner(foodPriceModel);
		JSpinner.DefaultEditor editor5 = (JSpinner.DefaultEditor) foodPriceSpinner.getEditor();
		JFormattedTextField ftf5 = editor5.getTextField();
		ftf5.setEditable(false);
		ftf5.setFont(new Font("Serif", 1, 12));
		ftf5.setForeground(c.BLUE);
		resourcePanel.add(foodPriceSpinner, gbc3);

		gbc3.gridy = 2;

		final SpinnerNumberModel minPriceModel = new SpinnerNumberModel(0, 0, 99999, 1);
		final JSpinner minPriceSpinner = new JSpinner(minPriceModel);
		JSpinner.DefaultEditor editor7 = (JSpinner.DefaultEditor) minPriceSpinner.getEditor();
		JFormattedTextField ftf7 = editor7.getTextField();
		ftf7.setEditable(false);
		ftf7.setFont(new Font("Serif", 1, 12));
		ftf7.setForeground(c.WHITE.darker().darker());
		resourcePanel.add(minPriceSpinner, gbc3);

		gbc3.gridy = 3;

		final SpinnerNumberModel gasPriceModel = new SpinnerNumberModel(0, 0, 99999, 1);
		final JSpinner gasPriceSpinner = new JSpinner(gasPriceModel);
		JSpinner.DefaultEditor editor6 = (JSpinner.DefaultEditor) gasPriceSpinner.getEditor();
		JFormattedTextField ftf6 = editor6.getTextField();
		ftf6.setEditable(false);
		ftf6.setFont(new Font("Serif", 1, 12));
		ftf6.setForeground(c.RED);
		resourcePanel.add(gasPriceSpinner, gbc3);

		gbc3.gridy = 4;

		final SpinnerNumberModel moneyPriceModel = new SpinnerNumberModel(0, 0, 99999, 1);
		final JSpinner moneyPriceSpinner = new JSpinner(moneyPriceModel);
		JSpinner.DefaultEditor editor8 = (JSpinner.DefaultEditor) moneyPriceSpinner.getEditor();
		JFormattedTextField ftf8 = editor8.getTextField();
		ftf8.setEditable(false);
		ftf8.setFont(new Font("Serif", 1, 12));
		ftf8.setForeground(c.GREEN.darker());
		resourcePanel.add(moneyPriceSpinner, gbc3);

		gbc3.fill = GridBagConstraints.BOTH;

		gbc3.gridy = 5;
		gbc3. gridx = 0;
		gbc3.gridwidth = 5;

		JButton offerDeal = new JButton("  Make Offer  ");
		offerDeal.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				try
				{
					// Grabbing values from spinners to make the deal.
					Offer offer = new Offer(player.getName(), foodModel.getNumber().intValue(), minModel.getNumber().intValue(), gasModel.getNumber().intValue(), moneyModel.getNumber().intValue(), foodPriceModel.getNumber().intValue(), minPriceModel.getNumber().intValue(), gasPriceModel.getNumber().intValue(), moneyPriceModel.getNumber().intValue());
					System.out.println("Made offer! " + offer.toString());
					psi.addOffer(player.getName(), offer);

					// Setting sliders back to zero.

					foodModel.setValue(new Integer(0));
					gasModel.setValue(new Integer(0));
					minModel.setValue(new Integer(0));
					moneyModel.setValue(new Integer(0));

					foodPriceModel.setValue(new Integer(0));
					gasPriceModel.setValue(new Integer(0));
					minPriceModel.setValue(new Integer(0));
					moneyPriceModel.setValue(new Integer(0));
				}
				catch (Exception f)
				{
					System.out.println("Can't create offer! " + f.toString());
				}

		}});
		offerDeal.setFont(new Font("Sans-Serif", 1, 14));

		resourcePanel.add(offerDeal, gbc3);

		frame.getContentPane().add(resourcePanel, gbc);

		GridBagConstraints gbc2 = new GridBagConstraints();


		gbc2.insets.right = 5;
		gbc2.insets.left = 5;
		gbc2.insets.bottom = 5;
		gbc2.insets.top = 5;


		gbc2.gridheight = 1;
		gbc2.gridwidth = 3;
		gbc2.gridx = 0;
		gbc2.gridy = 0;

		JPanel offerPanel = new JPanel();
		offerPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Market: "));
		offerPanel.setLayout(new GridBagLayout());

		final JLabel marketers = new JLabel("On the market: ", 0);
		marketers.setFont(new Font("Dialog", 0, 7));
		offerPanel.add(marketers, gbc2);

		gbc2.gridy = 1;

		final JList offers = new JList(new Vector());
		final ListSelectionModel lsm = offers.getSelectionModel();
		lsm.setSelectionMode(0);
		offers.setFont(new Font("Sans-Serif", 0, 12));
		offers.setPreferredSize(new Dimension(520, 130));
		JScrollPane scrollOffers = new JScrollPane(offers);
		scrollOffers.setPreferredSize(new Dimension(530, 110));

		ListCellRenderer dealRenderer = new DealRenderer();
		offers.setCellRenderer(dealRenderer);

		offerPanel.add(scrollOffers, gbc2);

		gbc2.gridwidth = 3;
		gbc2.gridheight = 1;
		gbc2.gridy = 2;//1;

		JPanel buttonPanel = new JPanel();

		final JButton acceptOffer = new JButton("  Accept  ");
		final JButton rejectOffer = new JButton("  Reject  ");
		final JButton withdrawOffer = new JButton(" Withdraw ");

		acceptOffer.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				try
				{
					acceptOffer.setEnabled(false);
					rejectOffer.setEnabled(false);
					withdrawOffer.setEnabled(false);

					Offer offer = (Offer) offers.getSelectedValue();

					// Checking that you meet the requirements.
					if (!offer.getFull())
					{
						if (oFood >= offer.getDFood() && oMinerals >= offer.getDMinerals() && oGas >= offer.getDGas() && oMoney >= offer.getDMoney())
						{
							psi.acceptOffer(player.getName(), offer.getId());
						}
						else
						{
							System.out.println("You don't have enough resources for this trade!");
							JOptionPane.showMessageDialog(frame, "You do not have enough resources for that trade!","Market Error", JOptionPane.ERROR_MESSAGE);
						}
					}
					else
					{
						psi.acceptOffer(player.getName(), offer.getId());
					}
				}
				catch (Exception f)
				{
					System.out.println("Can't accept the offer! " + f.toString());
				}
		}});
		acceptOffer.setFont(new Font("Sans-Serif", 1, 12));

		buttonPanel.add(acceptOffer);


		rejectOffer.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				try
				{
					acceptOffer.setEnabled(false);
					rejectOffer.setEnabled(false);
					withdrawOffer.setEnabled(false);

					Offer offer = (Offer) offers.getSelectedValue();
					psi.rejectOffer(player.getName(), offer.getId());
				}
				catch (Exception f)
				{
					System.out.println("Can't reject the offer! " + f.toString());
				}
		}});
		rejectOffer.setFont(new Font("Sans-Serif", 1, 12));

		buttonPanel.add(rejectOffer);

		withdrawOffer.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				try
				{
					acceptOffer.setEnabled(false);
					rejectOffer.setEnabled(false);
					withdrawOffer.setEnabled(false);

					Offer offer = (Offer) offers.getSelectedValue();
					psi.withdrawOffer(player.getName(), offer.getId());
				}
				catch (Exception f)
				{
					System.out.println("Can't withdraw the offer! " + f.toString());
				}
		}});
		withdrawOffer.setFont(new Font("Sans-Serif", 1, 12));

		buttonPanel.add(withdrawOffer);

		acceptOffer.disable();
		rejectOffer.disable();
		withdrawOffer.disable();

		offerPanel.add(buttonPanel, gbc2);

	    	gbc.gridy = 3;

		frame.getContentPane().add(offerPanel, gbc);

		gbc.gridy = 4;

		JLabel warning = new JLabel("Hitting 'Done' will withdraw you from all incomplete offers!", 0);
		warning.setFont(new Font("Serif", 1, 10));
		warning.setForeground(c.RED);

		frame.getContentPane().add(warning, gbc);

		gbc.gridy = 5;

		JButton done2 = new JButton(" Done ");
		done2.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				try
				{

					int finished = JOptionPane.showConfirmDialog(frame, "Clicking done will withdraw you from all unconfirmed offers and end your market phase.  \n\nDo you still wish to be done?", "Confirm Done", JOptionPane.YES_NO_OPTION);
					System.out.println("Finished - " +finished);
					if (finished == 0)
					{

						// Withdraw from all offers that are not confirmed.

						for (int i =0; i < offers.getModel().getSize(); i++)
						{
							offers.setSelectedIndex(i);
							Offer offer = (Offer) offers.getSelectedValue();

							if (!offer.getConfirmed())
							{
								psi.withdrawOffer(player.getName(), offer.getId());
							}
						}

						player = psi.getPlayer(player.getName());
						frame.setVisible(false);
					}
				}
				catch (Exception f)
				{
					System.out.println("Could not withdraw from all offers!");
				}
		}});
		done2.setFont(new Font("Sans-Serif", 1, 16));

		// MouseListener for the offer panel - activate or deactivate buttons as necessary.
		MouseListener mouseListener = new MouseAdapter() {
     		public void mouseClicked(MouseEvent e) {
  		       	if (e.getClickCount() > 0)
			{
             			int index = offers.locationToIndex(e.getPoint());
             			System.out.println("Clicked on Item " + index);

				Offer offer = (Offer) offers.getSelectedValue();

				withdrawOffer.setEnabled(false);//disable();
				acceptOffer.setEnabled(false);//disable();
				rejectOffer.setEnabled(false);//disable();

				if (player.getName().equals(offer.getOne()))
				{
					withdrawOffer.setEnabled(true);
					// Offer is full, so we can accept, reject or withdraw.
					if (offer.getFull())
					{
						if (!offer.getConfirmed())
						{
							acceptOffer.setEnabled(true);
							rejectOffer.setEnabled(true);
						}
						else
						{
							withdrawOffer.setEnabled(false);
						}
					}
				}
				else
				{
					if (!offer.getFull())
					{
						acceptOffer.setEnabled(true);
					}
				}
          		}
     		}};
 		offers.addMouseListener(mouseListener);



		frame.getContentPane().add(done2, gbc);

		frame.pack();
		frame.show();

		while (frame.isVisible())
		{
			// Grab information from the server about offers and resources.

			try
			{

				int index = offers.getSelectedIndex();
				Offer o = (Offer) offers.getSelectedValue();

				Vector offersVector = psi.getOffers();
				offers.setListData(offersVector);

				// Restoring the selected item.
				if (index > -1)
				{
					String id = o.getId();

					for (int i = 0; i < offersVector.size(); i++)
					{
						Offer offer = (Offer) offersVector.elementAt(i);

						if (id.equals(offer.getId()))
						{
							offers.setSelectedIndex(i);
						}
					}
				}

				if (offers.getSelectedIndex() < 0)
				{
					acceptOffer.setEnabled(false);//disable();
					rejectOffer.setEnabled(false);//disable();
					withdrawOffer.setEnabled(false);//disable();
				}

				player = psi.getPlayer(player.getName());

				// Set new label values.


				oFood = player.getEmpire().getFood();
				oGas = player.getEmpire().getGas();
				oMinerals = player.getEmpire().getMinerals();
				oMoney = player.getEmpire().getMoney();

				if (oMoney < 0)
				{
					oMoney = 0;
				}


				prodFood.setText(" Food: "+player.getEmpire().getFood());
				prodMinerals.setText(" Min: "+player.getEmpire().getMinerals());
				prodGas.setText(" Gas: "+player.getEmpire().getGas());
				prodMoney.setText(" Money: "+oMoney);//+player.getEmpire().getMoney());

				// Setting new maximums for the spinners.

				foodModel.setMaximum(new Integer(oFood));
				if (foodModel.getNumber().intValue() > oFood)
				{
					foodModel.setValue(new Integer(0));
					gasModel.setValue(new Integer(0));
					minModel.setValue(new Integer(0));
					moneyModel.setValue(new Integer(0));	foodModel.setValue(new Integer(oFood));
				}

				gasModel.setMaximum(new Integer(oGas));
				if (gasModel.getNumber().intValue() > oGas)
				{
					gasModel.setValue(new Integer(oGas));
				}

				minModel.setMaximum(new Integer(oMinerals));
				if (minModel.getNumber().intValue() > oMinerals)
				{
					minModel.setValue(new Integer(oMinerals));
				}

				moneyModel.setMaximum(new Integer(oMoney));
				if (moneyModel.getNumber().intValue() > oMoney)
				{
					moneyModel.setValue(new Integer(oMoney));
				}

				// Update the marketers label;
				int[] progress = psi.getProgress();
				String market = "On the market: ";

				Vector playList = psi.getPlayers();

				for (int i = 0; i < playList.size(); i++)//map.getPlayers().size(); i++)
				{
					Player p = (Player) playList.elementAt(i);//map.getPlayers().elementAt(i);

					if (progress[i] != 5)
					{
						market += p.toString() + " ";
					}
				}

				marketers.setText(market);

				Thread.sleep(1000);
			}
			catch (Exception e)
			{
				System.out.println("Can't sleep! " + e.toString());
			}

		}

		// End the phase.
		doneButton();

	}


	public void improvement()
	{

	    	max2 = player.getEmpire().getMoney();

		if (max2 < 0)
		{
			max2 = 0;
		}

		final int totalMax = max2;

		// For the sake of tech, this boolean indicates if you own Tortalus.
		boolean tortalus = false;

		Color c = new Color(121);

 		frame = new JFrame(player.toString() + " - Improvement");
		frame.setSize(350, 550);
		frame.setResizable(false);
		frame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 4;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		frame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 4;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Improvement Phase");
		frame.getContentPane().add(waitingLabel, gbc);

		gbc.gridy = 2;
		gbc.gridwidth = 4;

		gbc.fill = GridBagConstraints.BOTH;

		JPanel moneyPanel = new JPanel();
		moneyPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Money: "));
		final JLabel availableMoney = new JLabel(""+max2);
		availableMoney.setFont(new Font("Dialog", 2, 24));
		availableMoney.setForeground(c.GREEN.darker());
		moneyPanel.add(availableMoney);
		frame.getContentPane().add(moneyPanel, gbc);

		gbc.gridy = 3;
		gbc.gridwidth = 2;

		JLabel tec = new JLabel("Technology (5): ");
		frame.getContentPane().add(tec, gbc);

		gbc.gridx = 2;

		final SpinnerNumberModel techModel = new SpinnerNumberModel(player.getEmpire().getTech(), player.getEmpire().getTech(), player.getEmpire().getTech()+max2/5, 1);
		final JSpinner techSpinner = new JSpinner(techModel);
		JSpinner.DefaultEditor editor = (JSpinner.DefaultEditor) techSpinner.getEditor();
		JFormattedTextField ftf = editor.getTextField();
		ftf.setEditable(false);
		ftf.setFont(new Font("Serif", 1, 16));
		frame.getContentPane().add(techSpinner, gbc);

		gbc.gridy = 4;
		gbc.gridx = 0;

		JLabel esp = new JLabel("Espionage (5): ");
		frame.getContentPane().add(esp, gbc);

		gbc.gridx = 2;

		final SpinnerNumberModel espionageModel = new SpinnerNumberModel(player.getEmpire().getEspionage(), player.getEmpire().getEspionage(), player.getEmpire().getEspionage()+max2/5, 1);
		final JSpinner espionageSpinner = new JSpinner(espionageModel);
		editor = (JSpinner.DefaultEditor) espionageSpinner.getEditor();
		ftf = editor.getTextField();
		ftf.setEditable(false);
		ftf.setFont(new Font("Serif", 1, 16));
		frame.getContentPane().add(espionageSpinner, gbc);

		gbc.gridy = 5;
		gbc.gridx = 0;

		/*

		JLabel counterEsp = new JLabel("Counter-Esp (4): ");
		frame.getContentPane().add(counterEsp, gbc);

		gbc.gridx = 2;

		final SpinnerNumberModel counterEspionageModel = new SpinnerNumberModel(player.getEmpire().getCounterEspionage(), player.getEmpire().getCounterEspionage(), player.getEmpire().getCounterEspionage()+max2/4, 1);
		final JSpinner counterEspionageSpinner = new JSpinner(counterEspionageModel);
		editor = (JSpinner.DefaultEditor) counterEspionageSpinner.getEditor();
		ftf = editor.getTextField();
		ftf.setEditable(false);
		ftf.setFont(new Font("Serif", 1, 16));
		frame.getContentPane().add(counterEspionageSpinner, gbc);

		*/

		final Vector planetEconomyModels = new Vector();
		final Vector planetIndustryModels = new Vector();


		JPanel planetsPanel = new JPanel();
		planetsPanel.setLayout(new GridBagLayout());

		gbc.gridy = 0;

		for (int i = 0; i < player.getEmpire().getPlanets().size(); i++)
		{

			Planet p = (Planet) player.getEmpire().getPlanets().elementAt(i);

			gbc.gridx = 0;
			gbc.gridwidth = 4;
			gbc.gridy = gbc.gridy+1;

			// Checking if one of the planets is Tortalus.
			if (p.getName().equals("Tortalus") && !p.getCaptured())
			{
				System.out.println("We own Tortalus!");
				tortalus = true;
			}

			gbc.fill = GridBagConstraints.NONE;

			JLabel tempLabel = new JLabel(p.toString());
			tempLabel.setFont(new Font("Serif", 1, 16));
			tempLabel.setForeground(c.BLUE.darker());
			//frame.getContentPane().add(tempLabel, gbc);
			planetsPanel.add(tempLabel, gbc);

			gbc.gridy = gbc.gridy+1;
			gbc.gridwidth = 2;

			gbc.fill = GridBagConstraints.BOTH;

			JLabel tempEconomy = new JLabel("Economy (3): ");
			//frame.getContentPane().add(tempEconomy, gbc);
			planetsPanel.add(tempEconomy, gbc);

			gbc.gridx = 2;

			final SpinnerNumberModel economyModel = new SpinnerNumberModel(p.getEconomy(), p.getEconomy(), p.getEconomy()+max2/3, 1);
			final JSpinner economySpinner = new JSpinner(economyModel);
			editor = (JSpinner.DefaultEditor) economySpinner.getEditor();
			ftf = editor.getTextField();
			ftf.setEditable(false);
			ftf.setFont(new Font("Serif", 1, 16));
			//frame.getContentPane().add(economySpinner, gbc);
			planetsPanel.add(economySpinner, gbc);
			planetEconomyModels.addElement(economyModel);

			gbc.gridy = gbc.gridy+1;
			gbc.gridx = 0;

			JLabel tempIndustry = new JLabel("Industry (5): " );
			//frame.getContentPane().add(tempIndustry, gbc);
			planetsPanel.add(tempIndustry, gbc);

			gbc.gridx = 2;

			final SpinnerNumberModel industryModel = new SpinnerNumberModel(p.getIndustry(), p.getIndustry(), p.getIndustry()+max2/5, 1);
			final JSpinner industrySpinner = new JSpinner(industryModel);
			editor = (JSpinner.DefaultEditor) industrySpinner.getEditor();
			ftf = editor.getTextField();
			ftf.setEditable(false);
			ftf.setFont(new Font("Serif", 1, 16));
			//frame.getContentPane().add(industrySpinner, gbc);
			planetsPanel.add(industrySpinner, gbc);
			planetIndustryModels.addElement(industryModel);

		}

		// Tortalus gives the tech boost.
		int techDivider = 1;
		if (tortalus)
		{
			techDivider = 2;
			techModel.setStepSize(new Integer(2));
		}
		final int tDivider = techDivider;
		techModel.setMaximum(new Integer(player.getEmpire().getTech()+(tDivider*max2)/5));
		// End Tortalus stuff.

		techModel.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e)
			{

			    	int temp = techModel.getNumber().intValue();
				int temp2 = espionageModel.getNumber().intValue();
				//int temp3 = counterEspionageModel.getNumber().intValue();
				max2 = totalMax - ((temp2 - ((Integer)espionageModel.getMinimum()).intValue())*5);//  - ((temp3 - ((Integer)counterEspionageModel.getMinimum()).intValue())*4);

				// Tech Minus taking into account Tortalus
				int test =  temp - ((Integer)techModel.getMinimum()).intValue();
				test /= tDivider;
				test *= 5;
				max2 -= test;

				max2 = max2 - spinnerChange(planetEconomyModels, 3);
				max2 = max2 - spinnerChange(planetIndustryModels, 5);

				availableMoney.setText(""+max2);
				espionageModel.setMaximum(new Integer(((Integer)espionageModel.getNumber()).intValue()+max2/5));
				//counterEspionageModel.setMaximum(new Integer(((Integer)counterEspionageModel.getNumber()).intValue()+max2/4));

				for (int i = 0; i < planetEconomyModels.size(); i++)
				{
					SpinnerNumberModel spin = (SpinnerNumberModel) planetEconomyModels.elementAt(i);
					spin.setMaximum(new Integer(((Integer)spin.getNumber()).intValue()+max2/3));
				}
				for (int i = 0; i < planetIndustryModels.size(); i++)
				{
					SpinnerNumberModel spin = (SpinnerNumberModel) planetIndustryModels.elementAt(i);
					spin.setMaximum(new Integer(((Integer)spin.getNumber()).intValue()+max2/5));
				}

			}
		});
		espionageModel.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e)
			{
			     	int temp = techModel.getNumber().intValue();
				int temp2 = espionageModel.getNumber().intValue();
				//int temp3 = counterEspionageModel.getNumber().intValue();
				max2 = totalMax - ((temp2 - ((Integer)espionageModel.getMinimum()).intValue())*5);//  - ((temp3 - ((Integer)counterEspionageModel.getMinimum()).intValue())*4);

				// Tech Minus taking into account Tortalus
				int test =  temp - ((Integer)techModel.getMinimum()).intValue();
				test /= tDivider;
				test *= 5;
				max2 -= test;

				max2 = max2 - spinnerChange(planetEconomyModels, 3);
				max2 = max2 - spinnerChange(planetIndustryModels, 5);

				availableMoney.setText(""+max2);
				techModel.setMaximum(new Integer(((Integer)techModel.getNumber()).intValue()+(tDivider*max2)/5));
				//counterEspionageModel.setMaximum(new Integer(((Integer)counterEspionageModel.getNumber()).intValue()+max2/4));


				for (int i = 0; i < planetEconomyModels.size(); i++)
				{
					SpinnerNumberModel spin = (SpinnerNumberModel) planetEconomyModels.elementAt(i);
					spin.setMaximum(new Integer(((Integer)spin.getNumber()).intValue()+max2/3));
				}
				for (int i = 0; i < planetIndustryModels.size(); i++)
				{
					SpinnerNumberModel spin = (SpinnerNumberModel) planetIndustryModels.elementAt(i);
					spin.setMaximum(new Integer(((Integer)spin.getNumber()).intValue()+max2/5));
				}

			}
		});
	/*
		counterEspionageModel.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e)
			{
			     	int temp = techModel.getNumber().intValue();
				int temp2 = espionageModel.getNumber().intValue();
				int temp3 = counterEspionageModel.getNumber().intValue();
				max2 = totalMax - ((temp2 - ((Integer)espionageModel.getMinimum()).intValue())*4)  - ((temp3 - ((Integer)counterEspionageModel.getMinimum()).intValue())*4);

				// Tech Minus taking into account Tortalus
				int test =  temp - ((Integer)techModel.getMinimum()).intValue();
				test /= tDivider;
				test *= 5;
				max2 -= test;

				max2 = max2 - spinnerChange(planetEconomyModels, 3);
				max2 = max2 - spinnerChange(planetIndustryModels, 5);

				availableMoney.setText(""+max2);
				techModel.setMaximum(new Integer(((Integer)techModel.getNumber()).intValue()+(tDivider*max2)/5));
				espionageModel.setMaximum(new Integer(((Integer)espionageModel.getNumber()).intValue()+max2/4));


				for (int i = 0; i < planetEconomyModels.size(); i++)
				{
					SpinnerNumberModel spin = (SpinnerNumberModel) planetEconomyModels.elementAt(i);
					spin.setMaximum(new Integer(((Integer)spin.getNumber()).intValue()+max2/3));
				}
				for (int i = 0; i < planetIndustryModels.size(); i++)
				{
					SpinnerNumberModel spin = (SpinnerNumberModel) planetIndustryModels.elementAt(i);
					spin.setMaximum(new Integer(((Integer)spin.getNumber()).intValue()+max2/5));
				}

			}
		});
	*/

		for (int i = 0; i < planetEconomyModels.size(); i++)
		{
			final SpinnerNumberModel spinning = (SpinnerNumberModel) planetEconomyModels.elementAt(i);
			spinning.addChangeListener(new ChangeListener(){
				public void stateChanged(ChangeEvent e)
				{
				    	int temp = techModel.getNumber().intValue();
					int temp2 = espionageModel.getNumber().intValue();
					//int temp3 = counterEspionageModel.getNumber().intValue();
					max2 = totalMax - ((temp2 - ((Integer)espionageModel.getMinimum()).intValue())*5);//  - ((temp3 - ((Integer)counterEspionageModel.getMinimum()).intValue())*4);


					// Tech Minus taking into account Tortalus
					int test =  temp - ((Integer)techModel.getMinimum()).intValue();
					test /= tDivider;
					test *= 5;
					max2 -= test;

					max2 = max2 - spinnerChange(planetEconomyModels, 3);
					max2 = max2 - spinnerChange(planetIndustryModels, 5);

				  	availableMoney.setText(""+max2);
					techModel.setMaximum(new Integer(((Integer)techModel.getNumber()).intValue()+(tDivider*max2)/5));
					espionageModel.setMaximum(new Integer(((Integer)espionageModel.getNumber()).intValue()+max2/5)); //4
				//	counterEspionageModel.setMaximum(new Integer(((Integer)counterEspionageModel.getNumber()).intValue()+max2/4));


				}
			});
		}
		for (int i = 0; i < planetIndustryModels.size(); i++)
		{
			final SpinnerNumberModel spinning = (SpinnerNumberModel) planetIndustryModels.elementAt(i);
			spinning.addChangeListener(new ChangeListener(){
				public void stateChanged(ChangeEvent e)
				{
				    	int temp = techModel.getNumber().intValue();
					int temp2 = espionageModel.getNumber().intValue();
					//int temp3 = counterEspionageModel.getNumber().intValue();
					max2 = totalMax - ((temp2 - ((Integer)espionageModel.getMinimum()).intValue())*5);//  - ((temp3 - ((Integer)counterEspionageModel.getMinimum()).intValue())*4);

					// Tech Minus taking into account Tortalus
					int test =  temp - ((Integer)techModel.getMinimum()).intValue();
					test /= tDivider;
					test *= 5;
					max2 -= test;

					max2 = max2 - spinnerChange(planetEconomyModels, 3);
					max2 = max2 - spinnerChange(planetIndustryModels, 5);

				  	availableMoney.setText(""+max2);
					techModel.setMaximum(new Integer(((Integer)techModel.getNumber()).intValue()+(tDivider*max2)/5));
					espionageModel.setMaximum(new Integer(((Integer)espionageModel.getNumber()).intValue()+max2/5)); //4
//					counterEspionageModel.setMaximum(new Integer(((Integer)counterEspionageModel.getNumber()).intValue()+max2/4));


				}
			});
		}

		gbc.gridx = 0;
		gbc.gridwidth = 4;
		gbc.gridy = 6;

		JScrollPane scroll = new JScrollPane(planetsPanel);
		scroll.setPreferredSize(new Dimension(100, 200));
		frame.getContentPane().add(scroll, gbc);

		gbc.fill = GridBagConstraints.NONE;

		gbc.gridy = gbc.gridy+1;
		gbc.gridwidth = 1;
		gbc.gridx = 2;

		execute = new JButton("Execute");
		execute.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			player.getEmpire().setTech(techModel.getNumber().intValue());
			player.getEmpire().setEspionage(espionageModel.getNumber().intValue());
			player.getEmpire().setMaxEspionage(espionageModel.getNumber().intValue());
			//player.getEmpire().setCounterEspionage(counterEspionageModel.getNumber().intValue());

			if (player.getEmpire().getMoney() > 0)
			{
				player.getEmpire().setMoney(max2);
			}

			tech.setText("" + player.getEmpire().getTech());
			espionage.setText("" + player.getEmpire().getEspionage());
			//counterEspionage.setText("" + player.getEmpire().getCounterEspionage());
			money.setText(""+player.getEmpire().getMoney());

			for (int i = 0; i < planetEconomyModels.size(); i++)
			{

			    	Planet p = (Planet) player.getEmpire().getPlanets().elementAt(i);
				SpinnerNumberModel temporary = (SpinnerNumberModel) planetEconomyModels.elementAt(i);
				SpinnerNumberModel temporary2 = (SpinnerNumberModel) planetIndustryModels.elementAt(i);

			   	p.setEconomy(temporary.getNumber().intValue());

				if (!p.getCaptured())
				{
					p.setCurrentIndustry(p.getCurrentIndustry() + (temporary2.getNumber().intValue()-p.getIndustry()));
				}

				p.setIndustry(temporary2.getNumber().intValue());


			    	// temporary arbitrary planet labels...seemed like a good idea at the time...
				if (i == 0)
				{
				 	planetEco1.setText(""+p.getEconomy());
					planetInd1.setText(""+p.getIndustry());
				}
				if (i == 1)
				{
				 	planetEco2.setText(""+p.getEconomy());
					planetInd2.setText(""+p.getIndustry());
				}
				if (i == 2)
				{
				 	planetEco3.setText(""+p.getEconomy());
					planetInd3.setText(""+p.getIndustry());
				}
				if (i == 3)
				{
				 	planetEco4.setText(""+p.getEconomy());
					planetInd4.setText(""+p.getIndustry());
				}
				if (i == 4)
				{
				 	planetEco5.setText(""+p.getEconomy());
					planetInd5.setText(""+p.getIndustry());
				}
				if (i == 5)
				{
					planetEco6.setText(""+p.getEconomy());
					planetInd6.setText(""+p.getIndustry());
				}
			}

			income.setText("" + player.getEmpire().getIncome());

			// Restoring this planet's industry.
			for (int i = 0; i < player.getEmpire().getPlanets().size(); i++)
				{
					Planet p = (Planet) player.getEmpire().getPlanets().elementAt(i);
					p.restoreIndustry();
				}

			frame.setVisible(false);

		}});
		frame.getContentPane().add(execute, gbc);

		gbc.gridx = 3;

		JButton cancel = new JButton("Cancel ");
		cancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			frame.setVisible(false);
		}});
		frame.getContentPane().add(cancel, gbc);

		frame.pack();
		frame.show();

	}


	public int spinnerChange(Vector temp, int increment)
	{
		int result = 0;
		for (int i = 0; i < temp.size(); i++)
		{
			SpinnerNumberModel num = (SpinnerNumberModel) temp.elementAt(i);
			int temp2 = num.getNumber().intValue();
			result += ((temp2 - ((Integer)num.getMinimum()).intValue())*increment);
		}
		return result;
	}


	public void setTotalSpaceForces(Vector tot)
	{
		totalSpaceForces = tot;
	}

	public void setTotalGroundForces(Vector tot)
	{
		totalGroundForces = tot;
	}

	public Force createForce(String name, Vector forceList)
	{
		Force f = null;

		for (int i = 0; i < forceList.size(); i++)
		{
			Force forc = (Force) forceList.elementAt(i);
			if (forc.getName().equals(name))
			{
				f = (Force) forc.clone();
			}
			forc.setCommitted(true);
		}

		return f;
	}

	// Unloads a ground unit at the user's command.

	public void unLoad(Unit u)
	{

		Vector fleets = player.getEmpire().getSpaceUnits();

		for (int i = 0; i < fleets.size(); i++)
		{
			Unit u2 = (Unit) fleets.elementAt(i);

			for (int t = 0; t < u2.getForces().size(); t++)
			{
				SpaceForce sf = (SpaceForce) u2.getForces().elementAt(t);

				for (int k = 0; k < sf.getStorage().size(); k++)
				{
					Unit utemp = (Unit) sf.getStorage().elementAt(k);

					if (utemp.getName().equals(u.getName()))
					{
						sf.getStorage().removeElementAt(k);
						u.setLoaded(false);
					}
				}
			}
		}
	}

	public Player getPlayer()
	{
		return player;
	}

	public Map getMap()
	{
		return map;
	}

	// refreshLabels refreshes the space and ground location labels, mostly to be used after
	// transfer of forces.

	public void refreshLabels()
	{
		for (int i = 0; i < player.getEmpire().getSpaceUnits().size(); i++)
		{
			Unit u = (Unit) player.getEmpire().getSpaceUnits().elementAt(i);

			if (!u.isEmpty())
			{
				// Modify location label here.

				String locationText = "Location (x/y): ";

				Location loc = u.getLocation();
				locationText += loc.getPositionX() + "/" + loc.getPositionY();

				if (loc.getPlanets().size() > 0)
				{
					Planet plan = (Planet) loc.getPlanets().elementAt(0);
					locationText += " ("+plan.getName()+")";
				}

				JLabel spaceLocation = (JLabel) spaceLocations.elementAt(i);
				spaceLocation.setText(locationText);
			}
		}
		for (int i = 0; i < player.getEmpire().getGroundUnits().size(); i++)
		{
			Unit u = (Unit) player.getEmpire().getGroundUnits().elementAt(i);

			if (!u.isEmpty())
			{
				// Modify location label here.

				String locationText = "Location (x/y): ";

				Location loc = u.getLocation();
				locationText += loc.getPositionX() + "/" + loc.getPositionY();

				if (loc.getPlanets().size() > 0)
				{
					Planet plan = (Planet) loc.getPlanets().elementAt(0);
					locationText += " ("+plan.getName()+")";
				}

				JLabel groundLocation = (JLabel) groundLocations.elementAt(i);
				groundLocation.setText(locationText);
			}
		}
	}

	// This method checks if loaded ground units are over hostile planets and prompts the user to choose
	// what should be done with them.

	public boolean invadePlanets()
	{
		int confirming = 0;

		Vector unloads = new Vector();

		// Loop through all ground units and check if they are over an enemy planet.

		for (int t = 0; t < player.getEmpire().getGroundUnits().size(); t++)
		{
			Unit u = (Unit) player.getEmpire().getGroundUnits().elementAt(t);

			u.setGroundInvade(false);

			Location loc = u.getLocation();

			// Loop through all planets and find out if this unit is over enemy planet.

			if (!u.isEmpty() && loc.getPlanets().size() > 0  && u.getLoaded())
			{
				Planet plan = (Planet) loc.getPlanets().elementAt(0);

				boolean found = false;

				for (int z = 0; z < player.getEmpire().getPlanets().size(); z++)
				{
					Planet pl = (Planet) player.getEmpire().getPlanets().elementAt(z);

					if (pl.getName().equals(plan))
					{
						found = true;
					}
				}

				// Check if this planet is an enemy planet.
				if (!found)
				{
					// Prompt to see if this unit should be unloaded.

					int unload = 0;
					confirming++;

					unload = JOptionPane.showConfirmDialog(main, "Unload " + u + " on \n" + "planet " + plan.getName()+"?", "Invade "+plan.getName()+"?", JOptionPane.YES_NO_OPTION);

					if (unload == 0)
					{
						unloads.addElement(u);
					}

				}
			}
		}

		// Confirm that all unloading decisions are satisfactory.

	//	if (confirming > 0)
	//	{

			int check = JOptionPane.showConfirmDialog(main, "Confirm all troop dropping orders and End Phase?", "Confirm Troop Drops?", JOptionPane.YES_NO_OPTION);

			if (check != 0)
			{
				return false;
			}

			// We perform the unloading.

			for (int t = 0; t < unloads.size(); t++)
			{
				Unit u = (Unit) unloads.elementAt(t);

				// Unload each unit.
				//unLoad(player, u);
				u.setGroundInvade(true);
			}

	//	}

		return true;

	}


	public boolean getDropped()
	{
		return dropped;
	}

}
