import java.io.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import javax.swing.event.*;
import java.rmi.*;

import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;


// Name: Jeremy Long
// Student Number: 587 702
// NSID: jsl847
// CMPT436, Project

/*
	TODO: Fix freezes after movement.
	TODO: Messages for asteroid belt.
	TODO: Improvement phase has money spent automatically.
*/

public class PaxGalaktika
{


    public static void main(String[] args) throws Exception
    {
	System.setSecurityManager(new RMISecurityManager());
	PaxGalaktika pg = new PaxGalaktika();
    }

    	private String name;
	private Player player;
	private PaxServerInterface psi;
	private boolean delay;

	// We retrofit ships only the first time hyperLSD is obtained.
	private boolean hyperLSD = false;

	// Necessary for the battle system.
	private Battle b;
	private Combatant newC;

	// Do we accept defensive redeploy?
	private boolean confirmed;

	// Are we reloading this client or starting a new one?
	private boolean reload;

	// The version number of the game.
	final private float version = 2.01f;

	Vector empires;
	Map map;

    	public PaxGalaktika() throws Exception
    	{
		reload = connect();

		if (!reload)
		{
			choosePlanet();

		}

		boolean won = true;

		Vector temporary = new Vector();

		PaxClient initial = new PaxClient(psi.getSpaceForces(), psi.getGroundForces(), psi);

		if (!reload)
		{
			wait(0, 0);
		}
		else if (reload)
		{
			map = psi.getMap();

			Vector temp = map.getPlayers();

			for (int i = 0; i < temp.size(); i++)
			{
				Player p = (Player) temp.elementAt(i);

				if (p.getName().equals(name))
				{
					player = p;
				}
			}
		}


		while (!psi.gameOver() || map.getPhase() < 7)  // check for victory conditions here!
		{
		    	// new additions for Combat Phase
			if (map != null)
			{
				if ((map.getPhase() == 3 && !reload) || (reload && map.getPhase() == 4))
				{

					Vector battles = psi.getSpaceBattles(name);

					if (!reload || !psi.isDoneDeploy(name)) // Need another condition here to check if defensive redeploy is done.
					{

					// We will later only pass battles with defending stations to this method.
					// Later, we will put the defensive redeploy in PvP space battles only.
					// Process: Server returns a list of PvP space battles.
					// We prune it to find those that *this* player can defensive redeploy.
					// We confirm that defensive redeploy is done (if applicable) and send
					// signal to the server with our player object and wait for all to be done.
					// After it's all done, we grab a NEW list of battles that has been
					// recalculated on the server side.

					// Put in checking for station battles...

						Vector battling = checkRedeploy(battles);

						if (battling.size() > 0)
						{
							while (!confirmed)
							{
								confirmed = defensiveRedeploy(battling, battles);
								if (!confirmed)
								{
									battles = psi.getSpaceBattles(name);
									battling = checkRedeploy(battles);
									player = psi.getPlayer(name);
									// getMap() test to reload map.
									map = psi.getMap();
								}
							}
							confirmed = false;
						}

						psi.doneDeploy(name, player);

					}
					// Some sort of waiting method until all players are done with this step.

					waitDeploy();



					// Grab the list of battles again, now updated for defensive redeploy.
					battles = psi.getSpaceBattles(name);


					for (int i = 0; i < battles.size(); i++)
					{
						Battle b = (Battle) battles.elementAt(i);
						battle(b, true);
					}

					battles = waitPvP(true);//psi.getGroundBattles(name);

					for (int i = 0; i < battles.size(); i++)
					{
						Battle b = (Battle) battles.elementAt(i);
						battle(b, false);
					}

					battles = waitPvP(false); //psi.getNeutralSpaceBattles(name);

					// Ensure there are no duplicates in the neutral battles vector.
					pruneNeutrals(battles);

					System.out.println("Neutral space battles: " + battles.size());

					for (int i = 0; i < battles.size(); i++)
					{
						Battle b = (Battle) battles.elementAt(i);

						// Send a message about this neutral space battle.
						Vector temp = new Vector();

						b = battle(b, true);

						String winner = " The battle was won by " + b.getWinner() + "!";

						if (b.getWinner().length() == 0)
						{
							winner = " No forces survived the battle.";
						}

						String location = "in deep space";

						if (b.getLocation().getPlanets().size() > 0)
						{
							location = "above " + b.getLocation().getPlanets().elementAt(0);
						}

						Message m = new Message("A "+getAdjective(b)+" space battle was fought "+ location + " between " + (Combatant)b.getCombatants().elementAt(0) + " and " + (Combatant)b.getCombatants().elementAt(1) + "!" + winner,  true);
						temp.addElement(m);
						psi.sendMessages(temp);
					}

					battles = psi.getNeutralGroundBattles(name);

					// Once again, prune the vector remove all duplicates.

					pruneNeutrals(battles);

					for (int i = 0; i < battles.size(); i++)
					{
						Battle b = (Battle) battles.elementAt(i);

						b = battle(b, false);

						String winner = " The battle was won by " + b.getWinner() + "!";

						if (b.getWinner().length() == 0)
						{
							winner = " No forces survived the battle.";
						}

						// Send a message about this neutral ground battle.
						Vector temp = new Vector();
						Message m = new Message("A "+getAdjective(b)+" ground battle was fought on " + (Planet) b.getLocation().getPlanets().elementAt(0) +" between " + (Combatant)b.getCombatants().elementAt(0) + " and " + (Combatant)b.getCombatants().elementAt(1) + "!" + winner,  true);
						temp.addElement(m);
						psi.sendMessages(temp);
					}

				}
			}
			// end additions

			map = psi.getMap();

			Vector temp = map.getPlayers();

			for (int i = 0; i < temp.size(); i++)
			{
				Player p = (Player) temp.elementAt(i);

				if (p.getName().equals(name))//toString().equals(name))
				{
					player = p;
				}
			}

			// Display messages;
			if ((map.getPhase() > 1 || map.getTurn() > 1) && map.getPhase() != 4)
			{
				temporary = psi.getMessages(player.getName());
				//System.out.println("Showing message " + map.getPhase());
				showMessages(temporary);
			}

			// New maintenance!
			player.getEmpire().calculateMaintenance();

			// Repair all units.

			for (int i = 0; i < player.getEmpire().getSpaceUnits().size(); i++)
			{
				Unit u = (Unit) player.getEmpire().getSpaceUnits().elementAt(i);

				u.repair();
			}
			for (int i = 0; i < player.getEmpire().getGroundUnits().size(); i++)
			{
				Unit u = (Unit) player.getEmpire().getGroundUnits().elementAt(i);

				u.repair();
			}

			PaxClient pc = null;

			if (reload && psi.isReady(player.getName()))
			{
				pc = new PaxClient(player, map, false);
				pc.dispose();
			}
			else
			{
				pc = new PaxClient(player, map, true);
			}

			// For undo all, get player and map from PC.
			map = pc.getMap();
			player = pc.getPlayer();

			if (!reload || !psi.isReady(player.getName()))
			{

				if (map.getPhase() == 1)
				{
					player.getEmpire().collect();
				}
				temporary = new Vector();
				if (map.getPhase() == 2)
				{
				    	temporary = pc.getMessages();
					psi.sendMessages(temporary);
				}

				if (map.getPhase() == 4)
				{
					// Put in battle conquest stuff here!

					assignPlanets();
				}
				// This is to be done after market phase.
				if (map.getPhase() == 5)//6)
				{
					player = psi.getPlayer(player.getName());
				}

				System.out.println("Must be done phase!");

			}

			PaxClient pc2 = new PaxClient(player, map, false);
			pc2.disable();

			if (!reload || !psi.isReady(player.getName()))
			{

				// Retrofitting hyperLSD only once.
				if (map.getPhase() == 6 && !hyperLSD && player.getEmpire().getTech() > 44)
				{
					for (int i = 0; i < player.getEmpire().getSpaceUnits().size(); i++)
					{
						Unit u = (Unit) player.getEmpire().getSpaceUnits().elementAt(i);

						for (int t = 0; t < u.getForces().size(); t++)
						{
							Force f = (Force) u.getForces().elementAt(t);

							if (f.getMobile())
							{
								f.hyperLSD();
							}
						}
					}

					hyperLSD = true;
				}
			}

			reload = false;

			psi.donePhase(name, map.getPhase(), map.getTurn(), player);

			if (eliminated(player))
			{
				Message m = new Message(player.getName() + " has been eliminated from this game of Pax Galaktika!", true);
				temporary = new Vector();
				temporary.addElement(m);

				psi.sendMessages(temporary);
			}

			wait(map.getPhase(), map.getTurn());


			//if (!eliminated(player))
			//{

			//temporary = psi.getMessages(player.getName());
			//showMessages(temporary);


			if (map.getPhase() == 4)
			{
				System.out.println("Removing planets!");

				psi.checkPlanets(name, player.getEmpire().getPlanets());
			}

			//}
			//else
			if (eliminated(player))
			{
				won = false;
				break;
			}

			if (pc.getDropped())
			{

				Message m = new Message(player.getName() + " has dropped from this game of Pax Galaktika!", true);
				temporary = new Vector();
				temporary.addElement(m);

				psi.sendMessages(temporary);

				psi.dropPlayer(player.getName());

				won = false;
				break;
			}


			pc2.dispose();


		}


		// The game is over, so now we display the final results.

		PaxClient pc2 = new PaxClient(player, map, false);
		pc2.disable();

		finalResults(won);


    	}

	// Returns whether we are reloading this client.

	public boolean connect() throws Exception
  	{
		reload = false;

	    	final JFrame connector = new JFrame("Establish Connection - v" + version);
		connector.setSize(250, 350);
		connector.setResizable(false);
		connector.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    		connector.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 2;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
	    	connector.getContentPane().add(bc, gbc);

		gbc.fill = GridBagConstraints.HORIZONTAL;

		gbc.gridwidth = 1;
		gbc.gridy = 1;

		JLabel labeling = new JLabel("Enter your Name: ");
		connector.getContentPane().add(labeling, gbc);

		gbc.gridx = 1;

		final JTextField alias = new JTextField("Name", 15);
		connector.getContentPane().add(alias, gbc);

		gbc.gridy = 2;
		gbc.gridx = 0;

		JLabel label = new JLabel("Server Address: ");
		connector.getContentPane().add(label, gbc);

		gbc.gridx = 1;

		final JTextField address = new JTextField("localhost", 15);
		connector.getContentPane().add(address, gbc);

		gbc.gridy = 3;
		gbc.gridx = 0;

	/*	JLabel label2 = new JLabel("Port: ");
		connector.getContentPane().add(label2, gbc);

		gbc.gridx = 1;

		final JTextField port = new JTextField("9999", 15);
		connector.getContentPane().add(po	g.setFont(new Font("Serif", 0, 10));
		g.drawString("The Thwackers", horizontalIncrement*3+54, verticalIncrement*6+30);
	rt, gbc);

		gbc.gridx = 0;
		gbc.gridy = 4;*/

		gbc.gridwidth = 2;

		JButton done = new JButton("Connect!");

		done.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			name = alias.getText().trim();
			String addressed = address.getText().trim();
			int thePort = 0;
			try
			{
				/* thePort = Integer.parseInt(port.getText());
				connection = new Socket(addressed, thePort);
				receivestream = new ObjectInputStream(connection.getInputStream());
				sendstream = new ObjectOutputStream(connection.getOutputStream());
				sendstream.writeObject(userid);*/

			    String name1 = "//"+addressed+":1099/PaxServer";
				System.out.println(name1);
				//Registry registry = LocateRegistry.getRegistry(addressed, 1099);

				String[] listing = Naming.list(name1);

				System.out.println("List of Remote Objects: ");
				for (int z = 0; z < listing.length; z++)
				{
					System.out.println(listing[z]);
				}

				psi = (PaxServerInterface) Naming.lookup(name1);

				//psi = (PaxServerInterface) registry.lookup(name1);
				System.out.println("Found the server!");

				String hostName = InetAddress.getLocalHost().getHostAddress();
			    System.out.println(hostName);

				if (Math.abs(psi.getVersion() - version) < 0.00001)
				{
					if (psi.isFull())
					{

						if (psi.reload(name, hostName))
						{
							reload = true;
							connector.setVisible(false);
						}
						else
						{
							JOptionPane.showMessageDialog(connector, "Sorry, this game is full!","Connection Error", JOptionPane.ERROR_MESSAGE);
						}

					}
					else
					{
						if (!name.startsWith("AI ") && psi.connect(name, hostName))
						{
							connector.setVisible(false);
						}
						else
						{
							JOptionPane.showMessageDialog(connector, "Someone else has already used this name. \nPlease choose a new, unique name.","Connection Error", JOptionPane.ERROR_MESSAGE);
						}
					}
				}
				else
				{
					JOptionPane.showMessageDialog(connector, "Your version of the client does not match \n the server that you are connecting to. \n Please get client version " + psi.getVersion() + " and try again!","Version Error", JOptionPane.ERROR_MESSAGE);
				}
			}
			catch (Exception f)
			{
				System.out.println("Could not create connection! Please try again. " + f.toString());
				JOptionPane.showMessageDialog(connector, "Connection failed! Please try again!","Connection Error", JOptionPane.ERROR_MESSAGE);
			}


		}});
		connector.getContentPane().add(done, gbc);

		connector.pack();
		connector.show();
		while (connector.isVisible())
		{


		}

		return reload;
  	}

	// Displays the final results of a pax game as a GUI window.  The boolean indicates whether the game has been won or if
	// the current player lost.

	public void finalResults(boolean won) throws Exception
  	{

		// Getting the most recent map data to display.

		map = psi.getMap();
		Color c = new Color(121);

		float maxPoints = 0;
		String winner = "";


	    	final JFrame connector = new JFrame("Final Results");
		connector.setSize(250, 550);
		connector.setResizable(false);
		connector.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    		connector.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 2;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
	    	connector.getContentPane().add(bc, gbc);
		connector.getContentPane().setBackground(c.BLACK);

		gbc.fill = GridBagConstraints.HORIZONTAL;

		gbc.gridwidth = 1;
		gbc.gridy = 1;
		gbc.gridx = 1;

		JLabel labeling = new JLabel("GAME OVER", 0); // second indicates CENTER
		labeling.setFont(new Font("Dialog", 1, 24));
		labeling.setForeground(c.BLUE);
		connector.getContentPane().add(labeling, gbc);

		// Setting up the panel with the scores.

		JPanel victoryPanel = new JPanel();
		victoryPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1, c.WHITE, c.GRAY), "Final Scores:", 0, 0, new Font("Dialog", 1, 16), c.WHITE));
		victoryPanel.setLayout(new GridBagLayout());
		victoryPanel.setBackground(c.BLACK);

		GridBagConstraints gbc3 = new GridBagConstraints();

		gbc3.fill = GridBagConstraints.HORIZONTAL;

		gbc3.insets.top = 6;
		gbc3.insets.bottom = 6;
		gbc3.insets.right = 6;
		gbc3.insets.left = 6;

		gbc3.gridx = 0;
		gbc3.gridy = 0;
		gbc3.gridwidth = 1;
		gbc3.gridheight = 1;


		JLabel heading1 = new JLabel("Player", 0);
		heading1.setForeground(c.BLUE);
		heading1.setBorder(BorderFactory.createMatteBorder(0,0,1,0, c.WHITE));
		victoryPanel.add(heading1, gbc3);

		gbc3.gridx = 1;

		JLabel heading2 = new JLabel("Empire", 0);
		heading2.setForeground(c.BLUE);
		heading2.setBorder(BorderFactory.createMatteBorder(0,0,1,0, c.WHITE));
		victoryPanel.add(heading2, gbc3);

		gbc3.gridx = 2;

		JLabel heading3 = new JLabel("Victory Points", 0);
		heading3.setForeground(c.BLUE);
		heading3.setBorder(BorderFactory.createMatteBorder(0,0,1,0, c.WHITE));
		victoryPanel.add(heading3, gbc3);


		for (int i = 0; i < map.getPlayers().size(); i++)
		{
			gbc3.gridy = i+1;

			Player p = (Player) map.getPlayers().elementAt(i);

			gbc3.gridx = 0;

			JLabel finish1 = new JLabel(""+p, 0);
			finish1.setForeground(c.WHITE);
			if (p.getName().equals(player.getName()))
			{
				finish1.setForeground(c.RED);
			}
			victoryPanel.add(finish1, gbc3);

			gbc3.gridx = 1;

			JLabel finish2 = new JLabel(""+p.getEmpire().getName(), 0);
			finish2.setForeground(c.WHITE);
			if (p.getName().equals(player.getName()))
			{
			    finish2.setForeground(c.RED);
			}
			victoryPanel.add(finish2, gbc3);

			gbc3.gridx = 2;

			JLabel finish3 = new JLabel(p.getEmpire().getVictoryPoints()+" / " + p.getEmpire().getMaxVictoryPoints(), 0);
			finish3.setForeground(c.WHITE);
			if (p.getName().equals(player.getName()))
			{
			    finish3.setForeground(c.RED);
			}
			victoryPanel.add(finish3, gbc3);

			float test = ((float)p.getEmpire().getVictoryPoints())/((float)p.getEmpire().getMaxVictoryPoints());

			System.out.println("Scores: " + test);

			if (test > maxPoints)
			{
				maxPoints = test;
				winner = p.getName();
			}

		}


		gbc.gridwidth = 3;
		gbc.gridy = 2;
		gbc.gridx = 0;

		connector.getContentPane().add(victoryPanel, gbc);


		gbc.gridx = 0;
		gbc.gridy = 3;
		gbc.gridwidth = 3;


		if (!won)
		{
			JLabel labeling2 = new JLabel("You have been defeated!", 0); // second indicates CENTER
			labeling2.setFont(new Font("Dialog", 1, 20));
			labeling2.setForeground(c.WHITE);
			connector.getContentPane().add(labeling2, gbc);
		}
		else
		{
			JLabel labeling2 = new JLabel(""+winner+" has won the game!", 0); // second indicates CENTER
			labeling2.setFont(new Font("Dialog", 1, 18));
			labeling2.setForeground(c.WHITE);
			connector.getContentPane().add(labeling2, gbc);
		}

		gbc.gridy = 4;

		JButton done = new JButton("Done");

		done.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			connector.setVisible(false);
		}});
		connector.getContentPane().add(done, gbc);

		connector.pack();
		connector.show();
		while (connector.isVisible())
		{
		}
		connector.dispose();
  	}


	public void choosePlanet() throws Exception
  	{

	    	final JFrame frame = new JFrame("Pax Galaktika - Create your Empire");
		frame.setSize(450, 550);
		frame.setResizable(false);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    		frame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 3;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		frame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 1;

		gbc.fill = GridBagConstraints.HORIZONTAL;

		JLabel empireLabel = new JLabel("Empire Name: ");
		frame.getContentPane().add(empireLabel, gbc);

		gbc.gridx = 1;
		gbc.gridwidth = 2;

		final JTextField empireName = new JTextField("", 9);
		frame.getContentPane().add(empireName, gbc);

		gbc.gridx = 0;
		gbc.gridwidth = 1;
		gbc.gridy = 2;
		gbc.gridheight = 3;

		Vector availableEmpires = psi.getEmpires();
		final JList planetList = new JList(psi.getEmpires());
		ListSelectionModel lsm = planetList.getSelectionModel();
		lsm.setSelectionMode(0);
		JScrollPane scroll = new JScrollPane(planetList);
		scroll.setPreferredSize(new Dimension(80, 220));
		frame.getContentPane().add(scroll, gbc);

		gbc.gridx = 1;
		gbc.gridwidth = 2;

		final JTextArea info = new JTextArea("Planet Info", 9, 10);
		info.setLineWrap(true);
		info.setWrapStyleWord(true);
		info.setEditable(false);
		JScrollPane scroll2 = new JScrollPane(info);
		scroll2.setPreferredSize(new Dimension(250, 220));
		frame.getContentPane().add(scroll2, gbc);

		gbc.gridx = 0;
		gbc.gridy = 5;
		gbc.gridheight = 1;
		gbc.gridwidth = 3;

		final JButton done = new JButton("Create!");

		done.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			String named = empireName.getText();
			if (named.length() > 0)
			{
			    	try
				{
			    	Empire emp = (Empire) planetList.getSelectedValue();

				boolean chosen = psi.chooseEmpire(name, emp.toString(), named);

				if (!chosen)
				{
					info.setText("That empire has already been chosen! Please make another selection.");

					planetList.setListData(psi.getEmpires());
				}
				else
				{
					frame.setVisible(false);
					psi.donePhase(name, 0, 0, null);
				}
				}
				catch (Exception t)
				{
					System.out.println("Exception!");
				}


			}
			else
			{
				info.setText("You must enter an empire name before continuing!");
			}
		}});
		frame.getContentPane().add(done, gbc);

		done.setEnabled(false);
		planetList.addListSelectionListener(new ListSelectionListener(){
			public void valueChanged(ListSelectionEvent e) {
   			if (e.getValueIsAdjusting() == false)
			{
	        		if (planetList.getSelectedIndex() == -1)
				{
        				done.setEnabled(false);
		        	}
				else
				{
       		 			done.setEnabled(true);
					Empire empire = (Empire) planetList.getSelectedValue();
					info.setText(empire.getBlurb() + "\n\n" + empire.getDescription());
					info.setCaretPosition(0);

        			}
    			}
		}});

		frame.pack();
		frame.show();
		while (frame.isVisible())
		{

			try
			{
				Thread.sleep(500);
			}
			catch (Exception h)
			{
				System.out.println("Problem sleeping!");
			}

			Empire empir = null;

			if (planetList.getSelectedIndex() > -1)
			{
				empir = (Empire) planetList.getSelectedValue();
			}

			Vector empirs = psi.getEmpires();

			if (availableEmpires.size() != empirs.size())
			{

				planetList.setListData(empirs);

				if (empir != null)
				{
					boolean found = false;

					for (int i = 0; i < empirs.size(); i++)
					{
						Empire emp = (Empire) empirs.elementAt(i);

						if (empir.getRace().equals(emp.getRace()))
						{
							planetList.setSelectedIndex(i);
							i = empirs.size();
							found = true;
						}
					}

					if (!found)
					{
						info.setText("Planet Info");
					}
				}

				availableEmpires = empirs;
			}

		}
  	}


	public void wait(int phase, int turn) throws Exception
  	{

	    	final JFrame frame = new JFrame("Pax Galaktika - Waiting");
		frame.setSize(350, 550);
		frame.setResizable(false);
		frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    		frame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 3;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		frame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 3;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Waiting For Other Players");
		frame.getContentPane().add(waitingLabel, gbc);

		gbc.gridy = 2;

		gbc.fill = GridBagConstraints.HORIZONTAL;

		JProgressBar progressBar = new JProgressBar();
		progressBar.setIndeterminate(true);
		frame.getContentPane().add(progressBar, gbc);

		frame.pack();
		frame.show();

		while (!psi.ready(phase, turn))
		{
		    	try
			{
				Thread.sleep(100);
			}
			catch (Exception e)
			{
				System.out.println("Can't sleep!");
			}
		}

		frame.dispose();

	}

	// Wait for all players to finish defensive redeploy.

	public void waitDeploy() throws Exception
  	{

	    	final JFrame frame = new JFrame("Pax Galaktika - Waiting");
		frame.setSize(350, 550);
		frame.setResizable(false);
		frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    		frame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 3;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		frame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 3;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Waiting For Other Players to Redeploy");
		frame.getContentPane().add(waitingLabel, gbc);

		gbc.gridy = 2;

		gbc.fill = GridBagConstraints.HORIZONTAL;

		JProgressBar progressBar = new JProgressBar();
		progressBar.setIndeterminate(true);
		frame.getContentPane().add(progressBar, gbc);

		frame.pack();
		frame.show();

		while (!psi.checkDeploy())
		{
		    	try
			{
				Thread.sleep(100);
			}
			catch (Exception e)
			{
				System.out.println("Can't sleep!");
			}
		}

		frame.dispose();

	}

	// Wait for all players to finish PvP combat.

	public Vector waitPvP(boolean ground) throws Exception
  	{

	    	final JFrame frame = new JFrame("Pax Galaktika - Waiting");
		frame.setSize(350, 550);
		frame.setResizable(false);
		frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    		frame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 3;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		frame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 3;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Waiting For Other Players");
		frame.getContentPane().add(waitingLabel, gbc);

		gbc.gridy = 2;

		gbc.fill = GridBagConstraints.HORIZONTAL;

		JProgressBar progressBar = new JProgressBar();
		progressBar.setIndeterminate(true);
		frame.getContentPane().add(progressBar, gbc);

		frame.pack();
		frame.show();

		/*
		while (!psi.checkDeploy())
		{
		    	try
			{
				Thread.sleep(100);
			}
			catch (Exception e)
			{
				System.out.println("Can't sleep!");
			}
		}*/

		Vector results = new Vector();

		if (!ground)
		{
			results = psi.getNeutralSpaceBattles(name);
		}
		else
		{
			results = psi.getGroundBattles(name);
		}

		frame.dispose();

		return results;

	}

	public void showMessages(Vector temp)
	{
		if (temp.size() > 0)
		{

			final JFrame frame = new JFrame("Pax Galaktika - Intergalactic Messages");
			frame.setSize(550, 750);
			frame.setResizable(false);
			frame.getContentPane().setLayout(new GridBagLayout());

			GridBagConstraints gbc = new GridBagConstraints();

			gbc.insets.right = 5;
			gbc.insets.left = 5;
			gbc.insets.bottom = 5;
			gbc.insets.top = 5;

			gbc.gridheight = 1;
			gbc.gridwidth = 4;
			gbc.gridx = 0;
			gbc.gridy = 0;

			BannerCanvas bc = new BannerCanvas();
			frame.getContentPane().add(bc, gbc);

			gbc.gridy = 1;
			gbc.gridwidth = 4;

			gbc.fill = GridBagConstraints.NONE;

			JLabel messageLabel = new JLabel("Intergalactic Messages: ");
			frame.getContentPane().add(messageLabel, gbc);

			gbc.fill = GridBagConstraints.HORIZONTAL;

			gbc.gridx = 0;
			gbc.gridy = 2;
			gbc.gridwidth = 4;
			gbc.gridheight = 3;

			final JTextArea info = new JTextArea("Messages:\n\n", 16, 20);
			info.setLineWrap(true);
			info.setWrapStyleWord(true);
			info.setEditable(false);
			info.setFont(new Font("Serif", 1, 14));
			JScrollPane scroll2 = new JScrollPane(info);
			frame.getContentPane().add(scroll2, gbc);

			for (int i = 0; i < temp.size(); i++)
			{
				Message mess = (Message) temp.elementAt(i);
				info.setText(info.getText() + mess.toString() + "\n\n");
				info.setCaretPosition(0);
			}

			gbc.gridy = 5;
			gbc.gridx = 0;
			gbc.gridwidth = 4;

			JButton done = new JButton("Continue!");
			done.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){
				frame.dispose();
			}});
			frame.getContentPane().add(done, gbc);

			frame.pack();
			frame.show();
			/*
			while (frame.isVisible())
			{
			}
			*/

		}
	}


	public Battle battle(Battle b2, boolean space) throws Exception
  	{
    	Color color = new Color(121);
		delay = true;

		final boolean space2 = space;
		b = b2;

		final Vector<JComboBox> targets = new Vector<JComboBox>();

	   	final JFrame frame = new JFrame(name + " - Pax Galaktika - Battle");
		frame.setSize(350, 550);
		frame.setResizable(false);
		frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		frame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		final int participants = b.getCombatants().size();

		gbc.fill = GridBagConstraints.NONE;

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 3;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		frame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 3;

		JLabel waitingLabel = new JLabel("Battle Menu");
		frame.getContentPane().add(waitingLabel, gbc);

		gbc.gridy = 2;
		gbc.gridheight = 4;
		gbc.gridwidth = 3;

		gbc.fill = GridBagConstraints.HORIZONTAL;


		JPanel forcesPanel = new JPanel();
		forcesPanel.setLayout(new GridBagLayout());

		GridBagConstraints gbc2 = new GridBagConstraints();
		gbc2.fill = GridBagConstraints.HORIZONTAL;
		gbc2.insets.right = 5;
		gbc2.insets.left = 5;
		gbc2.insets.bottom = 5;
		gbc2.insets.top = 5;

		gbc2.gridheight = 1;
		gbc2.gridwidth = 1;
		gbc2.gridx = 0;
		gbc2.gridy = 0;

		int playIndex = 0;

		final Vector forceLists = new Vector();
		final Vector damageLabels = new Vector();
		final Vector rangeLabels = new Vector();
		final Vector armorLabels = new Vector();

		for (int i = 0; i < participants; i++, playIndex++)
		{
			JPanel tempPanel = new JPanel();
			tempPanel.setLayout(new GridBagLayout());

			GridBagConstraints gbc3 = new GridBagConstraints();

			gbc3.fill = GridBagConstraints.HORIZONTAL;
			gbc3.insets.right = 5;
			gbc3.insets.left = 5;
			gbc3.insets.bottom = 5;
			gbc3.insets.top = 5;

			Combatant c = (Combatant) b.getCombatants().elementAt(i);

			// Restoring ArmorPoints!!
			c.restoreAllForces();

			int tempGridy = 0;

			// Set up targetting priority for this participant.
			if (!c.getName().equals(player.getName()))
			{
				JComboBox targetting = new JComboBox();

				for (int t = 1; t < participants; t++)
				{
					targetting.addItem("Target Priority: " + t);
				}

				targetting.addItem("Do not target.");

				targetting.setSelectedIndex(playIndex);

				gbc3.gridy = tempGridy;
				tempGridy++;

				tempPanel.add(targetting, gbc3);
				targets.addElement(targetting);
			}
			else
			{
				JLabel placeHolder = new JLabel(" ");
				placeHolder.setFont(new Font("Serif", 1, 17));

				gbc3.gridy = tempGridy;
				tempGridy++;

				tempPanel.add(placeHolder, gbc3);

				playIndex--;
			}

			gbc3.gridx = 0;
			gbc3.gridy = 0;
			gbc3.gridwidth = 2;

			gbc3.insets.right = 5;
			gbc3.insets.left = 5;
			gbc3.insets.bottom = 1;
			gbc3.insets.top = 1;

			for (int t = 0; t < c.getUnits().size(); t++)
			{
				Unit u = (Unit) c.getUnits().elementAt(t);

				gbc3.gridy = tempGridy;

				JLabel nameLabel = new JLabel(u.getName());
				nameLabel.setFont(new Font("Serif", 1, 10));
				tempPanel.add(nameLabel, gbc3);

				tempGridy++;
			}

			gbc3.insets.right = 5;
			gbc3.insets.left = 5;
			gbc3.insets.bottom = 5;
			gbc3.insets.top = 5;

			gbc3.gridx = 0;
			gbc3.gridy = tempGridy;//1;//0;
			gbc3.gridwidth = 2;


			tempPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), c.getName(), 0, 0, new Font("Dialog", 1, 16), color.BLUE));

			// Only for your own list.
			if (c.getName().equals(player.getName()))
			{
				newC = c;
				final JList yourList = new JList(c.getAllForces());
				final int indice = i;

				ListCellRenderer battleRenderer = new BattleRenderer();
				yourList.setCellRenderer(battleRenderer);


				// MouseListener for your list of forces.  Double click to change committment.
				if (space)
				{
					MouseListener mouseListener = new MouseAdapter() {
     					public void mouseClicked(MouseEvent e) {
  			       			if (e.getClickCount() > 1)
						{
             				int index = yourList.locationToIndex(e.getPoint());
             				//System.out.println("Doubleclicked on Item " + index);

							Force force = (Force) yourList.getSelectedValue();

							if (force.getCommitted())
							{
								force.setCommitted(false);
							}
							else
							{
								force.setCommitted(true);
							}

							JLabel rangeLabel = (JLabel) rangeLabels.elementAt(indice);
							rangeLabel.setText("Attack: " + newC.getDamageRange());

							yourList.repaint();
						}
					}};
 					yourList.addMouseListener(mouseListener);
				}

				JScrollPane forcePane = new JScrollPane(yourList);
				forcePane.setPreferredSize(new Dimension(200, 140));

				tempPanel.add(forcePane, gbc3);//forceList, gbc3);
				forceLists.addElement(yourList);
			}
			else
			{

				JList forceList = new JList(c.getAllForces());

				ListCellRenderer battleRenderer = new BattleRenderer();
				forceList.setCellRenderer(battleRenderer);

				JScrollPane forcePane = new JScrollPane(forceList);
				forcePane.setPreferredSize(new Dimension(200, 140));

				tempPanel.add(forcePane, gbc3);//forceList, gbc3);
				forceLists.addElement(forceList);
			}

			tempGridy++;
			gbc3.gridy = tempGridy;//2;//1;
			gbc3.gridwidth = 1;

			JLabel rangeLabel = new JLabel("Attack: " + c.getDamageRange());
			//damageLabel.setForeground(color.RED);
			//rangeLabel.setFont(new Font("Serif", 1, 18));
			tempPanel.add(rangeLabel, gbc3);
			rangeLabels.addElement(rangeLabel);

			gbc3.gridx = 1;
			JLabel armorLabel = new JLabel("Armor: " + c.getArmor());
			tempPanel.add(armorLabel, gbc3);
			armorLabels.addElement(armorLabel);

			tempGridy++;
			gbc3.gridy = tempGridy;//2;//1;
			gbc3.gridwidth = 1;
			gbc3.gridx = 0;

			JLabel damageLabel = new JLabel("                  ");
			damageLabel.setForeground(color.RED);
			damageLabel.setFont(new Font("Serif", 1, 24));
			tempPanel.add(damageLabel, gbc3);
			damageLabels.addElement(damageLabel);

			gbc3.gridx = 1;
			JLabel tempLabel = new JLabel("Total Attack!");
			tempPanel.add(tempLabel, gbc3);

			forcesPanel.add(tempPanel, gbc2);

			gbc2.gridx = gbc2.gridx+1;

		}

		// Add ItemListeners for the combo boxes so that each priority is distinct.
		for (int i = 0; i < targets.size(); i++)
		{
			int playerIndex = b.getCombatants().indexOf(newC);

			JComboBox combo = targets.elementAt((playerIndex+i)%targets.size());

			combo.setSelectedIndex(i);

			combo.addItemListener(new ItemListener(){
						public void itemStateChanged(ItemEvent e){

								int chosenTargets = 0;
								int delta = 0;

								for (int t = 0; t < targets.size(); t++)
								{
									if (targets.elementAt(t).getSelectedIndex() < participants-1)
									{
										chosenTargets++;
									}
								}

								for (int t = 0; t < chosenTargets; t++)
								{
									boolean found = false;

									for (int z = 0; z < targets.size(); z++)
									{
										if (targets.elementAt(z).getSelectedIndex() == t)
										{
											found = true;
											break;
										}
									}

									if (!found)
									{
										delta = ((JComboBox)e.getSource()).getSelectedIndex() - t;

										break;
									}
								}

								if (delta < 0)
								{
									for (int z = 0; z < targets.size(); z++)
									{
										if (!e.getSource().equals(targets.elementAt(z)) && targets.elementAt(z).getSelectedIndex() == ((JComboBox)e.getSource()).getSelectedIndex())
										{
											targets.elementAt(z).setSelectedIndex(targets.elementAt(z).getSelectedIndex()+1);
										}
									}
								}
								else if (delta > 0)
								{
									for (int z = 0; z < targets.size(); z++)
									{
										if (!e.getSource().equals(targets.elementAt(z)) && targets.elementAt(z).getSelectedIndex() == ((JComboBox)e.getSource()).getSelectedIndex())
										{
											targets.elementAt(z).setSelectedIndex(targets.elementAt(z).getSelectedIndex()-1);
										}
									}

								}
			}});
		}


		frame.getContentPane().add(forcesPanel, gbc);

		MapCanvas mc = new MapCanvas(player, map, null, null, null, null, null, null);
		mc.addBattle(b);

		final JScrollPane mapScroll = new JScrollPane(mc);
		mapScroll.setPreferredSize(new Dimension(420,180));

		mapScroll.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Battle Zone", 0, 0, new Font("Dialog", 1, 12), color.BLACK));

		// Setting initial scrollbar positions;

  		Runnable doScroll = new Runnable() {
             		public void run() {
				try
				{
					Thread.sleep(300);
				}
				catch (Exception e)
				{
					System.out.println("Can't sleep to set scrollbars! " + e.toString());
				}
				JScrollBar vertical = mapScroll.getVerticalScrollBar();
				int y = b.getLocation().getPositionY() - 1;
				y *= 60;
				if (y > 0)
				{
					y += 20;
				}

				//System.out.println("Y: " + y);
            	 		vertical.setValue(y);

				JScrollBar horizontal = mapScroll.getHorizontalScrollBar();

				int x = b.getLocation().getPositionX() - 2;

				x *= 90;

				if (x < 0)
				{
					x = 0;
				}

				//System.out.println("X: " + x);
				horizontal.setValue(x);

				}
         		};

        SwingUtilities.invokeLater(doScroll);


		gbc.gridy = 6;
		gbc.gridheight = 1;

		frame.getContentPane().add(mapScroll, gbc);

		gbc.gridy = 7;

		// JLabel for committed info;
		JLabel committ = new JLabel("Double click on a force to change their committment status.", 0);
		frame.getContentPane().add(committ, gbc);

		gbc.gridy = gbc.gridy+1;
		gbc.gridheight = 1;

		final JButton holdFire = new JButton("Hold your Fire!");
		holdFire.setEnabled(true);

		final JButton fire = new JButton("Open Fire!");
		fire.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){
				try
				{
					int finished = JOptionPane.showConfirmDialog(frame, "Uncommitted forces will not open fire.\nThey also won't be targeted until all your committed forces are destroyed.\n\nOpen fire with all committed forces?", "Open Fire?", JOptionPane.YES_NO_OPTION);

					if (finished == 0)
					{
						fire.setEnabled(false);
						holdFire.setEnabled(false);

						// Set up the set of targets.
						newC.getTargets().clear();
						Vector<JComboBox> boxes = new Vector<JComboBox>();

						for (int i = 0; i < targets.size(); i++)
						{
							boxes.addElement(targets.elementAt(i));
						}

						Collections.sort(boxes, new PaxTargetComboBoxComparator());

						for (int i = 0; i < boxes.size(); i++)
						{
							//System.out.println("Selected index: " + boxes.elementAt(i).getSelectedIndex());
							if (boxes.elementAt(i).getSelectedIndex() < participants-1)
							{

								int targetIndex  = targets.indexOf(boxes.elementAt(i));
								int mod = 0;

								for (int t = 0; t <= targetIndex; t++)
								{
									Combatant test = (Combatant) b.getCombatants().elementAt(t);

									if (test.getName().equals(newC.getName()))
									{
										mod++;
									}
								}

								//System.out.println(mod + ", " + targets.indexOf(boxes.elementAt(i)) + ", " + b.getCombatants().indexOf(newC));
								Combatant nextTarget = (Combatant)b.getCombatants().elementAt(targets.indexOf(boxes.elementAt(i))+mod);
								//System.out.println("Targeting: " + nextTarget);
								newC.getTargets().addElement(nextTarget);
							}
						}


						psi.setReadyForBattle(name, b.getLocation(), true, newC);

						System.out.println("We are ready for battle!");

						while (!psi.isReadyForBattle(b.getLocation()))
						{
							try
		    					{
								Thread.sleep(100);
							}
							catch (Exception g)
		    					{
								System.out.println("Can't sleep!");
							}
						}

						b = (psi.findBattle(b.getLocation()));

						for (int k =0; k < b.getCombatants().size(); k++)
						{
							Combatant c = (Combatant) b.getCombatants().elementAt(k);

							if (c.getName().equals(player.getName()))
							{
								newC = c;
							}

							//System.out.println(c.getAllForces());

							JLabel damageLabel = (JLabel) damageLabels.elementAt(k);
							damageLabel.setText("        "+c.getDamage());

							JLabel rangeLabel = (JLabel) rangeLabels.elementAt(k);
							rangeLabel.setText("Attack: " + c.getDamageRange());

							JLabel armorLabel = (JLabel) armorLabels.elementAt(k);
							armorLabel.setText("Armor: " + c.getArmor());


						}

						delay = false;
					}
				}

				catch (Exception h)
				{
					System.out.println("Problem with fire! " + h.toString());
				}

			}});
		frame.getContentPane().add(fire, gbc);

		gbc.gridy = gbc.gridy+1;

		holdFire.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				try
				{
					int finished = JOptionPane.showConfirmDialog(frame, "Your foe will still have the opportunity to attack if you hold your fire.  \nIf all sides hold their fire, the battle will end this round.  \nNeutral units will NEVER hold their fire. \n\nDo you still wish to hold your fire?", "Hold Fire?", JOptionPane.YES_NO_OPTION);

					if (finished == 0)
					{

						fire.setEnabled(false);
						holdFire.setEnabled(false);

						psi.setReadyForBattle(name, b.getLocation(), false, newC);

						System.out.println("We are ready to hold fire!");

						while (!psi.isReadyForBattle(b.getLocation()))
						{
							try
		    					{
								Thread.sleep(100);
							}
							catch (Exception g)
		    					{
								System.out.println("Can't sleep!");
							}
						}

						b = (psi.findBattle(b.getLocation()));

						for (int k =0; k < b.getCombatants().size(); k++)
						{
							Combatant c = (Combatant) b.getCombatants().elementAt(k);

							if (c.getName().equals(player.getName()))
							{
								newC = c;
							}

							System.out.println(c.getAllForces());

							JLabel damageLabel = (JLabel) damageLabels.elementAt(k);
							damageLabel.setText("        "+c.getDamage());

							JLabel rangeLabel = (JLabel) rangeLabels.elementAt(k);
							rangeLabel.setText("Attack: " + c.getDamageRange());

							JLabel armorLabel = (JLabel) armorLabels.elementAt(k);
							armorLabel.setText("Armor: " + c.getArmor());

						}

						delay = false;
					}
				}
				catch (Exception h)
				{
					System.out.println("Problem! " + h.toString());
				}

			}});

		frame.getContentPane().add(holdFire, gbc);


		gbc.gridy = gbc.gridy+1;

		final JButton done = new JButton("Done");
		done.setEnabled(false);
		done.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
			//delay = false;

			Location l = null;

			for (int t = 0; t < b.getCombatants().size(); t++)
			{

				Combatant c = (Combatant) b.getCombatants().elementAt(t);

				for (int k = 0; k < c.getUnits().size(); k++)
				{
					Unit u = (Unit) c.getUnits().elementAt(k);

					l = u.getLocation();

					if (u.getForces().size() == 0)
					{
						l = u.getLocation();
						l.removeUnit(u);
					}

				}
			}

			try
			{
				psi.doneBattle(l, space2);
			}
			catch (Exception ee)
			{
			}
			System.out.println("Finished battle!");
			frame.dispose();
			delay = false;

			}});

		frame.getContentPane().add(done, gbc);

		/*
		JProgressBar progressBar = new JProgressBar();
		progressBar.setIndeterminate(true);
		frame.getContentPane().add(progressBar, gbc);*/

		frame.pack();
		frame.show();
/*
		while (!psi.ready(phase, turn))
		{
		    	try
			{
				Thread.sleep(100);
			}
			catch (Exception e)
			{
				System.out.println("Can't sleep!");
			}
		}

		frame.dispose();*/
		while (frame.isVisible())
		{
			while (delay)
			{

			}
			try
			{
				Thread.sleep(2000);
			}
			catch (Exception e)
			{
				System.out.println("Can't sleep!");
			}

			if (frame.isVisible())
			{

			int stillFighting = 0; // number of combatants still fighting.
			boolean damageDone = false; // indicates whether damage was done in the last round, if not
						    // we end the battle.

			for (int i = 0; i < b.getCombatants().size(); i++)
			{
				Combatant c = (Combatant) b.getCombatants().elementAt(i);

				JList forceList = (JList) forceLists.elementAt(i);
				forceList.setListData(c.getAllForces());

				if (c.getSize() > 0)
				{
					stillFighting++;
				}

				// Checking if anyone did damage in the last round.
				if (c.getDamage() > 0)
				{
					damageDone = true;
				}
			}

			// End battle if no damage was inflicted in the last round.
			if (stillFighting > 1 && damageDone)
			{
				fire.setEnabled(true);
				holdFire.setEnabled(true);

			}
			else
			{
				done.setEnabled(true);

				if (!damageDone)
				{
					System.out.println("No damage inflicted - ending battle!");
				}
			}



			delay = true;

			}
		}

		return b;

	}


	public void assignPlanets() throws Exception
	{
			for (int t = 0; t <player.getEmpire().getGroundUnits().size(); t++)
			{
				Unit gu = (Unit) player.getEmpire().getGroundUnits().elementAt(t);

				if (!gu.isEmpty() && (!gu.getLoaded() || gu.getGroundInvade()))
				{
					Location l = gu.getLocation();

					for (int k = 0; k < l.getPlanets().size(); k++)
					{
						Planet plan = (Planet) l.getPlanets().elementAt(k);
						System.out.println("Over planet " + plan);

						// Should we add this planet?
						boolean addPlanet = true;

						for (int z = 0; z < player.getEmpire().getPlanets().size(); z++)
						{
							Planet plan2 = (Planet) player.getEmpire().getPlanets().elementAt(z);
							if (plan.getName().equals(plan2.getName()))
							{
								addPlanet = false;
							}
						}

						gu.setGroundInvade(false);

						if (addPlanet)
						{
							gu.setLoaded(false);

							boolean found = false;

							// Find who had that planet - if we can't it must be neutral, use
							// the one grabbed from that location.

							for (int z = 0; z < map.getPlayers().size(); z++)
							{
								Player p = (Player) map.getPlayers().elementAt(z);

								for (int m = 0; m < p.getEmpire().getPlanets().size(); m++)
								{
									Planet plane = (Planet) p.getEmpire().getPlanets().elementAt(m);
									if (plane.getName().equals(plan.getName()))
									{
										plan = plane;
										m = p.getEmpire().getPlanets().size();
										z = map.getPlayers().size();
										found = true;
									}
								}
							}

							// Must be a neutral planet, find it.

							if (!found)
							{
								System.out.println("Searching for planet to add from neutral empires!");
								Vector empires = new Vector();

								try
								{
									empires = psi.getEmpires();
								}
								catch (Exception ee)
								{
									System.out.println("Could not get neutral empires!" + ee.toString());
								}

								for (int z = 0; z < empires.size(); z++)
								{
									Empire e = (Empire) empires.elementAt(z);

									for (int a = 0; a < e.getPlanets().size(); a++)
									{
										Planet planet = (Planet) e.getPlanets().elementAt(a);
										if (planet.getName().equals(plan.getName()))
										{
											plan = planet;													     }

									}
								}
							}

							// Setting current industry to zero.
							plan.setCurrentIndustry(0);
							plan.setCaptured(true);
							(player.getEmpire().getPlanets()).addElement(plan);
							System.out.println("Add planet!");

							// Send message regarding planet capture.
							Vector messages = new Vector();
							Message m = new Message("After a vicious ground battle, " + player.getName() + " has wrested control of the planet " + plan.getName() + " from " + plan.getOwner() + "!", true);
							messages.addElement(m);
							psi.sendMessages(messages);

							// Checking if Tech should be increased!
							found = false;
							for (int z = 0; z < map.getPlayers().size(); z++)
							{
								Player p = (Player) map.getPlayers().elementAt(z);

								if (plan.getOwner().equals(p.getName()))
								{
									System.out.println("Checking tech!");
									found = true;

									if (p.getEmpire().getTech() > player.getEmpire().getTech())
									{
									    int newTech = (p.getEmpire().getTech() + player.getEmpire().getTech())/2;
									    System.out.println("Increasing tech to " + newTech);
									    player.getEmpire().setTech(newTech);
									}
								}
							}
							// Setting tech for captured neutral planets.
							if (!found)
							{
								System.out.println("Searching for planet to remove from neutral empires!");
								Vector empires = new Vector();

								try
								{
									empires = psi.getEmpires();
								}
								catch (Exception ee)
								{
									System.out.println("Could not get neutral empires!" + ee.toString());
								}

								for (int z = 0; z < empires.size(); z++)
								{
									Empire e = (Empire) empires.elementAt(z);

									for (int a = 0; a < e.getPlanets().size(); a++)
									{
										Planet planet = (Planet) e.getPlanets().elementAt(a);
										if (planet.getName().equals(plan.getName()))
										{
											System.out.println("Checking tech!");
											if (e.getTech() > player.getEmpire().getTech())
											{
									 		   int newTech = (e.getTech() + player.getEmpire().getTech())/2;
									    		   System.out.println("Increasing tech to " + newTech);
									    		   player.getEmpire().setTech(newTech);
											}

											try
											{
												psi.removeNeutralPlanet(planet.getName());
											}
											catch (Exception ex)
											{
												System.out.println("Cannot remove neutral planet! " + ex.toString());
											}
										}

									}
								}

							}

							plan.setOwner(player.getName());

							System.out.println(player.getEmpire().getPlanets());
						}
					}

				}
			}

			// Check if any planets need to be removed.

			try
			{
				//player.getEmpire().setPlanets(psi.checkPlanets(name, player.getEmpire().getPlanets()));
			}
			catch (Exception e)
			{
				System.out.println("Couldn't check planets!");
			}


	}


	// This method determines if a player has been eliminated from the game, in which case their client
	// must be closed.  This occurs when they have zero planets and space units.

	public boolean eliminated(Player player)
	{
		boolean result = false;

		if (player.getEmpire().getPlanets().size() == 0)
		{
			result = true;


			for (int i = 0; i < player.getEmpire().getSpaceUnits().size(); i++)
			{
				Unit u = (Unit) player.getEmpire().getSpaceUnits().elementAt(i);
				if (u.getForces().size() != 0)
				{
					result = false;
				}
			}

		}

		if (result)
		{
			System.out.println("You have been eliminated!");
			try
			{
				psi.removePlayer(player.getName());
			}
			catch (Exception e)
			{
				System.out.println("Can't get rid of " + player.getName());
			}

		}

		return result;
	}


	// The pruneNeutrals() method searches a vector of battles and removes any duplicates (ie. any battles
	// that are at the same location as a previous one.)

	public void pruneNeutrals(Vector battles)
	{
		Location loc = null;

		for (int i = 0; i < battles.size(); i++)
		{
			Battle b = (Battle) battles.elementAt(i);

			Location loc2 = b.getLocation();

			// This battle is identical to a previous one, so remove it.
			if (i > 0 && loc.getPositionX() == loc2.getPositionX() && loc.getPositionY() == loc2.getPositionY())
			{
				battles.removeElementAt(i-1);
				i--;
			}

			loc = loc2;
		}
	}

	// This method takes in a vector of battles and returns a vector that contains only those
	// where the current player has a station - in essence, the ones where defense redeploy is
	// permissable.

	public Vector checkRedeploy(Vector battles) throws Exception
	{
		Vector newBattles = new Vector();

		// Check battles for stations.
		for (int i = 0; i < battles.size(); i++)
		{
			Battle b = (Battle) battles.elementAt(i);
			boolean station = false;

			// Loop through combatants to find the right one.
			for (int t = 0; t < b.getCombatants().size(); t++)
			{
				Combatant c = (Combatant) b.getCombatants().elementAt(t);

				// This is the right combatant; check forces for station;
				if (c.getName().equals(player.getName()))
				{
					for (int z = 0; z < c.getAllForces().size(); z++)
					{
						Force f = (Force) c.getAllForces().elementAt(z);

						if (!f.getMobile())
						{
							station = true;
							System.out.println("There is a station in battle " + b);
						}
					}
				}
			}

			if (station)
			{
				newBattles.addElement(b);
			}
		}
		return newBattles; // battles;
	}

	// The defensive redeploy method allows you to move forces that are within range of a battle with a station on your
	// side.  We're assuming the vector of battles passed in are only those where defensive redploy is an option.
	// They can look at all battles and move to ones as needed.  Only executed when there is at least one valid battle.
	// TextArea to display battle being redeployed to.
	// JList for the unit being redeployed from, with a distance listed above it.
	// Returns a boolean as to whether the user has confirmed their choices.

	public boolean defensiveRedeploy(Vector battles, Vector totalBattle) throws Exception
  	{
		final Color color = new Color(121);
		confirmed = false;

		// Getting current battle and current unit - we know there's at least one of each.
		Battle bat = (Battle) battles.elementAt(0);
		Unit un = (Unit) player.getEmpire().getSpaceUnits().elementAt(0);
		final Vector totalBattles = totalBattle;

		// Figure the distance between the two quantities
		int distance = map.distance(bat.getLocation(), un.getLocation());


	    	final JFrame frame = new JFrame("Pax Galaktika - Defensive Redeploy");
		frame.setSize(450, 550);
		frame.setResizable(false);
		frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		frame.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets.right = 5;
		gbc.insets.left = 5;
		gbc.insets.bottom = 5;
		gbc.insets.top = 5;

		gbc.gridheight = 1;
		gbc.gridwidth = 4;
		gbc.gridx = 0;
		gbc.gridy = 0;

		BannerCanvas bc = new BannerCanvas();
		frame.getContentPane().add(bc, gbc);

		gbc.gridy = 1;
		gbc.gridwidth = 4;

		gbc.fill = GridBagConstraints.NONE;

		JLabel waitingLabel = new JLabel("Defensive Redeploy", 0);
		frame.getContentPane().add(waitingLabel, gbc);

		gbc.gridy = 2;
		gbc.gridwidth = 2;


		// Redeploy from Panel.

		JPanel from = new JPanel();
		from.setLayout(new GridBagLayout());
		from.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Nearby Units", 0, 0, new Font("Dialog", 1, 16), color.BLUE));

		GridBagConstraints gbc2 = new GridBagConstraints();

		gbc2.insets.right = 5;
		gbc2.insets.left = 5;
		gbc2.insets.bottom = 5;
		gbc2.insets.top = 5;

		gbc2.gridheight = 1;
		gbc2.gridwidth = 1;
		gbc2.gridx = 0;
		gbc2.gridy = 0;

		JLabel unitLabel = new JLabel("Select a Unit: ");
		from.add(unitLabel, gbc2);

		gbc2.gridx = 1;

		final JComboBox unitBox = new JComboBox(player.getEmpire().getSpaceUnits());
		from.add(unitBox, gbc2);

		gbc2.gridx = 0;
		gbc2.gridy = gbc2.gridy+1;
		gbc2.gridwidth = 2;

		final JLabel distanceLabel = new JLabel("Distance to Current Battle: " + distance, 0);
		distanceLabel.setFont(new Font("Dialog", 1, 12));
		if (distance == 0)
		{
			distanceLabel.setForeground(color.RED);
		}
		else
		{
			distanceLabel.setForeground(color.GREEN.darker());
		}
		from.add(distanceLabel, gbc2);

		gbc2.gridx = 0;
		gbc2.gridy = gbc2.gridy+1;
		gbc2.gridwidth = 2;

		final JList forceList = new JList(un.getForces());
		ListSelectionModel lsm = forceList.getSelectionModel();
		lsm.setSelectionMode(0);
		JScrollPane forceScroll = new JScrollPane(forceList);
		forceScroll.setPreferredSize(new Dimension(200, 100));

		ListCellRenderer unitRenderer = new UnitRenderer();
		forceList.setCellRenderer(unitRenderer);

		from.add(forceScroll, gbc2);

		//from.setPreferredSize(new Dimension(200, 300));

		final JLabel battleHere = new JLabel("No battle at this unit's location.");

		gbc2.gridy = gbc2.gridy+1;
		from.add(battleHere, gbc2);

		gbc2.gridy = gbc2.gridy+1;

		final JTextArea textBattleHere = new JTextArea("", 35, 25);
		textBattleHere.setLineWrap(true);
		textBattleHere.setWrapStyleWord(true);
		textBattleHere.setEditable(false);
		textBattleHere.setFont(new Font("Serif", 1, 12));
		JScrollPane textScrollHere = new JScrollPane(textBattleHere);
		textScrollHere.setPreferredSize(new Dimension(200, 130));

		from.add(textScrollHere, gbc2);

		Battle tempBattle = findBattle(un, totalBattles);

		if (tempBattle != null)
		{
			battleHere.setText("This unit is in a battle!");
			battleHere.setForeground(color.RED);

			textBattleHere.setText("");

			for (int i = 0; i < tempBattle.getCombatants().size(); i++)
			{
				Combatant c = (Combatant) tempBattle.getCombatants().elementAt(i);

				textBattleHere.setText(textBattleHere.getText() + c.display());
			}

			textBattleHere.setCaretPosition(0);

		}

		frame.getContentPane().add(from, gbc);

		// Redeploy to panel.

		gbc.gridx = 2;

		JPanel to = new JPanel();
		to.setLayout(new GridBagLayout());
		to.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(1), "Battle View", 0, 0, new Font("Dialog", 1, 16), color.BLUE));

		GridBagConstraints gbc3 = new GridBagConstraints();

		gbc3.insets.right = 5;
		gbc3.insets.left = 5;
		gbc3.insets.bottom = 5;
		gbc3.insets.top = 5;

		gbc3.gridheight = 1;
		gbc3.gridwidth = 1;
		gbc3.gridx = 0;
		gbc3.gridy = 0;

		JLabel battleLabel = new JLabel("Select a Battle: ");
		to.add(battleLabel, gbc3);

		gbc3.gridx = 1;

		final JComboBox battleBox = new JComboBox(battles);
		to.add(battleBox, gbc3);

		gbc3.gridx = 0;
		gbc3.gridy = gbc3.gridy+1;
		gbc3.gridwidth = 2;

		// Set up a text area to show the battle information.

		final JTextArea textBattle = new JTextArea("", 35, 25);
		textBattle.setLineWrap(true);
		textBattle.setWrapStyleWord(true);
		textBattle.setEditable(false);
		textBattle.setFont(new Font("Serif", 1, 12));
		JScrollPane textScroll = new JScrollPane(textBattle);
		textScroll.setPreferredSize(new Dimension(200, 293));

		to.add(textScroll, gbc3);

		for (int i = 0; i < bat.getCombatants().size(); i++)
		{
			Combatant c = (Combatant) bat.getCombatants().elementAt(i);

			textBattle.setText(textBattle.getText() + c.display());
		}

		battleBox.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
			    	Battle b = (Battle) battleBox.getSelectedItem();

				// Refresh the textarea.

				textBattle.setText("");

				for (int i = 0; i < b.getCombatants().size(); i++)
				{
					Combatant c = (Combatant) b.getCombatants().elementAt(i);

					textBattle.setText(textBattle.getText() + c.display());
				}


				// Reset the distance label here!

				Unit u = (Unit) unitBox.getSelectedItem();

				int distant = map.distance(b.getLocation(), u.getLocation());

				distanceLabel.setText("Distance to Current Battle: " + distant);

				if (distant == 0)
				{
					distanceLabel.setForeground(color.RED);
				}
				else
				{
					distanceLabel.setForeground(color.GREEN.darker());
				}
		}});

		final MapCanvas mc = new MapCanvas(player, map, null, null, null, null, null, null);

		unitBox.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
			    	Unit u = (Unit) unitBox.getSelectedItem();

				// Refresh the JList.

				forceList.setListData(u.getForces());

				// Reset the distance label here!
				Battle b = (Battle) battleBox.getSelectedItem();

				int distant = map.distance(b.getLocation(), u.getLocation());

				distanceLabel.setText("Distance to Current Battle: " + distant);

				if (distant == 0)
				{
					distanceLabel.setForeground(color.RED);
				}
				else
				{
					distanceLabel.setForeground(color.GREEN.darker());
				}

				mc.setCurrentUnit(u, unitBox.getSelectedIndex());

				Battle tempBattle = findBattle(u, totalBattles);

				if (tempBattle != null)
				{
					battleHere.setText("This unit is in a battle!");
					battleHere.setForeground(color.RED);

					textBattleHere.setText("");

					for (int i = 0; i < tempBattle.getCombatants().size(); i++)
					{
						Combatant c = (Combatant) tempBattle.getCombatants().elementAt(i);

						textBattleHere.setText(textBattleHere.getText() + c.display());
					}

					textBattleHere.setCaretPosition(0);

				}
				else
				{
					battleHere.setText("No battle at this unit's location.");
					battleHere.setForeground(color.BLACK);

					textBattleHere.setText("");
				}
		}});

		if ((Unit)unitBox.getSelectedItem() != null)
		{
			mc.setCurrentUnit((Unit)unitBox.getSelectedItem(), unitBox.getSelectedIndex());
		}

		// MouseListener for your list of forces.  Double click to redeploy to current battle.
		MouseListener mouseListener = new MouseAdapter() {
     		public void mouseClicked(MouseEvent e) {
  		  		if (e.getClickCount() > 1)
				{
             				int index = forceList.locationToIndex(e.getPoint());
             				//System.out.println("Doubleclicked on Item " + index);
					SpaceForce force = (SpaceForce) forceList.getSelectedValue();

					Unit u = (Unit) unitBox.getSelectedItem();
					Battle b = (Battle) battleBox.getSelectedItem();

					int distant = map.distance(b.getLocation(), u.getLocation());

					// Can't redeploy to a battle if you're already part of it.
					if (distant > 0)
					{

						// Can only redeploy if the force has enough movement left.
						if (force.getCurrentMove() >= distant)
						{
							force.setMove(force.getCurrentMove() - distant);

							// Now we add the force to the first unit in the battle.

							// We find our combatant c.
							Combatant c = null;

							for (int i = 0; i < b.getCombatants().size(); i++)
							{
								c = (Combatant) b.getCombatants().elementAt(i);

								if (c.getName().equals(player.getName()))
								{
									i = b.getCombatants().size();
								}
							}

							Unit adding = (Unit) c.getUnits().elementAt(0);

							for (int i = 0; i < player.getEmpire().getSpaceUnits().size(); i++)
							{
								Unit spaceU = (Unit) player.getEmpire().getSpaceUnits().elementAt(i);
								// Found unit so add the force.
								if (spaceU.getName().equals(adding.getName()))
								{
									spaceU.addForce(force);
									i = player.getEmpire().getSpaceUnits().size();
								}
							}

							adding.addForce(force);

							// We move the location of any stored ground units;

							for (int i = 0; i < force.getStorage().size(); i++)
							{
								Unit ground = (Unit) force.getStorage().elementAt(i);
								ground.setLocation(adding.getLocation());
							}

							u.getForces().removeElementAt(index);
							u.calculateMinMove();

							forceList.setListData(u.getForces());

							// Refresh the textarea.

							textBattle.setText("");

							for (int i = 0; i < b.getCombatants().size(); i++)
							{
								Combatant c2 = (Combatant) b.getCombatants().elementAt(i);

								textBattle.setText(textBattle.getText() + c2.display());
							}

							textBattle.setCaretPosition(0);

							Battle tempBattle = findBattle(u, totalBattles);

							if (tempBattle != null)
							{
								battleHere.setText("This unit is in a battle!");
								battleHere.setForeground(color.RED);

								textBattleHere.setText("");

								for (int i = 0; i < tempBattle.getCombatants().size(); i++)
								{
									Combatant c2 = (Combatant) tempBattle.getCombatants().elementAt(i);
									if (c2.getName().equals(player.getName()))
									{
										for (int z = 0; z < c2.getUnits().size(); z++)
										{
											Unit un2 = (Unit) c2.getUnits().elementAt(z);
											if (un2.getName().equals(u.getName()))
											{
												System.out.println("Setting unit!");
												c2.getUnits().setElementAt(u, z);
											}
										}
									}

									textBattleHere.setText(textBattleHere.getText() + c2.display());
								}

								textBattleHere.setCaretPosition(0);

							}
							else
							{
								battleHere.setText("No battle at this unit's location.");
								battleHere.setForeground(color.BLACK);

								textBattleHere.setText("");
							}

						}
						else
						{
							JOptionPane.showMessageDialog(frame, "This force is too far away to reach this battle!","Redeploy Error!", JOptionPane.ERROR_MESSAGE);
						}
					}
					else
					{
						JOptionPane.showMessageDialog(frame, "This force is already a part of this battle!","Redeploy Error!", JOptionPane.ERROR_MESSAGE);
					}

					forceList.repaint();
					mc.repaint();
       				}
			}};
		forceList.addMouseListener(mouseListener);


		//to.setPreferredSize(new Dimension(200, 300));

		frame.getContentPane().add(to, gbc);


		// Done and Undo buttons.

		gbc.gridx = 0;
		gbc.gridy = gbc.gridy + 1;
	       	gbc.gridwidth = 4;
		gbc.fill = GridBagConstraints.HORIZONTAL;

		JLabel instructionLabel = new JLabel("Double click on a force to add them to the selected battle!", 0);
		instructionLabel.setFont(new Font("Dialog", 1, 14));
		instructionLabel.setForeground(color.RED);
		frame.getContentPane().add(instructionLabel, gbc);

		gbc.gridy = gbc.gridy + 1;
		gbc.gridwidth = 2;

		JButton done = new JButton("Done");
		done.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){

			int finished = JOptionPane.showConfirmDialog(frame, "Confirm defensive redeploy instructions?", "Defensive Redeploy Confirm", JOptionPane.YES_NO_OPTION);
			if (finished == 0)
			{
				confirmed = true;
				frame.dispose();
			}
			}});

		frame.getContentPane().add(done, gbc);

		gbc.gridx = 2;

		JButton undo = new JButton("Undo");
		undo.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){

			int finished = JOptionPane.showConfirmDialog(frame, "Undo all defensive redeploy instructions?", "Undo Defensive Redeploy", JOptionPane.YES_NO_OPTION);
			if (finished == 0)
			{
				confirmed = false;
				frame.dispose();
			}
			}});

		frame.getContentPane().add(undo, gbc);

		frame.pack();
		frame.show();

		Vector battling = psi.getSpaceBattles(name);

		for (int i = 0; i < battling.size(); i++)
		{
			Battle b = (Battle) battling.elementAt(i);
			mc.addBattle(b);

		}

		JFrame paxMap = new JFrame();
		paxMap.setResizable(false);
		paxMap.setTitle("Pax Galaktika Map");
		paxMap.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints gbcNew = new GridBagConstraints();

		gbcNew.gridx = 0;
		gbcNew.gridy = 0;
		gbcNew.gridwidth = 6;
		gbcNew.gridheight = 10;

		paxMap.getContentPane().add(mc, gbcNew);

		paxMap.pack();
		paxMap.show();

		int timer = 0;

		// Wait to proceed until all redeploying is done.
		while (frame.isVisible())
		{
			try
			{
				Thread.sleep(100);
				timer++;
				mc.setTimer((float)(Math.abs(Math.sin(timer*0.25))));
				mc.repaint();
			}
			catch (Exception e)
			{
				System.out.println("Can't flash button!");
			}
		}

		paxMap.dispose();

		return confirmed;
	}


	// This method selects an appropriate adjective to describe a battle.
	public String getAdjective(Battle b)
	{
		String result = "small";

		int totalDamage = 0;

		for (int i = 0; i < b.getCombatants().size(); i++)
		{
			Combatant c = (Combatant) b.getCombatants().elementAt(i);

			totalDamage += c.getTotalDamage();
		}

		result = "pathetic";

		if (totalDamage > 40)
		{
			result = "mediocre";
		}
		if (totalDamage > 70)
		{
			result = "vigorous";
		}
		if (totalDamage > 100)
		{
			result = "large";
		}
		if (totalDamage > 130)
		{
			result = "massive";
		}
		if (totalDamage > 160)
		{
			result = "titanic";
		}

		return result;
	}

	// Finds if a unit is in a battle.

	public Battle findBattle(Unit u, Vector battles)
	{
		Battle result = null;

		Location l = u.getLocation();

		for (int i = 0; i < battles.size(); i++)
		{
			Battle b = (Battle) battles.elementAt(i);

			Location l2 = b.getLocation();

			if (l.getPositionX() == l2.getPositionX() && l.getPositionY() == l2.getPositionY())
			{
				result = b;
				i = battles.size();
			}
		}

		return result;
	}


}
