import java.rmi.*;
import java.util.*;

// Name: Jeremy Long
// Student Number: 587 702
// NSID: jsl847
// CMPT436, Project

public interface PaxServerInterface extends Remote
{
	// Connection methods.
	public boolean isFull() throws RemoteException;
	public float getVersion() throws RemoteException;
	public boolean connect(String name, String hostName) throws RemoteException;
	public boolean reload(String name, String hostName) throws RemoteException;

	public Vector getEmpires() throws RemoteException;
	public void removeNeutralPlanet(String name) throws RemoteException;
	public boolean chooseEmpire(String name, String race, String empName) throws RemoteException;

	// Turn methods.
	public boolean ready(int phase, int turn) throws RemoteException;
	public boolean isReady(String name) throws RemoteException;
	public void donePhase(String name, int phase, int turn, Player player) throws RemoteException;
	public boolean gameOver() throws RemoteException;

	public Map getMap() throws RemoteException;

	// Espionage and message methods.
	public void sendMessages(Vector messages) throws RemoteException;
	public Vector getMessages(String name) throws RemoteException;
	public void ecoBomb(Planet planet, int damage) throws RemoteException;
	public int stealMoney(Planet planet, int damage, String recipient) throws RemoteException;
	public void industryBomb(Planet planet, int damage) throws RemoteException;
	public void techSteal(String name, int newTech) throws RemoteException;
	public void useEspionage(String name, int amount) throws RemoteException;

	public void acceptOperations(Vector operations) throws RemoteException;

	public Vector getSpaceForces() throws RemoteException;
	public Vector getGroundForces() throws RemoteException;

	// Battle methods.
	public Vector getSpaceBattles(String player) throws RemoteException;
	public Vector getGroundBattles(String player) throws RemoteException;
	public Vector getNeutralSpaceBattles(String player) throws RemoteException;
	public Vector getNeutralGroundBattles(String player) throws RemoteException;
	public boolean isDuplicated(Vector battles, Battle b) throws RemoteException;
	public void dealDamage(Battle b) throws RemoteException;
	public void setReadyForBattle(String name, Location location, boolean shooting, Combatant newC) throws RemoteException;
	public Battle findBattle(Location l) throws RemoteException;
	public boolean isReadyForBattle(Location l) throws RemoteException;
	public void doneBattle(Location l, boolean space) throws RemoteException;

	// Defensive redeploy methods.
	public boolean checkDeploy() throws RemoteException;
	public void doneDeploy(String name, Player player) throws RemoteException;
	public boolean isDoneDeploy(String name) throws RemoteException;

	public void checkPlanets(String name, Vector planets) throws RemoteException;
	public void removePlayer(String name) throws RemoteException;
	public void dropPlayer(String name) throws RemoteException;

	// Market Phase methods.
	public Vector getOffers() throws RemoteException;
	public Player getPlayer(String name) throws RemoteException;
	public void addOffer(String name, Offer offer) throws RemoteException;
	public void withdrawOffer(String name, String id) throws RemoteException;
	public void acceptOffer(String name, String id) throws RemoteException;
	public void rejectOffer(String name, String id) throws RemoteException;

	public int[] getProgress() throws RemoteException;
	public Vector getPlayers() throws RemoteException;



}
