import java.io.*;
import java.util.*;

//The unchecked warnings come from any method which takes any Vector
@SuppressWarnings("unchecked")

class PlayerImprovementData
{
	public int money;
	public int tech;
	public int espionage;

	public Vector<Integer> economies;
	public Vector<Integer> industries;

	// Create a PlayerImprovementData based on a player that has been passed in.
	public PlayerImprovementData(Player player)
	{
		money = player.getEmpire().getMoney();
		tech = player.getEmpire().getTech();
		espionage = player.getEmpire().getEspionage();

		economies = new Vector<Integer>();
		industries = new Vector<Integer>();

		for (int i = 0; i < player.getEmpire().getPlanets().size(); i++)
		{
			economies.addElement(new Integer(((Planet)player.getEmpire().getPlanets().elementAt(i)).getEconomy()));
			industries.addElement(new Integer(((Planet)player.getEmpire().getPlanets().elementAt(i)).getIndustry()));
		}
	}

	public PlayerImprovementData()
	{
		economies = new Vector<Integer>();
		industries = new Vector<Integer>();
	}

	public PlayerImprovementData clone()
	{
		PlayerImprovementData clone = new PlayerImprovementData();

		clone.money = this.money;
		clone.tech = this.tech;
		clone.espionage = this.espionage;

		for (int i = 0; i < economies.size(); i++)
		{
			clone.economies.addElement(this.economies.elementAt(i));
			clone.industries.addElement(this.industries.elementAt(i));
		}

		return clone;
	}

	// Sets up a player that is passed in so it reflects the PlayerImprovementData.
	public void playerImprovementDataToPlayer(Player player)
	{
		player.getEmpire().setTech(this.tech);
		player.getEmpire().setEspionage(this.espionage);
		player.getEmpire().setMoney(this.money);


		for (int i = 0; i < this.economies.size(); i++)
		{
			((Planet)player.getEmpire().getPlanets().elementAt(i)).setEconomy(this.economies.elementAt(i));
			((Planet)player.getEmpire().getPlanets().elementAt(i)).setIndustry(this.industries.elementAt(i));
			((Planet)player.getEmpire().getPlanets().elementAt(i)).setCurrentIndustry(this.industries.elementAt(i));
		}
	}

}