import java.rmi.*;
import java.io.*;
import java.net.*;

import java.rmi.RMISecurityManager;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;


// Name: Jeremy Long
// Student Number: 587 702
// NSID: jsl847
// CMPT436, Project

public class Server
{

	final static float version = 2.01f;

    // The constructor is where execution of the server begins.  It basically serves only to set up RMI, including
	// setting the security manager and binding the PaxServer object.
	public static void main(String[] args)
	{

		System.setSecurityManager(new RMISecurityManager());
		String name = "//localhost/";

		System.setProperty("java.rmi.server.hostname","24.108.201.87");

		try
		{

		    System.out.println("Pax Server, Version " + version);
		    System.out.println("Please enter your router's IP address.");

   		    BufferedReader kb = new BufferedReader(new InputStreamReader(System.in));

		    String ip = kb.readLine();

		    System.setProperty("java.rmi.server.hostname", ip.trim());

		    System.out.println("Please enter the number of people playing this game.");
		    System.out.println("--Enter -1 players to load the last AutoSave.--");

		    int totalPlayers = Integer.parseInt(kb.readLine());

		    if (totalPlayers > 12)
		    {
				totalPlayers = 12;
		    }

		    System.out.println("Starting a game with " + totalPlayers + " players!");

//start rmiregistry 1099

		//	LocateRegistry.createRegistry(1099);
	 	//	Registry registry=LocateRegistry.getRegistry(); // grabs 1099 by default;


		    PaxServer ps = new PaxServer(totalPlayers, version);

		    Naming.rebind(name + "PaxServer", ps);
		//	registry.rebind(name + "PaxServer", ps);


		    System.out.println("Running at //" + System.getProperty("java.rmi.server.hostname") + "/PaxServer");

		}
		catch (Exception e)
		{
			System.out.println("Problem starting the server!");
			e.printStackTrace();
		}


	}

}

