import java.util.*;
import java.io.*;

public class SpaceForce extends Force implements Serializable
{

	private int storageCapacity;
	private Vector storage;

   	public SpaceForce(String nam, String exclusiv, int minAttac, int maxAttac, int armo, int foo, int ga, int mineral, int maintenanc, int industr, int tec, int mov, int storageCapacit, boolean mobil)
	{
		name = nam;
		exclusive = exclusiv;

		minAttack = minAttac;
		maxAttack = maxAttac;
		armor = armo;
		currentArmor = armo;

		food = foo;
		gas = ga;
		minerals = mineral;
		maintenance = maintenanc;
		industry =industr;
		tech = tec;

		move = mov;
		currentMove = move;
		mobile = mobil;
		storageCapacity = storageCapacit;
		storage = new Vector();
	}

	public String toString()
	{
		if (committed)
		{
			return name + "\t   Move: " + currentMove+"/"+move + "\t    Free Storage: "+getStorageCapability()+"/" + storageCapacity;
		}
		// Uncommitted
		else
		{
			return name + "\t   UNCOMMITTED \t   Free Storage: "+getStorageCapability()+"/" + storageCapacity;
		}

	}


	public String getInfo()
	{
		String result = "<html><I>"+name+"</I> - ";

		result += "Move " + currentMove+"/"+move;

		if (storageCapacity > 0)
		{
			result += ", Trans: " + (storageCapacity-getStorageCapability())+"/"+storageCapacity;
		}

		result += " (<FONT COLOR=red>" + minAttack + "-"+maxAttack+"</FONT COLOR>, ";

		result += "<FONT COLOR=green>" + armor + "</FONT COLOR>)";

		result += "</html>";

		return result;
	}

	public String getBattleInfo()
	{
		String result = "<html><I>"+name+"</I> - ";

		if (!committed)
		{
			result += "<B>UNCOMMITTED</B> ";
		}

		if (storageCapacity > 0)
		{
			result += "Trans: " + (storageCapacity-getStorageCapability())+"/"+storageCapacity;
		}

		result += " (<FONT COLOR=red>" + minAttack + "-"+maxAttack+"</FONT COLOR>, ";

		result += "<FONT COLOR=green>" + currentArmor + "/" + armor + "</FONT COLOR>)";

		result += "</html>";

		return result;
	}

	public String getDescription()
	{
		String result = name;
		while (result.length() < 12)
		{
			result = result + " ";
		}
		result += "  " + industry;
		while (result.length() < 16)
		{
			result = result + " ";
		}
		result += " " + food + "F/"+minerals+"M/"+gas+"G";
		while (result.length() < 27)
		{
			result = result + " ";
		}
		result += tech;
		while (result.length() < 32)
		{
			result = result + " ";
		}
		result += maintenance;
			while (result.length() < 36)
		{
			result = result + " ";
		}
		result += minAttack+"-"+maxAttack;
		while (result.length() < 41)
		{
			result = result + " ";
		}
		result += " " +armor;
		while (result.length() < 50)
		{
			result = result + " ";
		}

		result += move;
		while (result.length() < 55)
		{
			result = result + " ";
		}
		result += storageCapacity;

		return result;
	}

	public int getStorageCapability()
	{
	    int result = storageCapacity;
		for (int i = 0; i < storage.size(); i++)
		{
			Unit u = (Unit) storage.elementAt(i);
			result -= u.getForces().size();
		}
		return result;
	}

	public Vector getStorage()
	{
		return storage;
	}

	public void setStorage(Vector stor)
	{
		storage = stor;
	}

	public int getStorageCapacity()
	{
		return storageCapacity;
	}

}
