import java.util.*;
import java.io.*;

public class TechnologyOperation extends Operation implements Cloneable, Serializable
{

	public TechnologyOperation(Player playe, Player targetPlaye, Planet targetPlane)
	{
		player = playe;
		targetPlayer = targetPlaye;
		targetPlanet = targetPlane;

		name = "Technology Theft";
		cost = 8;
		defensive = false;
		type = 4;
	}

	// Determine if operation succeeds or fails, make any changes to the map that are required.
	// Operations will always be performed sequentially, NOT CONCURRENTLY.
	// Adds messages as necessary to indicate the success of the operation.

	public void performOperation(Map currentMap, Vector messages, Vector defensiveOperations, Vector<PaxGenericAI> aiPlayers)
	{
		Random r = new Random();
		r.nextInt(100);

		// indicates whether to report operation to the target based on defensive op.
		boolean report = CheckReport(defensiveOperations);
		// check the success of the operation
		boolean success = CheckSuccess(defensiveOperations);

		int effect = 5; // the numerical effect of the operation.


		if (success)
		{
			StringBuffer results = new StringBuffer("");

			Player p1 = null;
			Player p2 = null;

			for (int i = 0; i < currentMap.getPlayers().size(); i++)
			{
				p1 = (Player) currentMap.getPlayers().elementAt(i);

				if (p1.getName().equals(targetPlayer.getName()))
				{
					i = currentMap.getPlayers().size();
				}
			}


			for (int i = 0; i < currentMap.getPlayers().size(); i++)
			{
				p2 = (Player) currentMap.getPlayers().elementAt(i);

				if (p2.getName().equals(player.getName()))
				{
					i = currentMap.getPlayers().size();
				}
			}


			if (p1.getEmpire().getTech() - p2.getEmpire().getTech() < effect)
			{
				effect = p1.getEmpire().getTech() - p2.getEmpire().getTech();
			}

			if (effect < 0)
			{
				effect = 0;
			}


			for (int i = 0; i < currentMap.getPlayers().size(); i++)
			{
				Player p = (Player) currentMap.getPlayers().elementAt(i);

				if (p.getName().equals(player.getName()))
				{
					p.getEmpire().setTech(p.getEmpire().getTech() + effect);
				}
			}

			if (effect > 0)
			{
				results.append("Your spies have infiltrated " + targetPlanet + ", a planet belonging to " + targetPlayer.getName() + ", and stolen some of their amazing technology, increasing your tech by " + effect + ".  The enemy's current technology level is " + targetPlayer.getEmpire().getTech() + "!\n\n");
			}
			else
			{
				results.append("Your spies have infiltrated " + targetPlanet + ", a planet belonging to " + targetPlayer.getName() + ", but there is nothing for them to learn from the enemy's primitive technology level of " + targetPlayer.getEmpire().getTech() + "!\n\n");
			}

			Message message = new Message(results.toString(), false);
			message.addPlayer(player.getName());

			messages.addElement(message);

			// Update the AI's intelligence information.
			for (int i = 0; i < aiPlayers.size(); i++)
			{
				PaxGenericAI aiPlayer = aiPlayers.elementAt(i);

				if (aiPlayer.player.getName().equals(player.getName()))
				{
					aiPlayer.intelligenceFile.updateEmpire(targetPlayer.getEmpire());
					break;
				}
			}

			if (report)
			{
				StringBuffer results2 = new StringBuffer("");

				results2.append(player.getName() + "'s spies have infiltrated " + targetPlanet + " and stolen some of your precious technology!\n\n");

				Message message2 = new Message(results2.toString(), false);
				message2.addPlayer(targetPlayer.getName());

				messages.addElement(message2);

				// Update the AI's aggression level.
				for (int i = 0; i < aiPlayers.size(); i++)
				{
					PaxGenericAI aiPlayer = aiPlayers.elementAt(i);

					if (aiPlayer.player.getName().equals(targetPlayer.getName()))
					{
						aiPlayer.intelligenceFile.updateAggression(player.getName(), 0.4);
						break;
					}
				}
			}
		}
		else
		{
			FailureMessage(messages, report, aiPlayers);
		}
	}

}
